/*! grafana - v2.5.0 - 2015-10-28
 * Copyright (c) 2015 Torkel Ödegaard; Licensed Apache-2.0 */

define("app/components/partials",["angular"],function(a){a.module("grafana").run(["$templateCache",function(a){"use strict";a.put("app/features/admin/partials/edit_org.html",'<topnav icon="fa fa-fw fa-user" title="Global Users" subnav="true">\n	<ul class="nav">\n		<li><a href="admin/orgs">List</a></li>\n		<li class="active"><a href="admin/orgs/edit/{{org.id}}">Edit Org</a></li>\n	</ul>\n</topnav>\n\n<div class="page-container">\n	<div class="page">\n		<h2>\n			Organization Details\n		</h2>\n\n		<form name="orgDetailsForm">\n			<div>\n				<div class="tight-form">\n					<ul class="tight-form-list">\n						<li class="tight-form-item" style="width: 100px">\n							Name\n						</li>\n						<li>\n							<input type="text" required ng-model="org.name" class="input-xxlarge tight-form-input last" >\n						</li>\n					</ul>\n					<div class="clearfix"></div>\n				</div>\n			</div>\n\n			<br>\n			<button type="submit" class="pull-right btn btn-success" ng-click="update()" ng-show="!createMode">Update</button>\n		</form>\n\n		<h3>\n			Organization Users\n		</h3>\n\n		<table class="grafana-options-table form-inline">\n			<tr>\n				<th>Username</th>\n				<th>Email</th>\n				<th>Role</th>\n				<th></th>\n			</tr>\n			<tr ng-repeat="orgUser in orgUsers">\n				<td>{{orgUser.login}}</td>\n				<td>{{orgUser.email}}</td>\n				<td>\n					<select type="text" ng-model="orgUser.role" class="input-small" ng-options="f for f in [\'Viewer\', \'Editor\', \'Read Only Editor\', \'Admin\']" ng-change="updateOrgUser(orgUser)">\n					</select>\n				</td>\n				<td style="width: 1%">\n					<a ng-click="removeOrgUser(orgUser)" class="btn btn-danger btn-mini">\n						<i class="fa fa-remove"></i>\n					</a>\n				</td>\n			</tr>\n		</table>\n\n	</div>\n</div>\n'),a.put("app/features/admin/partials/edit_user.html",'<topnav icon="fa fa-fw fa-user" title="Global Users" subnav="true">\n	<ul class="nav">\n		<li><a href="admin/users">Users</a></li>\n		<li><a href="admin/users/create">Create user</a></li>\n		<li class="active"><a href="admin/users/edit/{{user_id}}">Edit user</a></li>\n	</ul>\n</topnav>\n\n<div class="page-container">\n	<div class="page">\n		<h2>\n			Edit User\n		</h2>\n\n		<form name="userForm">\n			<div>\n				<div class="tight-form">\n					<ul class="tight-form-list">\n						<li class="tight-form-item" style="width: 100px">\n							Name\n						</li>\n						<li>\n							<input type="text" required ng-model="user.name" class="input-xxlarge tight-form-input last" >\n						</li>\n					</ul>\n					<div class="clearfix"></div>\n				</div>\n				<div class="tight-form">\n					<ul class="tight-form-list">\n						<li class="tight-form-item" style="width: 100px">\n							Email\n						</li>\n						<li>\n							<input type="email" ng-model="user.email" class="input-xxlarge tight-form-input last" >\n						</li>\n					</ul>\n					<div class="clearfix"></div>\n				</div>\n				<div class="tight-form">\n					<ul class="tight-form-list">\n						<li class="tight-form-item" style="width: 100px">\n							Username\n						</li>\n						<li>\n							<input type="text" ng-model="user.login" class="input-xxlarge tight-form-input last" >\n						</li>\n					</ul>\n					<div class="clearfix"></div>\n				</div>\n			</div>\n\n			<br>\n			<button type="submit" class="pull-right btn btn-success" ng-click="update()" ng-show="!createMode">Update</button>\n		</form>\n\n		<h3>\n			Change password\n		</h3>\n\n		<form name="passwordForm">\n			<div>\n				<div class="tight-form">\n					<ul class="tight-form-list">\n						<li class="tight-form-item" style="width: 100px">\n							New password\n						</li>\n						<li>\n							<input type="password" required ng-minlength="4" ng-model="password" class="input-xxlarge tight-form-input last">\n						</li>\n					</ul>\n					<div class="clearfix"></div>\n				</div>\n			</div>\n\n			<br>\n			<button type="submit" class="pull-right btn btn-success" ng-click="setPassword()">Update</button>\n		</form>\n\n		<h3>\n			Permissions\n		</h3>\n\n		<div>\n			<div class="tight-form last">\n				<ul class="tight-form-list">\n					<li class="tight-form-item last">\n						Grafana Admin&nbsp;\n						<input class="cr1" id="permissions.isGrafanaAdmin" type="checkbox"\n						ng-model="permissions.isGrafanaAdmin" ng-checked="permissions.isGrafanaAdmin">\n						<label for="permissions.isGrafanaAdmin" class="cr1"></label>\n					</li>\n				</ul>\n				<div class="clearfix"></div>\n			</div>\n			<br>\n			<button type="submit" class="pull-right btn btn-success" ng-click="updatePermissions()">Update</button>\n			<br>\n		</div>\n\n		<h3>\n			Organizations\n		</h3>\n\n		<form name="addOrgForm">\n			<div class="tight-form">\n				<ul class="tight-form-list">\n					<li class="tight-form-item" style="width: 160px">\n						Add organization\n					</li>\n					<li>\n						<input type="text" ng-model="newOrg.name" bs-typeahead="searchOrgs"\n									required class="input-xlarge tight-form-input" placeholder="organization name">\n					</li>\n					<li class="tight-form-item">\n						Role\n					</li>\n					<li>\n						<select type="text" ng-model="newOrg.role" class="input-small tight-form-input" ng-options="f for f in [\'Viewer\', \'Editor\', \'Read Only Editor\', \'Admin\']">\n						</select>\n					</li>\n					<li>\n						<button class="btn btn-success tight-form-btn" ng-click="addOrgUser()">Add</button>\n					</li>\n					<div class="clearfix"></div>\n				</ul>\n			</div>\n		</form>\n\n		<table class="grafana-options-table form-inline">\n			<tr>\n				<th>Name</th>\n				<th>Role</th>\n				<th></th>\n			</tr>\n			<tr ng-repeat="org in orgs">\n				<td>\n					{{org.name}} <span class="label label-info" ng-show="org.orgId === user.orgId">Current</span>\n				</td>\n				<td>\n					<select type="text" ng-model="org.role" class="input-small" ng-options="f for f in [\'Viewer\', \'Editor\', \'Read Only Editor\', \'Admin\']" ng-change="updateOrgUser(org)">\n					</select>\n				</td>\n				<td style="width: 1%">\n					<a ng-click="removeOrgUser(org)" class="btn btn-danger btn-mini">\n						<i class="fa fa-remove"></i>\n					</a>\n				</td>\n			</tr>\n		</table>\n\n	</div>\n</div>\n'),a.put("app/features/admin/partials/new_user.html",'<topnav icon="fa fa-fw fa-cogs" title="Global Users" subnav="true">\n	<ul class="nav">\n		<li><a href="admin/users">Users</a></li>\n		<li class="active"><a href="admin/users/create">Create user</a></li>\n	</ul>\n</topnav>\n\n<div class="page-container">\n	<div class="page">\n		<h2>\n			Create a new user\n		</h2>\n\n		<form name="userForm">\n			<div>\n				<div class="tight-form">\n					<ul class="tight-form-list">\n						<li class="tight-form-item" style="width: 100px">\n							<strong>Name</strong>\n						</li>\n						<li>\n							<input type="text" required ng-model="user.name" class="input-xxlarge tight-form-input last" >\n						</li>\n					</ul>\n					<div class="clearfix"></div>\n				</div>\n				<div class="tight-form">\n					<ul class="tight-form-list">\n						<li class="tight-form-item" style="width: 100px">\n							<strong>Email</strong>\n						</li>\n						<li>\n							<input type="email" ng-model="user.email" class="input-xxlarge tight-form-input last" >\n						</li>\n					</ul>\n					<div class="clearfix"></div>\n				</div>\n				<div class="tight-form">\n					<ul class="tight-form-list">\n						<li class="tight-form-item" style="width: 100px">\n							<strong>Username</strong>\n						</li>\n						<li>\n							<input type="text" ng-model="user.login" class="input-xxlarge tight-form-input last" >\n						</li>\n					</ul>\n					<div class="clearfix"></div>\n				</div>\n				<div class="tight-form">\n					<ul class="tight-form-list">\n						<li class="tight-form-item" style="width: 100px">\n							<strong>Password</strong>\n						</li>\n						<li>\n							<input type="password" required ng-model="user.password" class="input-xxlarge tight-form-input last" >\n						</li>\n					</ul>\n					<div class="clearfix"></div>\n				</div>\n			</div>\n\n			<br>\n			<button type="submit" class="pull-right btn btn-success" ng-click="create()">Create</button>\n		</form>\n	</div>\n</div>\n'),a.put("app/features/admin/partials/orgs.html",'<topnav icon="fa fa-fw fa-users" title="Global Orgs" subnav="true">\n	<ul class="nav">\n		<li class="active"><a href="admin/orgs">List</a></li>\n	</ul>\n</topnav>\n\n<div class="page-container">\n	<div class="page">\n		<h2>\n			Organizations\n		</h2>\n\n		<table class="grafana-options-table">\n			<tr>\n				<th style="text-align:left">Id</th>\n				<th>Name</th>\n				<th></th>\n			</tr>\n			<tr ng-repeat="org in orgs">\n				<td>{{org.name}}</td>\n				<td style="width: 1%">\n					<a href="admin/orgs/edit/{{org.id}}" class="btn btn-inverse btn-small">\n						<i class="fa fa-edit"></i>\n						Edit\n					</a>\n					&nbsp;&nbsp;\n					<a ng-click="deleteOrg(org)" class="btn btn-danger btn-small">\n						<i class="fa fa-remove"></i>\n					</a>\n				</td>\n			</tr>\n		</table>\n\n	</div>\n</div>\n'),a.put("app/features/admin/partials/settings.html",'<topnav icon="fa fa-fw fa-info" title="System info">\n</topnav>\n\n<div class="page-container">\n	<div class="page">\n		<h2>\n			System information\n		</h2>\n\n		<div class="grafana-info-box span8" style="margin: 20px 0 25px 0">\n			These system settings are defined in grafana.ini or grafana.custom.ini (or overriden in ENV variables).\n			To change these you currently need to restart grafana.\n		</div>\n\n		<table class="grafana-options-table">\n			<tr ng-repeat-start="(secName, secValue) in settings">\n				<td class="admin-settings-section">{{secName}}</td>\n				<td></td>\n			</tr>\n			<tr ng-repeat="(keyName, keyValue) in secValue" ng-repeat-end>\n				<td style="padding-left: 25px;">{{keyName}}</td>\n				<td>{{keyValue}}</td>\n			</tr>\n		</table>\n	</div>\n</div>\n\n\n\n'),a.put("app/features/admin/partials/users.html",'<topnav icon="fa fa-fw fa-user" title="Global Users" subnav="true">\n	<ul class="nav">\n		<li class="active"><a href="admin/users">List</a></li>\n		<li><a href="admin/users/create">Create user</a></li>\n	</ul>\n</topnav>\n\n<div class="page-container">\n	<div class="page">\n		<h2>\n			Users\n		</h2>\n\n		<table class="grafana-options-table">\n			<tr>\n				<th style="text-align:left">Id</th>\n				<th>Name</th>\n				<th>Login</th>\n				<th>Email</th>\n				<th style="white-space: nowrap">Grafana Admin</th>\n				<th></th>\n			</tr>\n			<tr ng-repeat="user in users">\n				<td>{{user.id}}</td>\n				<td>{{user.name}}</td>\n				<td>{{user.login}}</td>\n				<td>{{user.email}}</td>\n				<td>{{user.isAdmin}}</td>\n				<td style="width: 1%">\n					<a href="admin/users/edit/{{user.id}}" class="btn btn-inverse btn-small">\n						<i class="fa fa-edit"></i>\n						Edit\n					</a>\n					&nbsp;&nbsp;\n					<a ng-click="deleteUser(user)" class="btn btn-danger btn-small">\n						<i class="fa fa-remove"></i>\n					</a>\n				</td>\n			</tr>\n		</table>\n	</div>\n</div>\n'),a.put("app/features/annotations/partials/editor.html",'<div ng-controller="AnnotationsEditorCtrl" ng-init="init()">\n\n	<div class="gf-box-header">\n		<div class="gf-box-title">\n			<i class="fa fa-bolt"></i>\n			Annotations\n		</div>\n\n		<div class="tabs">\n			<ul class="nav nav-tabs">\n				<li ng-class="{active: mode === \'list\'}">\n					<a ng-click="mode = \'list\';">\n						List\n					</a>\n				</li>\n\n				<li ng-class="{active: mode === \'edit\'}" ng-show="mode === \'edit\'">\n					<a>\n						{{currentAnnotation.name}}\n					</a>\n				</li>\n\n				<li ng-class="{active: mode === \'new\'}">\n					<a ng-click="mode = \'new\';">\n						<i class="fa fa-plus"></i>\n						New\n					</a>\n				</li>\n			</ul>\n		</div>\n\n		<button class="gf-box-header-close-btn" ng-click="dismiss();">\n			<i class="fa fa-remove"></i>\n		</button>\n	</div>\n\n	<div class="gf-box-body">\n\n		<div class="editor-row row" ng-if="mode === \'list\'">\n			<div class="span6">\n				<div ng-if="annotations.length === 0">\n					<em>No annotations defined</em>\n				</div>\n				<table class="grafana-options-table">\n					<tr ng-repeat="annotation in annotations">\n						<td style="width:90%">\n							<i class="fa fa-bolt"></i> &nbsp;\n							{{annotation.name}}\n						</td>\n						<td style="width: 1%"><i ng-click="_.move(annotations,$index,$index-1)" ng-hide="$first" class="pointer fa fa-arrow-up"></i></td>\n						<td style="width: 1%"><i ng-click="_.move(annotations,$index,$index+1)" ng-hide="$last" class="pointer fa fa-arrow-down"></i></td>\n\n						<td style="width: 1%" class="nobg">\n							<a ng-click="edit(annotation)" class="btn btn-inverse btn-mini">\n								<i class="fa fa-edit"></i>\n								Edit\n							</a>\n						</td>\n						<td style="width: 1%" class="nobg">\n							<a ng-click="removeAnnotation(annotation)" class="btn btn-danger btn-mini">\n								<i class="fa fa-remove"></i>\n							</a>\n						</td>\n					</tr>\n				</table>\n			</div>\n		</div>\n\n		<div ng-if="mode === \'edit\' || mode === \'new\'">\n			<div class="editor-row">\n				<div class="editor-option">\n					<label class="small">Name</label>\n					<input type="text" class="input-medium" ng-model=\'currentAnnotation.name\' placeholder="name"></input>\n				</div>\n				<div class="editor-option">\n					<label class="small">Datasource</label>\n					<select ng-model="currentAnnotation.datasource" ng-options="f.name as f.name for f in datasources" ng-change="datasourceChanged()"></select>\n				</div>\n				<div class="editor-option text-center">\n					<label class="small">Icon color</label>\n					<spectrum-picker ng-model="currentAnnotation.iconColor"></spectrum-picker>\n				</div>\n				<div class="editor-option">\n					<label class="small">Icon size</label>\n					<select class="input-mini" ng-model="currentAnnotation.iconSize" ng-options="f for f in [7,8,9,10,13,15,17,20,25,30]"></select>\n				</div>\n				<editor-opt-bool text="Grid line" model="currentAnnotation.showLine"></editor-opt-bool>\n				<div class="editor-option text-center">\n					<label class="small">Line color</label>\n					<spectrum-picker ng-model="currentAnnotation.lineColor"></spectrum-picker>\n				</div>\n			</div>\n\n			<datasource-editor-view datasource="currentAnnotation.datasource" name="annotations-query-editor"></datasource-editor-view>\n\n			<br>\n			<button ng-show="mode === \'new\'" type="button" class="btn btn-success" ng-click="add()">Add</button>\n			<button ng-show="mode === \'edit\'" type="button" class="btn btn-success pull-left" ng-click="update();">Update</button>\n			<br>\n			<br>\n		</div>\n	</div>\n</div>\n'),a.put("app/features/dashboard/partials/dashboardTopNav.html",'<div class="navbar navbar-static-top" ng-controller=\'DashboardNavCtrl\' ng-init="init()">\n	<div class="navbar-inner">\n		<div class="container-fluid">\n\n			<div class="top-nav">\n				<a class="pointer top-nav-menu-btn" ng-if="!contextSrv.sidemenu" ng-click="contextSrv.toggleSideMenu()">\n					<img class="logo-icon" src="img/fav32.png"></img>\n					<i class="fa fa-bars"></i>\n				</a>\n\n				<div class="top-nav-dashboards-btn">\n					<a class="pointer" ng-click="openSearch()">\n						<i class="fa fa-th-large"></i>\n						<span class="dashboard-title">{{dashboard.title}}</span>\n						<i class="fa fa-caret-down"></i>\n					</a>\n				</div>\n			</div>\n\n			<ul class="nav pull-left top-nav-dash-actions">\n				<li ng-show="dashboardMeta.canStar">\n					<a class="pointer" ng-click="starDashboard()">\n						<i class="fa" ng-class="{\'fa-star-o\': !dashboardMeta.isStarred, \'fa-star\': dashboardMeta.isStarred}" style="color: orange;"></i>\n					</a>\n				</li>\n				<li ng-show="dashboardMeta.canShare">\n					<a class="pointer" ng-click="shareDashboard()" bs-tooltip="\'Share dashboard\'" data-placement="bottom"><i class="fa fa-share-square-o"></i></a>\n				</li>\n				<li ng-show="dashboardMeta.canSave">\n					<a ng-click="saveDashboard()" bs-tooltip="\'Save dashboard\'" data-placement="bottom"><i class="fa fa-save"></i></a>\n				</li>\n				<li class="dropdown">\n					<a class="pointer" ng-click="hideTooltip($event)" bs-tooltip="\'Manage dashboard\'" data-placement="bottom" data-toggle="dropdown"><i class="fa fa-cog"></i></a>\n					<ul class="dropdown-menu">\n						<li ng-if="dashboardMeta.canEdit"><a class="pointer" ng-click="openEditView(\'settings\');">Settings</a></li>\n						<li ng-if="dashboardMeta.canEdit"><a class="pointer" ng-click="openEditView(\'annotations\');">Annotations</a></li>\n						<li ng-if="dashboardMeta.canEdit"><a class="pointer" ng-click="openEditView(\'templating\');">Templating</a></li>\n						<li><a class="pointer" ng-click="exportDashboard();">Export</a></li>\n						<li><a class="pointer" ng-click="editJson();">View JSON</a></li>\n						<li ng-if="contextSrv.isEditor"><a class="pointer" ng-click="saveDashboardAs();">Save As...</a></li>\n						<li ng-if="dashboardMeta.canSave"><a class="pointer" ng-click="deleteDashboard();">Delete dashboard</a></li>\n					</ul>\n				</li>\n			</ul>\n\n			<ul class="nav dash-playlist-actions" ng-if="playlistSrv">\n				<li>\n					<a ng-click="playlistSrv.prev()"><i class="fa fa-step-backward"></i></a>\n				</li>\n				<li>\n					<a ng-click="playlistSrv.stop()"><i class="fa fa-stop"></i></a>\n				</li>\n				<li>\n					<a ng-click="playlistSrv.next()"><i class="fa fa-step-forward"></i></a>\n				</li>\n			</ul>\n\n			<ul class="nav pull-right">\n				<li ng-show="dashboardViewState.fullscreen" class="back-to-dashboard-link">\n					<a ng-click="exitFullscreen()">\n						Back to dashboard\n					</a>\n				</li>\n				<li ng-if="dashboard">\n					<gf-time-picker dashboard="dashboard"></gf-time-picker>\n				</li>\n			</ul>\n		</div>\n	</div>\n</div>\n\n'),a.put("app/features/dashboard/partials/graphiteImport.html",'<div ng-controller="GraphiteImportCtrl" ng-init="init()">\n\n	<div ng-if="datasources.length > 0">\n		<h2 style="margin-top: 30px;">Load dashboard from Graphite-Web</h2>\n\n		<div class="tight-form last">\n			<ul class="tight-form-list">\n				<li class="tight-form-item" style="width: 150px">\n					<strong>Data source</strong>\n				</li>\n				<li>\n					<select type="text" ng-model="options.sourceName" class="input-medium tight-form-input" ng-options="f for f in datasources">\n					</select>\n				</li>\n				<li style="float: right">\n					<button class="btn btn-inverse tight-form-btn" ng-click="listAll()">List dashboards</button>\n				</li>\n				<div class="clearfix"></div>\n			</ul>\n		</div>\n\n		<table class="grafana-options-table" style="margin-top: 20px;">\n			<tr ng-repeat="dash in dashboards">\n				<td style="">{{dash.name}}</td>\n				<td>\n					<button class="btn btn-inverse pull-right" ng-click="import(dash.name)">\n						Load\n					</a>\n				</td>\n			</tr>\n		</table>\n\n	</div>\n</div>\n'),a.put("app/features/dashboard/partials/import.html",'<topnav icon="fa fa-th-large" title="Dashboards" subnav="true">\n	<ul class="nav">\n		<li class="active"><a href="import/dashboard">Import</a></li>\n	</ul>\n</topnav>\n\n<div class="page-container">\n	<div class="page">\n		<h2>\n			Import file\n			<em style="font-size: 14px;padding-left: 10px;"> <i class="fa fa-info-circle"></i> Load dashboard from local .json file</em>\n		</h2>\n\n		<div class="editor-row">\n			<div class="section">\n				<div class="editor-option">\n					<form>\n						<input type="file" id="dashupload" dash-upload/><br>\n					</form>\n				</div>\n			</div>\n		</div>\n\n		<h2>\n			Migrate dashboards\n			<em style="font-size: 14px;padding-left: 10px;"><i class="fa fa-info-circle"></i> Import dashboards from Elasticsearch or InfluxDB</em>\n		</h2>\n\n		<div class="tight-form last">\n			<ul class="tight-form-list">\n				<li class="tight-form-item" style="width: 150px">\n					<strong>Dashboard source</strong>\n				</li>\n				<li>\n					<select type="text" ng-model="sourceName" class="input-medium tight-form-input" ng-options="f for f in datasources">\n					</select>\n				</li>\n				<li style="float: right">\n					<button class="btn btn-success tight-form-btn" ng-click="startImport()">Import</button>\n				</li>\n				<div class="clearfix"></div>\n			</ul>\n		</div>\n\n		<div class="editor-row" ng-if="importing">\n			<section class="section">\n				<h5>{{infoText}}</h5>\n\n				<div class="editor-row row">\n					<table class="grafana-options-table span5">\n						<tr ng-repeat="dash in imported">\n							<td>{{dash.name}}</td>\n							<td>\n								{{dash.info}}\n							</td>\n						</tr>\n					</table>\n				</div>\n			</section>\n		</div>\n\n		<div ng-include="\'app/features/dashboard/partials/graphiteImport.html\'"></div>\n\n	</div>\n</div>\n\n'),a.put("app/features/dashboard/partials/linksEditor.html",'<div ng-controller="DashLinksController">\n	<div class="editor-row">\n		<div class="tight-form-section">\n			<h5>Links and Dash Navigation</h5>\n\n			<div ng-repeat="link in panel.links">\n				<div class="tight-form" >\n					<ul class="tight-form-list">\n						<li class="tight-form-item">\n							<i class="fa fa-remove pointer" ng-click="deleteLink(link)"></i>\n						</li>\n\n						<li class="tight-form-item" style="width: 80px;">Link title</li>\n						<li>\n							<input type="text" ng-model="link.title" class="input-medium tight-form-input">\n						</li>\n\n						<li class="tight-form-item">Type</li>\n						<li>\n							<select class="input-medium tight-form-input" style="width: 101px;" ng-model="link.type" ng-options="f for f in [\'dashboard\',\'absolute\']"></select>\n						</li>\n\n						<li class="tight-form-item" ng-show="link.type === \'dashboard\'">Dashboard</li>\n						<li ng-show="link.type === \'dashboard\'">\n							<input type="text"\n							ng-model="link.dashboard"\n							bs-typeahead="searchDashboards"\n							class="input-large tight-form-input">\n						</li>\n\n						<li class="tight-form-item" ng-show="link.type === \'absolute\'">Url</li>\n						<li ng-show="link.type === \'absolute\'">\n							<input type="text" ng-model="link.url" class="input-xlarge tight-form-input">\n						</li>\n					</ul>\n					<div class="clearfix"></div>\n				</div>\n				<div class="tight-form">\n					<ul class="tight-form-list" role="menu">\n						<li class="tight-form-item">\n							<i class="fa fa-remove invisible"></i>\n						</li>\n						<li class="tight-form-item" style="width: 80px;">\n							Params\n							<tip>Use var-variableName=value to pass templating variables.</tip>\n						</li>\n						<li>\n							<input type="text" ng-model="link.params" class="input-xxlarge tight-form-input">\n						</li>\n					</ul>\n					<div class="clearfix"></div>\n				</div>\n			</div>\n\n		</div>\n	</div>\n\n	<div class="editor-row">\n		<br>\n		<button class="btn btn-inverse" ng-click="addLink()"><i class="fa fa-plus"></i> Add link</button>\n	</div>\n</div>\n'),a.put("app/features/dashboard/partials/saveDashboardAs.html",'<div class="modal-body gf-box gf-box-no-margin" ng-controller="SaveDashboardAsCtrl" ng-init="init();">\n	<div class="gf-box-header">\n		<div class="gf-box-title">\n			<i class="fa fa-copy"></i>\n			Save As...\n		</div>\n\n		<button class="gf-box-header-close-btn" ng-click="dismiss();">\n			<i class="fa fa-remove"></i>\n		</button>\n	</div>\n\n	<div class="gf-box-body">\n		<div class="text-center">\n			<h4>New title</h4>\n\n			<input type="text" class="input input-fluid" ng-model="clone.title" give-focus="true" ng-keydown="keyDown($event)">\n			<br>\n			<br>\n\n			<button class="btn btn-inverse" ng-click="dismiss();">Cancel</button>\n			<button class="btn btn-success" ng-click="saveClone();">Save</button>\n		</div>\n	</div>\n</div>\n\n'),a.put("app/features/dashboard/partials/settings.html",'<div class="gf-box-header">\n	<div class="gf-box-title">\n		<i class="fa fa-cogs"></i>\n		Settings\n	</div>\n\n	<div ng-model="editor.index" bs-tabs style="text-transform:capitalize;">\n		<div ng-repeat="tab in [\'General\', \'Rows\', \'Links\', \'Time picker\']" data-title="{{tab}}">\n		</div>\n	</div>\n\n	<button class="gf-box-header-close-btn" ng-click="dismiss();">\n		<i class="fa fa-remove"></i>\n	</button>\n</div>\n\n<div class="gf-box-body" style="padding-bottom: 50px;">\n	<div ng-if="editor.index == 0">\n		<div class="editor-row">\n			<div class="tight-form-section">\n				<h5>Dashboard info</h5>\n				<div class="tight-form">\n					<ul class="tight-form-list">\n						<li class="tight-form-item" style="width: 90px">\n							Title\n						</li>\n						<li>\n							<input type="text" class="input-xlarge tight-form-input" ng-model=\'dashboard.title\'></input>\n						</li>\n						<li class="tight-form-item">\n							Tags\n							<tip>Press enter to a add tag</tip>\n						</li>\n						<li>\n							<bootstrap-tagsinput ng-model="dashboard.tags" tagclass="label label-tag" placeholder="add tags">\n							</bootstrap-tagsinput>\n						</li>\n					</ul>\n					<div class="clearfix"></div>\n				</div>\n				<div class="tight-form last">\n					<ul class="tight-form-list">\n						<li class="tight-form-item" style="width: 90px">\n							Timezone\n						</li>\n						<li>\n							<select ng-model="dashboard.timezone" class=\'input-small tight-form-input\' ng-options="f for f in [\'browser\',\'utc\']"></select>\n						</li>\n					</ul>\n					<div class="clearfix"></div>\n				</div>\n			</div>\n		</div>\n\n		<div class="editor-row">\n			<div class="tight-form-section">\n				<h5>Toggles</h5>\n				<div class="tight-form last">\n					<ul class="tight-form-list">\n						<li class="tight-form-item">\n							<editor-checkbox text="Editable" model="dashboard.editable"></editor-checkbox>\n						</li>\n						<li class="tight-form-item">\n							<editor-checkbox text="Hide Controls (CTRL+H)" model="dashboard.hideControls"></editor-checkbox>\n						</li>\n						<li class="tight-form-item last">\n							<editor-checkbox text="Shared Crosshair (CTRL+O)" model="dashboard.sharedCrosshair"></editor-checkbox>\n						</li>\n					</ul>\n					<div class="clearfix"></div>\n				</div>\n			</div>\n		</div>\n	</div>\n\n	<div ng-if="editor.index == 1">\n		<div class="editor-row">\n			<div class="tight-form-section">\n				<h5>Rows settings</h5>\n				<div class="tight-form-container">\n					<div class="tight-form" ng-repeat="row in dashboard.rows">\n						<ul class="tight-form-list">\n							<li class="tight-form-item">\n								Title\n							</li>\n							<li>\n								<input type="text" class="input tight-form-input" style="width: 400px;" ng-model=\'row.title\'></input>\n							</li>\n							<li class="tight-form-item">\n								<editor-checkbox text="Show title" model="row.showTitle"></editor-checkbox>\n							</li>\n							<li class="tight-form-item last">\n								<i ng-click="_.move(dashboard.rows,$index,$index-1)" ng-class="{\'invisible\': $first}" class="pointer fa fa-arrow-up"></i>\n							</li>\n							<li class="tight-form-item last">\n								<i ng-click="_.move(dashboard.rows,$index,$index+1)" ng-class="{\'invisible\': $last}" class="pointer fa fa-fw fa-arrow-down"></i>\n							</li>\n							<li class="tight-form-item last">\n								<i ng-click="dashboard.rows = _.without(dashboard.rows,row)" class="pointer fa fa-remove"></i>\n							</li>\n						</ul>\n						<div class="clearfix"></div>\n					</div>\n				</div>\n			</div>\n		</div>\n	</div>\n\n	<div ng-if="editor.index == 2">\n		<dash-links-editor></dash-links-editor>\n	</div>\n\n	<div ng-if="editor.index == 3">\n		<gf-time-picker-settings dashboard="dashboard"></gf-time-picker-settings>\n	</div>\n\n</div>\n\n<div class="clearfix"></div>\n</div>\n\n<div class="gf-box-footer">\n	<div class="grafana-version-info" ng-show="editor.index === 0">\n		<span class="editor-option small">\n			Grafana version: {{contextSrv.version}} &nbsp;&nbsp;\n		</span>\n		<span grafana-version-check>\n		</span>\n	</div>\n</div>\n'),a.put("app/features/dashboard/partials/shareModal.html",'<div class="modal-body gf-box gf-box-no-margin" ng-controller="ShareModalCtrl" ng-init="init()">\n	<div class="gf-box-header">\n		<div class="gf-box-title">\n			<i class="fa fa-share"></i>\n			{{modalTitle}}\n		</div>\n\n		<div ng-model="editor.index" bs-tabs>\n			<div ng-repeat="tab in tabs" data-title="{{tab.title}}">\n			</div>\n		</div>\n\n		<button class="gf-box-header-close-btn" ng-click="dismiss();">\n			<i class="fa fa-remove"></i>\n		</button>\n	</div>\n\n	<div class="gf-box-body" ng-repeat="tab in tabs" ng-if="editor.index == $index">\n		<div ng-include src="tab.src" class="share-modal-body"></div>\n	</div>\n\n</div>\n\n<script type="text/ng-template" id="shareEmbed.html">\n	<div class="share-modal-big-icon">\n		<i class="fa fa-code"></i>\n	</div>\n\n	<div class="share-snapshot-header">\n		<p class="share-snapshot-info-text">\n			The html code below can be pasted and included in another web page. Unless anonymous access\n			is enabled the user viewing that page need to be signed into grafana for the graph to load.\n		</p>\n	</div>\n\n	<div ng-include src="\'shareLinkOptions.html\'"></div>\n\n	<div class="gf-form">\n		<div class="gf-form-row">\n			<span class="gf-fluid-input">\n				<textarea rows="5" data-share-panel-url class="input" ng-model=\'iframeHtml\'></textarea>\n			</span>\n		</div>\n		<button class="btn btn-inverse" data-clipboard-text="{{iframeHtml}}" clipboard-button><i class="fa fa-clipboard"></i> Copy</button>\n	</div>\n</script>\n\n<script type="text/ng-template" id="shareLinkOptions.html">\n	<div class="editor-row" style="margin: 11px 20px 33px 20px">\n		<div class="section">\n			<div class="tight-form">\n				<ul class="tight-form-list">\n					<li class="tight-form-item" style="width: 170px;">\n						<label class="checkbox-label" for="options.forCurrent">Current time range</label>\n					</li>\n					<li class="tight-form-item last">\n						<input class="cr1" id="options.forCurrent" type="checkbox" ng-model="options.forCurrent" ng-checked="options.forCurrent" ng-change="buildUrl()">\n						<label for="options.forCurrent" class="cr1"></label>\n					</li>\n				</ul>\n				<div class="clearfix"></div>\n			</div>\n			<div class="tight-form">\n				<ul class="tight-form-list">\n					<li class="tight-form-item" style="width: 170px">\n						<label class="checkbox-label" for="options.includeTemplateVars">Include template variables</label>\n					</li>\n					<li class="tight-form-item last">\n						<input class="cr1" id="options.includeTemplateVars" type="checkbox" ng-model="options.includeTemplateVars" ng-checked="options.includeTemplateVars" ng-change="buildUrl()">\n						<label for="options.includeTemplateVars" class="cr1"></label>\n					</li>\n				</ul>\n				<div class="clearfix"></div>\n			</div>\n			<div class="tight-form">\n				<ul class="tight-form-list">\n					<li class="tight-form-item" style="width: 170px">\n						Theme\n					</li>\n					<li>\n						<select class="input-small tight-form-input last" style="width: 211px" ng-model="options.theme" ng-options="f as f for f in [\'current\', \'dark\', \'light\']" ng-change="buildUrl()"></select>\n					</li>\n				</ul>\n				<div class="clearfix"></div>\n			</div>\n		</div>\n	</div>\n</script>\n\n<script type="text/ng-template" id="shareLink.html">\n	<div class="share-modal-big-icon">\n		<i class="fa fa-external-link"></i>\n	</div>\n\n	<div ng-include src="\'shareLinkOptions.html\'"></div>\n	<div class="gf-form">\n		<div class="gf-form-row">\n			<button class="btn btn-inverse pull-right" data-clipboard-text="{{shareUrl}}" clipboard-button><i class="fa fa-clipboard"></i> Copy</button>\n			<span class="gf-fluid-input">\n				<input type="text" data-share-panel-url class="input" ng-model=\'shareUrl\'></input>\n			</span>\n		</div>\n		<div class="editor-row" style="margin-top: 5px;" ng-show="modeSharePanel">\n			<a href="{{imageUrl}}" target="_blank"><i class="fa fa-camera"></i> Direct link rendered image</a>\n		</div>\n	</div>\n</script>\n\n<script type="text/ng-template" id="shareSnapshot.html">\n	<div class="ng-cloak" ng-cloak ng-controller="ShareSnapshotCtrl">\n		<div class="share-modal-big-icon">\n			<i ng-if="loading" class="fa fa-spinner fa-spin"></i>\n			<i ng-if="!loading" class="gf-icon gf-icon-snap-multi"></i>\n		</div>\n\n		<div class="share-snapshot-header" ng-if="step === 1">\n			<p class="share-snapshot-info-text">\n				A snapshot is an instant way to share an interactive dashboard publicly.\n				When created, we <strong>strip sensitive data</strong> like queries (metric, template and annotation) and panel links,\n				leaving only the visible metric data and series names embedded into your dashboard.\n			</p>\n			<p class="share-snapshot-info-text">\n				Keep in mind, your <strong>snapshot can be viewed by anyone</strong> that has the link and can reach the URL.\n				Share wisely.\n			</p>\n		</div>\n\n		<div class="share-snapshot-header" ng-if="step === 3">\n			<p class="share-snapshot-info-text">\n				The snapshot has now been deleted. If it you have already accessed it once, It might take up to an hour before it is removed from\n				browser caches or CDN caches.\n			</p>\n		</div>\n\n		<div class="editor-row share-modal-options" style="">\n			<div class="section" ng-if="step === 1">\n				<div class="tight-form">\n					<ul class="tight-form-list">\n						<li class="tight-form-item" style="width: 110px;">\n							Snapshot name\n						</li>\n						<li>\n							<input type="text" ng-model="snapshot.name" class="input-large tight-form-input last" >\n						</li>\n					</ul>\n					<div class="clearfix"></div>\n				</div>\n				<div class="tight-form">\n					<ul class="tight-form-list">\n						<li class="tight-form-item" style="width: 110px">\n							Expire\n						</li>\n						<li>\n							<select class="input-small tight-form-input last" style="width: 211px" ng-model="snapshot.expires" ng-options="f.value as f.text for f in expireOptions"></select>\n						</li>\n					</ul>\n					<div class="clearfix"></div>\n				</div>\n			</div>\n\n			<div class="gf-form" ng-if="step === 2" style="margin-top: 40px">\n				<div class="gf-form-row">\n					<a href="{{snapshotUrl}}" class="large share-snapshot-link" target="_blank">\n						<i class="fa fa-external-link-square"></i>\n						{{snapshotUrl}}\n					</a>\n					<br>\n					<button class="btn btn-inverse btn-large" data-clipboard-text="{{snapshotUrl}}" clipboard-button><i class="fa fa-clipboard"></i> Copy Link</button>\n				</div>\n			</div>\n		</div>\n\n		<div ng-if="step === 1">\n			<button class="btn btn-success btn-large" ng-click="createSnapshot()" ng-disabled="loading">\n				<i class="fa fa-save"></i>\n				Local Snapshot\n			</button>\n\n			<button class="btn btn-primary btn-large" ng-click="createSnapshot(true)" ng-disabled="loading">\n				<i class="fa fa-cloud-upload"></i>\n				Publish to snapshot.raintank.io\n			</button>\n		</div>\n\n		<div class="pull-right" ng-if="step === 2" style="padding: 5px">\n			Did you make a mistake? <a class="pointer" ng-click="deleteSnapshot()" target="_blank">delete snapshot.</a>\n		</div>\n\n	</div>\n</script>\n'),
a.put("app/features/dashboard/partials/snapshotTopNav.html",'<div class="navbar navbar-static-top" ng-controller=\'SnapshotTopNavCtrl\' ng-init="init()">\n	<div class="navbar-inner">\n		<div class="container-fluid">\n\n			<div class="top-nav">\n				<a class="pointer top-nav-menu-btn" ng-if="!contextSrv.sidemenu" ng-click="contextSrv.toggleSideMenu()">\n					<img class="logo-icon" src="img/fav32.png"></img>\n					<i class="fa fa-bars"></i>\n				</a>\n\n				<div class="top-nav-snapshot-title">\n					<a class="pointer" bs-tooltip="titleTooltip" data-placement="bottom">\n						<i class="gf-icon gf-icon-snap-multi"></i>\n						<span class="dashboard-title">\n							{{dashboard.title}}\n							<em class="small">&nbsp;&nbsp;(snapshot)</em>\n						</span>\n					</a>\n				</div>\n			</div>\n\n			<ul class="nav pull-left top-nav-dash-actions">\n				<li>\n					<a class="pointer" ng-click="shareDashboard()" bs-tooltip="\'Share dashboard\'" data-placement="bottom"><i class="fa fa-share-square-o"></i></a>\n				</li>\n			</ul>\n\n			<ul class="nav pull-right">\n				<li ng-if="dashboard">\n					<gf-time-picker dashboard="dashboard"></gf-time-picker>\n				</li>\n			</ul>\n\n		</div>\n	</div>\n</div>\n'),a.put("app/features/dashboard/timepicker/custom.html",'<div class="gf-box-header">\n	<div class="gf-box-title">\n		<i class="fa fa-clock-o"></i>\n		Custom time range\n	</div>\n	<button class="gf-box-header-close-btn" ng-click="dismiss();">\n		<i class="fa fa-remove"></i>\n	</button>\n</div>\n\n<div class="gf-box-body">\n	<div class="timepicker form-horizontal">\n		<form name="timeForm" style="margin-bottom: 0">\n\n			<div class="timepicker-from-column">\n				<label class="small">From</label>\n				<div class="fake-input timepicker-input">\n					<input class="timepicker-date" type="text" ng-change="validate(temptime)" ng-model="temptime.from.date" data-date-format="yyyy-mm-dd" required bs-datepicker />@\n					<input class="timepicker-hms" type="text" maxlength="2" ng-change="validate(temptime)" ng-model="temptime.from.hour" required ng-pattern="patterns.hour" onClick="this.select();"/>:\n					<input class="timepicker-hms" type="text" maxlength="2" ng-change="validate(temptime)" ng-model="temptime.from.minute" required ng-pattern="patterns.minute" onClick="this.select();"/>:\n					<input class="timepicker-hms" type="text" maxlength="2" ng-change="validate(temptime)" ng-model="temptime.from.second" required ng-pattern="patterns.second" onClick="this.select();"/>.\n					<input class="timepicker-ms" type="text" maxlength="3" ng-change="validate(temptime)" ng-model="temptime.from.millisecond" required ng-pattern="patterns.millisecond"  onClick="this.select();"/>\n				</div>\n			</div>\n\n			<div class="timepicker-to-column">\n\n				<label class="small">To (<a class="link" ng-class="{\'strong\':temptime.now}" ng-click="ctrl.setNow();temptime.now=true">set now</a>)</label>\n\n				<div class="fake-input timepicker-input">\n					<div ng-hide="temptime.now">\n						<input class="timepicker-date" type="text" ng-change="validate(temptime)" ng-model="temptime.to.date" data-date-format="yyyy-mm-dd" required bs-datepicker />@\n						<input class="timepicker-hms" type="text" maxlength="2" ng-change="validate(temptime)" ng-model="temptime.to.hour" required ng-pattern="patterns.hour" onClick="this.select();"/>:\n						<input class="timepicker-hms" type="text" maxlength="2" ng-change="validate(temptime)" ng-model="temptime.to.minute" required ng-pattern="patterns.minute" onClick="this.select();"/>:\n						<input class="timepicker-hms" type="text" maxlength="2" ng-change="validate(temptime)" ng-model="temptime.to.second" required ng-pattern="patterns.second" onClick="this.select();"/>.\n						<input class="timepicker-ms" type="text" maxlength="3" ng-change="validate(temptime)" ng-model="temptime.to.millisecond" required ng-pattern="patterns.millisecond" onClick="this.select();"/>\n					</div>\n					<span type="text" ng-show="temptime.now" ng-disabled="temptime.now">&nbsp <i class="pointer fa fa-remove" ng-click="ctrl.setNow();temptime.now=false;"></i> Right Now <input type="text" name="dummy" style="visibility:hidden" /></span>\n				</div>\n			</div>\n\n			<br>\n			<button ng-click="ctrl.setAbsoluteTimeFilter(ctrl.validate(temptime));dismiss();" ng-disabled="!timeForm.$valid" class="btn btn-success">Apply</button>\n			<span class="" ng-hide="input.$valid">Invalid date or range</span>\n		</form>\n	</div>\n</div>\n'),a.put("app/features/dashboard/timepicker/dropdown.html",'<div class="row pull-right">\n	<div class="gf-timepicker-absolute-section">\n		<h3>Time range</h3>\n		<label class="small">From:</label>\n		<div class="input-prepend">\n			<input type="text" class="input-large" ng-model="ctrl.timeRaw.from" input-datetime>\n			<button class="btn btn-primary" type="button" ng-click="openFromPicker=!openFromPicker">\n				<i class="fa fa-calendar"></i>\n			</button>\n		</div>\n\n		<div ng-if="openFromPicker">\n			<datepicker ng-model="ctrl.absolute.fromJs" class="gf-timepicker-component" show-weeks="false" ng-change="ctrl.absoluteFromChanged()"></datepicker>\n		</div>\n\n		<label class="small">To:</label>\n		<div class="input-prepend">\n			<input type="text" class="input-large" ng-model="ctrl.timeRaw.to" input-datetime>\n			<button class="btn btn-primary" type="button" ng-click="openToPicker=!openToPicker">\n				<i class="fa fa-calendar"></i>\n			</button>\n		</div>\n\n		<div ng-if="openToPicker">\n			<datepicker ng-model="ctrl.absolute.toJs" class="gf-timepicker-component" show-weeks="false" ng-change="ctrl.absoluteToChanged()"></datepicker>\n		</div>\n\n		<label class="small">Refreshing every:</label>\n		<select ng-model="ctrl.refresh.value" class=\'input-medium\' ng-options="f.value as f.text for f in ctrl.refresh.options">\n		</select>\n\n		<button class="btn btn-inverse gf-timepicker-btn-apply" type="button" ng-click="ctrl.applyCustom()">\n			Apply\n		</button>\n	</div>\n\n	<div class="gf-timepicker-relative-section">\n		<h3>Quick ranges</h3>\n		<ul ng-repeat="group in ctrl.timeOptions">\n			<li bindonce ng-repeat=\'option in group\' ng-class="{active: option.active}">\n				<a ng-click="ctrl.setRelativeFilter(option)" bo-text="option.display"></a>\n			</li>\n		</ul>\n	</div>\n\n</div>\n<div class="clearfix"></div>\n\n'),a.put("app/features/dashboard/timepicker/settings.html",'<div class="editor-row">\n	<div class="section">\n		<div>\n			<!-- <div class="tight&#45;form"> -->\n			<!-- 	<ul class="tight&#45;form&#45;list"> -->\n			<!-- 		<li class="tight&#45;form&#45;item" style="width: 118px"> -->\n			<!-- 			Relative times -->\n			<!-- 		</li> -->\n			<!-- 		<li> -->\n			<!-- 			<input type="text" class="input&#45;xlarge tight&#45;form&#45;input last" style="width: 450px" ng&#45;model="ctrl.panel.time_options" array&#45;join> -->\n			<!-- 		</li> -->\n			<!-- 	</ul> -->\n			<!-- 	<div class="clearfix"></div> -->\n			<!-- </div> -->\n			<div class="tight-form">\n				<ul class="tight-form-list">\n					<li class="tight-form-item" style="width: 118px">\n						Auto-refresh\n					</li>\n					<li>\n						<input type="text" class="input-xlarge tight-form-input last" style="width: 450px" ng-model="ctrl.panel.refresh_intervals" array-join>\n					</li>\n				</ul>\n				<div class="clearfix"></div>\n			</div>\n\n			<div class="tight-form last">\n				<ul class="tight-form-list">\n					<li class="tight-form-item" style="width: 118px">\n						Now delay\n					</li>\n					<li class="tight-form-item">\n						now-\n					</li>\n					<li>\n						<input type="text" class="input-mini tight-form-input last"\n						ng-model="ctrl.panel.nowDelay" placeholder="0m"\n						valid-time-span\n						bs-tooltip="\'Enter 1m to ignore the last minute (because it can contain incomplete metrics)\'"\n						data-placement="right">\n					</li>\n\n				</ul>\n				<div class="clearfix"></div>\n			</div>\n		</div>\n	</div>\n</div>\n'),a.put("app/features/dashboard/timepicker/timepicker.html",'<ul class="nav gf-timepicker-nav">\n\n	<li class="grafana-menu-zoom-out">\n		<a class=\'small\' ng-click=\'ctrl.zoom(2)\'>\n			Zoom Out\n		</a>\n	</li>\n\n	<li ng-class="{\'gf-timepicker-open\': ctrl.isOpen}">\n		<a bs-tooltip="ctrl.tooltip" data-placement="bottom" ng-click="ctrl.openDropdown()">\n			<i class="fa fa-clock-o"></i>\n			<span ng-bind="ctrl.rangeString"></span>\n			<span ng-show="ctrl.isUtc" class="gf-timepicker-utc">\n				UTC\n			</span>\n\n			<span ng-show="ctrl.dashboard.refresh" class="text-warning">\n				&nbsp;\n				&nbsp;\n				<i class="fa fa-refresh"></i>\n				Refresh every {{ctrl.dashboard.refresh}}\n			</span>\n		</a>\n	</li>\n\n	<li class="grafana-menu-refresh" ng-show="!ctrl.dashboard.refresh">\n		<a ng-click="ctrl.timeSrv.refreshDashboard()">\n			<i class="fa fa-refresh"></i>\n		</a>\n	</li>\n\n</ul>\n'),a.put("app/features/dashlinks/editor.html",'<div class="editor-row">\n	<h5>Links and Dash Navigation</h5>\n\n	<div ng-repeat="link in dashboard.links" style="margin-top: 10px;">\n		<div class="tight-form">\n			<ul class="tight-form-list pull-right">\n				<li class="tight-form-item">\n					<i ng-click="moveLink($index, -1)" ng-hide="$first" class="pointer fa fa-arrow-up"></i>\n					<i ng-click="moveLink($index, 1)" ng-hide="$last" class="pointer fa fa-fw fa-arrow-down"></i>\n				</li>\n				<li class="tight-form-item last">\n					<i class="fa fa-remove pointer" ng-click="deleteLink($index)"></i>\n				</li>\n			</ul>\n\n			<ul class="tight-form-list">\n				<li class="tight-form-item" style="width: 20px">\n					<i class="fa fa-fw fa-unlink"></i>\n				</li>\n\n				<li class="tight-form-item">Type</li>\n				<li>\n					<select class="input-medium tight-form-input" style="width: 150px;" ng-model="link.type" ng-options="f for f in [\'dashboards\',\'link\']" ng-change="updated()"></select>\n				</li>\n\n				<li class="tight-form-item" ng-show="link.type === \'dashboards\'">With tags</li>\n				<li ng-show="link.type === \'dashboards\'">\n					<bootstrap-tagsinput ng-model="link.tags" tagclass="label label-tag" placeholder="add tags">\n					</bootstrap-tagsinput>\n				</li>\n				<li class="tight-form-item" ng-show="link.type === \'dashboards\'">\n					<editor-checkbox text="As dropdown" model="link.asDropdown" change="updated()"></editor-checkbox>\n				</li>\n				<li class="tight-form-item" ng-show="link.type === \'dashboards\' && link.asDropdown">\n					Title\n				</li>\n				<li ng-show="link.type === \'dashboards\' && link.asDropdown">\n					<input type="text" ng-model="link.title" class="input-medium tight-form-input" ng-model-onblur ng-change="updated()">\n				</li>\n				<li class="tight-form-item" ng-show="link.type === \'link\'" style="width: 51px">Url</li>\n				<li ng-show="link.type === \'link\'">\n					<input type="text" ng-model="link.url" class="input-xlarge tight-form-input" style="width: 302px;" ng-model-onblur ng-change="updated()">\n				</li>\n				<li class="tight-form-item" ng-show="link.type === \'link\'">\n					<editor-checkbox text="Open in new tab " model="link.targetBlank" change="updated()"></editor-checkbox>\n				</li>\n			</ul>\n			<div class="clearfix"></div>\n		</div>\n		<div class="tight-form" ng-if="link.type === \'link\'">\n			<ul class="tight-form-list">\n				<li class="tight-form-item" style="width: 20px">\n					<i class="fa fa-fw fa-unlink invisible"></i>\n				</li>\n				<li class="tight-form-item" ng-show="link.type === \'link\'" style="width: 31px">Title</li>\n				<li ng-show="link.type === \'link\'">\n					<input type="text" ng-model="link.title" class="input-medium tight-form-input" ng-model-onblur ng-change="updated()">\n				</li>\n				<li class="tight-form-item" ng-show="link.type === \'link\'" style="width: 51px">Tooltip</li>\n				<li ng-show="link.type === \'link\'">\n					<input type="text" ng-model="link.tooltip" class="input-medium tight-form-input" style="width: 151px" placeholder="Open dashboard" ng-model-onblur ng-change="updated()">\n				</li>\n				<li class="tight-form-item" ng-show="link.type === \'link\'">Icon</li>\n				<li ng-show="link.type === \'link\'">\n					<select class="input-medium tight-form-input" style="width: 110px;" ng-model="link.icon" ng-options="k as k for (k, v) in iconMap" ng-change="updated()"></select>\n				</li>\n			</ul>\n			<div class="clearfix"></div>\n		</div>\n		<div class="tight-form last">\n			<ul class="tight-form-list">\n				<li class="tight-form-item" style="width: 20px">\n					<i class="fa fa-fw fa-unlink invisible"></i>\n				</li>\n				<li class="tight-form-item">\n					<editor-checkbox text="Keep current time range" model="link.keepTime" change="updated()"></editor-checkbox>\n				</li>\n				<li class="tight-form-item">\n					<editor-checkbox text="Add current variable values" model="link.includeVars" change="updated()"></editor-checkbox>\n				</li>\n			</ul>\n			<div class="clearfix"></div>\n		</div>\n	</div>\n</div>\n<div class="editor-row">\n	<br>\n	<button class="btn btn-inverse" ng-click="addLink()"><i class="fa fa-plus"></i> Add link</button>\n</div>\n\n'),a.put("app/features/org/partials/apikeyModal.html",'<div class="modal-body gf-box gf-box-no-margin">\n	<div class="gf-box-header">\n		<div class="gf-box-title">\n			<i class="fa fa-key"></i>\n			API Key Created\n		</div>\n\n		<button class="gf-box-header-close-btn" ng-click="dismiss();">\n			<i class="fa fa-remove"></i>\n		</button>\n	</div>\n\n	<div class="gf-box-body" style="min-height: 0px;">\n\n		<div class="tight-form last">\n			<ul class="tight-form-list">\n				<li class="tight-form-item">\n					<strong>Key</strong>\n				</li>\n				<li class="tight-form-item last">\n					{{key}}\n				</li>\n			</ul>\n			<div class="clearfix"></div>\n		</div>\n		<br>\n		<br>\n\n		<div class="grafana-info-box" style="text-align: left">\n			You will only be able to view this key here once! It is not stored in this form. So be sure to copy it now.\n			<br>\n			<br>\n			You can authenticate request using the Authorization HTTP header, example:\n			<br>\n			<br>\n			<pre class="small" style="overflow: hidden">\ncurl -H "Authorization: Bearer your_key_above" http://your.grafana.com/api/dashboards/db/mydash\n			</pre>\n		</div>\n\n	</div>\n\n</div>\n\n'),a.put("app/features/org/partials/datasourceEdit.html",'<topnav title="Data sources" icon="fa fa-fw fa-database" subnav="true">\n	<ul class="nav">\n		<li><a href="datasources">Overview</a></li>\n		<li ng-class="{active: isNew}"><a href="datasources/new">Add new</a></li>\n		<li class="active" ng-show="!isNew"><a href="datasources/edit/{{current.name}}">Edit</a></li>\n	</ul>\n</topnav>\n\n<div class="page-container">\n	<div class="page">\n		<h2 ng-show="isNew">Add data source</h2>\n		<h2 ng-show="!isNew">Edit data source</h2>\n\n		<form name="editForm">\n			<div class="tight-form">\n				<ul class="tight-form-list">\n					<li class="tight-form-item" style="width: 80px">\n						Name\n					</li>\n					<li>\n						<li>\n							<input type="text" class="input-xlarge tight-form-input" ng-model="current.name" placeholder="my data source name" required>\n						</li>\n					</li>\n					<li class="tight-form-item">\n						Default&nbsp;\n						<input class="cr1" id="current.isDefault" type="checkbox" ng-model="current.isDefault" ng-checked="current.isDefault">\n						<label for="current.isDefault" class="cr1"></label>\n					</li>\n				</ul>\n				<div class="clearfix"></div>\n			</div>\n			<div class="tight-form last">\n				<ul class="tight-form-list">\n					<li class="tight-form-item" style="width: 80px">\n						Type\n					</li>\n					<li>\n						<select class="input-xlarge tight-form-input" ng-model="current.type" ng-options="k as v.name for (k, v) in types" ng-change="typeChanged()"></select>\n					</li>\n				</ul>\n				<div class="clearfix"></div>\n			</div>\n\n			<div ng-include="datasourceMeta.partials.config" ng-if="datasourceMeta.partials.config"></div>\n\n			<div ng-if="testing" style="margin-top: 25px">\n				<h5 ng-show="!testing.done">Testing.... <i class="fa fa-spiner fa-spin"></i></h5>\n				<h5 ng-show="testing.done">Test results</h5>\n				<div class="alert-{{testing.status}} alert">\n					<div class="alert-title">{{testing.title}}</div>\n					<div ng-bind=\'testing.message\'></div>\n				</div>\n			</div>\n\n			<div class="pull-right" style="margin-top: 35px">\n				<button type="submit" class="btn btn-success" ng-show="isNew" ng-click="saveChanges()">Add</button>\n				<button type="submit" class="btn btn-success" ng-show="!isNew" ng-click="saveChanges()">Save</button>\n				<button type="submit" class="btn btn-inverse" ng-show="!isNew" ng-click="saveChanges(true)">\n					Test Connection\n				</button>\n				<a class="btn btn-inverse" ng-show="!isNew" href="datasources">Cancel</a>\n			</div>\n			<br>\n		</form>\n	</div>\n</div>\n'),a.put("app/features/org/partials/datasourceHttpConfig.html",'<br>\n<h5>Http settings</h5>\n<div class="tight-form">\n	<ul class="tight-form-list">\n		<li class="tight-form-item" style="width: 80px">\n			Url\n		</li>\n		<li>\n			<input type="text" class="tight-form-input input-xlarge" ng-model=\'current.url\' placeholder="http://my.server.com:8080" ng-pattern="/^(ftp|http|https):\\/\\/(\\w+:{0,1}\\w*@)?(\\S+)(:[0-9]+)?(\\/|\\/([\\w#!:.?+=&%@!\\-\\/]))?$/" required></input>\n		</li>\n		<li class="tight-form-item">\n			Access <tip>Direct = url is used directly from browser, Proxy = Grafana backend will proxy the request</tip>\n	  </li>\n		<li>\n			<select class="input-medium tight-form-input" ng-model="current.access" ng-options="f for f in [\'direct\', \'proxy\']"></select>\n		</li>\n	</ul>\n	<div class="clearfix"></div>\n</div>\n<div class="tight-form last">\n	<ul class="tight-form-list">\n		<li class="tight-form-item" style="width: 80px">\n			Basic Auth\n		</li>\n		<li class="tight-form-item">\n			<editor-checkbox text="Enable" model="current.basicAuth"></editor-checkbox>\n		</li>\n		<li class="tight-form-item" ng-if="current.basicAuth">\n			User\n		</li>\n		<li ng-if="current.basicAuth">\n			<input type="text" class="tight-form-input input-medium" style="width: 139px" ng-model=\'current.basicAuthUser\' placeholder="user" required></input>\n		</li>\n		<li class="tight-form-item" style="width: 67px" ng-if="current.basicAuth">\n			Password\n		</li>\n		<li ng-if="current.basicAuth">\n			<input type="password" class="tight-form-input input-medium" ng-model=\'current.basicAuthPassword\' placeholder="password" required></input>\n		</li>\n	</ul>\n	<div class="clearfix"></div>\n</div>\n\n\n'),a.put("app/features/org/partials/datasources.html",'<topnav title="Data sources" icon="fa fa-fw fa-database" subnav="true">\n	<ul class="nav">\n		<li class="active" ><a href="datasources">Overview</a></li>\n		<li><a href="datasources/new">Add new</a></li>\n	</ul>\n</topnav>\n\n<div class="page-container">\n	<div class="page">\n		<h2>Data sources</h2>\n\n		<div ng-if="datasources.length === 0">\n			<em>No datasources defined</em>\n		</div>\n\n		<table class="grafana-options-table" ng-if="datasources.length > 0">\n			<tr>\n				<td><strong>Name</strong></td>\n				<td><strong>Url</strong></td>\n				<td></td>\n				<td></td>\n				<td></td>\n			</tr>\n			<tr ng-repeat="ds in datasources">\n				<td style="width:1%">\n					<i class="fa fa-database"></i> &nbsp;\n					{{ds.name}}\n				</td>\n				<td style="width:90%">\n					{{ds.url}}\n				</td>\n				<td style="width:2%" class="text-center">\n					<span ng-if="ds.isDefault">\n						<span class="label label-info">default</span>\n					</span>\n				</td>\n				<td style="width: 1%">\n					<a href="datasources/edit/{{ds.id}}" class="btn btn-inverse btn-mini">\n						<i class="fa fa-edit"></i>\n						Edit\n					</a>\n				</td>\n				<td style="width: 1%">\n					<a ng-click="remove(ds)" class="btn btn-danger btn-mini">\n						<i class="fa fa-remove"></i>\n					</a>\n				</td>\n			</tr>\n		</table>\n\n	</div>\n</div>\n'),a.put("app/features/org/partials/invite.html",'<div class="modal-body" ng-controller="UserInviteCtrl" ng-init="init()">\n\n	<a class="modal-close" ng-click="dismiss();">\n		<i class="fa fa-remove"></i>\n	</a>\n\n	<h3>\n		Invite Users\n	</h3>\n\n	<div class="modal-tagline">\n		Send invite or add existing Grafana users to the organization\n		<span class="highlight-word">{{contextSrv.user.orgName}}</span>\n	</div>\n\n	<br>\n	<br>\n\n	<form name="inviteForm">\n		<div style="display: inline-block">\n			<div class="tight-form-container">\n				<div class="tight-form" ng-repeat="invite in invites">\n					<ul class="tight-form-list">\n						<li class="tight-form-item">\n							Email or Username\n						</li>\n						<li>\n							<input type="text" ng-model="invite.loginOrEmail" required class="input-large tight-form-input" placeholder="email@test.com">\n						</li>\n						<li class="tight-form-item">\n							Name\n						</li>\n						<li>\n							<input type="text" ng-model="invite.name" class="input-large tight-form-input" placeholder="name (optional)">\n						</li>\n\n						<li class="tight-form-item">\n							Role\n						</li>\n						<li>\n							<select ng-model="invite.role" class="input-small tight-form-input" ng-options="f for f in [\'Viewer\', \'Editor\', \'Read Only Editor\', \'Admin\']">\n							</select>\n						</li>\n						<li class="tight-form-item last" ng-show="$index > 0">\n							<a class="pointer" tabindex="1" ng-click="removeInvite(invite)">\n								<i class="fa fa-remove"></i>\n							</a>\n						</li>\n						<div class="clearfix"></div>\n					</ul>\n				</div>\n			</div>\n\n			<div style="text-align: left; margin-top: 6px;">\n				<a ng-click="addInvite()">+ Invite another</a>\n				<div class="form-inline" style="margin-top: 20px">\n					<editor-checkbox text="Skip sending invite email" model="options.skipEmails" change="targetBlur()"></editor-checkbox>\n				</div>\n			</div>\n\n			<div class="" style="margin-top: 30px; margin-bottom: 20px;">\n				<button type="button" class="btn btn-inverse" ng-click="dismiss()">Cancel</button>\n				<button type="submit" class="btn btn-success" ng-click="sendInvites();">Invite Users</button>\n\n			</div>\n		</div>\n	</form>\n</div>\n\n\n'),a.put("app/features/org/partials/newOrg.html",'<topnav title="Organization" icon="fa fa-fw fa-users" subnav="true">\n	<ul class="nav">\n		<li class="active"><a href="org/new">New organization</a></li>\n	</ul>\n</topnav>\n\n<div class="page-container">\n	<div class="page">\n\n		<h2 style="margin-top: 30px;">Add Organization</h2>\n\n		<form name="form">\n			<div class="tight-form last">\n				<ul class="tight-form-list">\n					<li class="tight-form-item" style="width: 100px;">\n						<strong>Org. name</strong>\n					</li>\n					<li>\n						<input type="text" ng-model="newOrg.name" required class="input-xxlarge tight-form-input last" placeholder="organization name">\n					</li>\n					<li>\n					</li>\n				</ul>\n				<div class="clearfix"></div>\n			</div>\n			<br>\n			<button class="btn btn-success pull-right" ng-click="createOrg()">Create</button>\n		</form>\n\n	</div>\n</div>\n\n'),a.put("app/features/org/partials/orgApiKeys.html",'<topnav icon="fa fa-fw fa-users" title="Organization" subnav="true">\n	<ul class="nav">\n		<li class="active"><a href="org/apikeys">API Keys</a></li>\n	</ul>\n</topnav>\n\n<div class="page-container">\n	<div class="page">\n\n		<h2>\n			API Keys\n		</h2>\n\n		<form name="addTokenrForm" class="form-inline tight-form last">\n			<ul class="tight-form-list">\n				<li class="tight-form-item" style="width: 100px">\n					Add a key\n				</li>\n				<li>\n					<input type="text" class="input-xlarge tight-form-input" ng-model=\'token.name\' placeholder="Name"></input>\n				</li>\n				<li class="tight-form-item">\n					Role\n				</li>\n				<li>\n					<select class="input-small tight-form-input" ng-model="token.role" ng-options="r for r in roleTypes"></select>\n				</li>\n				<li style="float: right">\n					<button class="btn btn-success tight-form-btn" ng-click="addToken()">Add</button>\n				</li>\n				<div class="clearfix"></div>\n			</ul>\n		</form>\n\n		<table class="grafana-options-table" style="width: 250px">\n			<tr>\n				<th style="text-align: left">Name</th>\n				<th style="text-align: left">Role</th>\n				<th></th>\n			</tr>\n			<tr ng-repeat="t in tokens">\n				<td>{{t.name}}</td>\n				<td>{{t.role}}</td>\n				<td style="width: 1%">\n					<a ng-click="removeToken(t.id)" class="btn btn-danger btn-mini">\n						<i class="fa fa-remove"></i>\n					</a>\n				</td>\n			</tr>\n		</table>\n	</div>\n\n</div>\n\n\n'),a.put("app/features/org/partials/orgDetails.html",'<topnav icon="fa fa-fw fa-users" title="Organization" subnav="true">\n	<ul class="nav">\n		<li class="active"><a href="org">Info</a></li>\n	</ul>\n</topnav>\n\n<div class="page-container">\n	<div class="page">\n\n		<h2>Organization</h2>\n\n		<div class="tight-form-section">\n			<h5>Info</h5>\n\n			<form name="orgForm">\n				<div class="tight-form last">\n					<ul class="tight-form-list">\n						<li class="tight-form-item" style="width: 100px">\n							Org. name\n						</li>\n						<li>\n							<input type="text" required ng-model="org.name" class="tight-form-input last" style="width: 475px">\n						</li>\n					</ul>\n					<div class="clearfix"></div>\n				</div>\n\n				<br>\n				<button type="submit" class="pull-right btn btn-success" ng-click="update()">Update</button>\n			</form>\n		</div>\n\n		<div class="tight-form-section">\n			<h5>Address</h5>\n\n			<form name="addressForm">\n				<div class="tight-form">\n					<ul class="tight-form-list">\n						<li class="tight-form-item" style="width: 100px">\n							Address 1\n						</li>\n						<li>\n							<input type="text" ng-model="address.address1" class="tight-form-input" style="width:193px">\n						</li>\n						<li class="tight-form-item" style="width: 75px">\n							Address 2\n						</li>\n						<li>\n							<input type="text" ng-model="address.address2" class="tight-form-input last" style="width:193px">\n						</li>\n					</ul>\n					<div class="clearfix"></div>\n				</div>\n				<div class="tight-form">\n					<ul class="tight-form-list">\n						<li class="tight-form-item" style="width: 100px">\n							City\n						</li>\n						<li>\n							<input type="text" ng-model="address.city" class="tight-form-input" style="width: 193px">\n						</li>\n						<li class="tight-form-item" style="width: 75px">\n							Postal code\n						</li>\n						<li>\n							<input type="text" ng-model="address.zipCode" class="input-medium tight-form-input last" style="width: 193px">\n						</li>\n					</ul>\n					<div class="clearfix"></div>\n				</div>\n				<div class="tight-form last">\n					<ul class="tight-form-list">\n						<li class="tight-form-item" style="width: 100px">\n							State\n						</li>\n						<li>\n							<input type="text" ng-model="address.state" class="tight-form-input" style="width: 193px">\n						</li>\n						<li class="tight-form-item" style="width: 75px">\n							Country\n						</li>\n						<li>\n							<input type="text" ng-model="address.country" class="tight-form-input last" style="width: 193px">\n						</li>\n					</ul>\n					<div class="clearfix"></div>\n				</div>\n\n				<br>\n				<button type="submit" class="pull-right btn btn-success" ng-click="updateAddress()">Update</button>\n\n			</form>\n		</div>\n\n	</div>\n</div>\n\n\n'),a.put("app/features/org/partials/orgUsers.html",'<topnav title="Organization" icon="fa fa-fw fa-users" subnav="true">\n	<ul class="nav">\n		<li class="active"><a href="org/users">Users</a></li>\n	</ul>\n</topnav>\n\n<div class="page-container">\n	<div class="page">\n\n		<h2>Organization users</h2>\n\n		<button class="btn btn-success pull-right" ng-click="openInviteModal()">\n			<i class="fa fa-plus"></i>\n			Add or Invite\n		</button>\n\n		<br>\n\n		<tabset>\n			<tab heading="Users ({{users.length}})">\n				<table class="grafana-options-table form-inline">\n					<tr>\n						<th>Login</th>\n						<th>Email</th>\n						<th>Role</th>\n						<th></th>\n					</tr>\n					<tr ng-repeat="user in users">\n						<td>{{user.login}}</td>\n						<td>{{user.email}}</td>\n						<td>\n							<select type="text" ng-model="user.role" class="input-medium" ng-options="f for f in [\'Viewer\', \'Editor\', \'Read Only Editor\', \'Admin\']" ng-change="updateOrgUser(user)">\n							</select>\n						</td>\n						<td style="width: 1%">\n							<a ng-click="removeUser(user)" class="btn btn-danger btn-mini">\n								<i class="fa fa-remove"></i>\n							</a>\n						</td>\n					</tr>\n				</table>\n			</tab>\n			<tab heading="Pending Invitations ({{pendingInvites.length}})">\n				<div class="grafana-list-item" ng-repeat="invite in pendingInvites" ng-click="invite.expanded = !invite.expanded">\n					{{invite.email}}\n					<span ng-show="invite.name" style="padding-left: 20px"> {{invite.name}}</span>\n					<span class="pull-right">\n						<button class="btn btn-inverse btn-mini " data-clipboard-text="{{invite.url}}" clipboard-button ng-click="copyInviteToClipboard($event)"\n							<i class="fa fa-clipboard"></i> Copy Invite\n						</button>\n						&nbsp;\n						<a class="pointer">\n							<i ng-show="!invite.expanded" class="fa fa-caret-right"></i>\n							<i ng-show="invite.expanded" class="fa fa-caret-down"></i>\n						</a>\n					</span>\n					<div ng-show="invite.expanded">\n						<a href="{{invite.url}}">{{invite.url}}</a><br>\n						<button class="btn btn-inverse btn-mini">\n							<i class="fa fa-envelope-o"></i> Resend invite\n						</button>\n						&nbsp;\n						<button class="btn btn-inverse btn-mini" ng-click="revokeInvite(invite, $event)">\n							<i class="fa fa-remove" style="color: red"></i> Revoke invite\n						</button>\n						<span style="padding-left: 15px">\n							Invited: <em> {{invite.createdOn | date: \'shortDate\'}} by {{invite.invitedBy}} </em>\n						</span>\n					<div>\n				</div>\n			</tab>\n		</tabset>\n\n	</div>\n</div>\n\n'),a.put("app/features/panel/partials/panel.html",'<div class="panel-container" ng-class="{\'panel-transparent\': panel.transparent}">\n	<div class="panel-header">\n		<span class="alert-error panel-error small pointer" config-modal="app/partials/inspector.html" ng-if="panelMeta.error">\n			<span data-placement="top" bs-tooltip="panelMeta.error">\n				<i class="fa fa-exclamation"></i><span class="panel-error-arrow"></span>\n			</span>\n		</span>\n\n		<span class="panel-loading" ng-show="panelMeta.loading">\n			<i class="fa fa-spinner fa-spin"></i>\n		</span>\n\n		<div class="panel-title-container drag-handle" panel-menu></div>\n	</div>\n\n	<div class="panel-content">\n		<ng-transclude></ng-transclude>\n	</div>\n	<panel-resizer></panel-resizer>\n</div>\n\n<div class="panel-full-edit" ng-if="editMode">\n	<div class="gf-box">\n		<div class="gf-box-header">\n			<div class="gf-box-title">\n				<i ng-class="panelMeta.editIcon"></i>\n				{{panelMeta.panelName}}\n			</div>\n\n			<div ng-model="editor.index" bs-tabs>\n				<div ng-repeat="tab in panelMeta.editorTabs" data-title="{{tab.title}}">\n				</div>\n			</div>\n\n			<button class="gf-box-header-close-btn" ng-click="exitFullscreen();">\n				Back to dashboard\n			</button>\n		</div>\n\n		<div class="gf-box-body">\n			<div ng-repeat="tab in panelMeta.editorTabs" ng-if="editor.index === $index">\n				<div ng-include src="tab.src"></div>\n			</div>\n		</div>\n	</div>\n</div>\n\n'),a.put("app/features/panel/partials/panelTime.html",'<div class="editor-row">\n	<div class="section tight-form-container" style="margin-bottom: 20px">\n		<div class="tight-form">\n			<ul class="tight-form-list">\n				<li class="tight-form-item tight-form-item-icon">\n					<i class="fa fa-clock-o"></i>\n				</li>\n				<li class="tight-form-item" style="width: 178px">\n					<strong>Override relative time</strong>\n				</li>\n				<li class="tight-form-item" style="width: 50px">\n					Last\n				</li>\n				<li>\n					<input type="text" class="input-small tight-form-input last" placeholder="1h"\n					  empty-to-null ng-model="panel.timeFrom" valid-time-span\n					  ng-change="get_data()" ng-model-onblur>\n				</li>\n			</ul>\n			<div class="clearfix"></div>\n		</div>\n		<div class="tight-form">\n			<ul class="tight-form-list">\n				<li class="tight-form-item tight-form-item-icon">\n					<i class="fa fa-clock-o"></i>\n				</li>\n				<li class="tight-form-item" style="width: 178px">\n					<strong>Add time shift</strong>\n				</li>\n				<li class="tight-form-item" style="width: 50px">\n					Amount\n				</li>\n				<li>\n					<input type="text" class="input-small tight-form-input last" placeholder="1h"\n					empty-to-null ng-model="panel.timeShift" valid-time-span\n					ng-change="get_data()" ng-model-onblur>\n				</li>\n			</ul>\n			<div class="clearfix"></div>\n		</div>\n		<div class="tight-form">\n			<ul class="tight-form-list">\n				<li class="tight-form-item tight-form-item-icon">\n					<i class="fa fa-clock-o"></i>\n				</li>\n				<li class="tight-form-item" style="width: 178px">\n					<strong>Hide time override info</strong>\n				</li>\n				<li class="tight-form-item last">\n					<input class="cr1" id="panel.hideTimeOverride" type="checkbox"\n					ng-model="panel.hideTimeOverride" ng-checked="panel.hideTimeOverride" ng-change="get_data()">\n					<label for="panel.hideTimeOverride" class="cr1"></label>\n				</li>\n			</ul>\n			<div class="clearfix"></div>\n		</div>\n	</div>\n</div>\n\n'),
a.put("app/features/panel/partials/soloPanel.html",'<div class="container-fluid main">\n	<div class="row-fluid">\n		<div class="span12">\n			<div class="panel nospace" ng-if="panel" style="width: 100%">\n				<panel-loader type="panel.type" ng-cloak></panel-loader>\n			</div>\n		</div>\n</div>\n'),a.put("app/features/panellinks/module.html",'<div class="editor-row">\n  <div class="section">\n		<h5>Drilldown / detail link<tip>These links appear in the dropdown menu in the panel menu. </tip></h5>\n\n		<div ng-repeat="link in panel.links" style="margin-top: 20px;">\n			<div class="tight-form">\n				<ul class="tight-form-list pull-right">\n					<li class="tight-form-item">\n						<i ng-click="moveLink($index, -1)" ng-hide="$first" class="pointer fa fa-arrow-up"></i>\n						<i ng-click="moveLink($index, 1)" ng-hide="$last" class="pointer fa fa-fw fa-arrow-down"></i>\n					</li>\n					<li class="tight-form-item last">\n						<i class="fa fa-remove pointer" ng-click="deleteLink(link)"></i>\n					</li>\n				</ul>\n\n				<ul class="tight-form-list">\n					<li class="tight-form-item" style="width: 20px">\n						<i class="fa fa-fw fa-unlink"></i>\n					</li>\n\n					<li class="tight-form-item">Type</li>\n					<li>\n						<select class="input-medium tight-form-input" style="width: 150px;" ng-model="link.type" ng-options="f for f in [\'dashboard\',\'absolute\']"></select>\n					</li>\n\n					<li class="tight-form-item" ng-show="link.type === \'dashboard\'" style="width: 73px;">Dashboard</li>\n					<li ng-show="link.type === \'dashboard\'">\n						<input type="text" ng-model="link.dashboard" bs-typeahead="searchDashboards" class="input-large tight-form-input" ng-blur="dashboardChanged(link)">\n					</li>\n\n					<li class="tight-form-item" ng-show="link.type === \'absolute\'" style="width: 73px;">Url</li>\n					<li ng-show="link.type === \'absolute\'">\n						<input type="text" ng-model="link.url" class="input-large tight-form-input">\n					</li>\n\n				</ul>\n				<div class="clearfix"></div>\n			</div>\n\n			<div class="tight-form">\n				<ul class="tight-form-list">\n					<li class="tight-form-item" style="width: 20px">\n						<i class="fa fa-fw fa-unlink invisible"></i>\n					</li>\n					<li class="tight-form-item" style="width: 31px">Title</li>\n					<li>\n						<input type="text" ng-model="link.title" class="input-medium tight-form-input">\n					</li>\n					<li class="tight-form-item" style="width: 73px;">\n						Url params\n					</li>\n					<li>\n						<input type="text" ng-model="link.params" class="input-large tight-form-input">\n					</li>\n				</ul>\n				<div class="clearfix"></div>\n			</div>\n			<div class="tight-form last">\n				<ul class="tight-form-list">\n					<li class="tight-form-item" style="width: 20px">\n						<i class="fa fa-fw fa-unlink invisible"></i>\n					</li>\n					<li class="tight-form-item">\n						<editor-checkbox text="Keep current time range" model="link.keepTime"></editor-checkbox>\n					</li>\n					<li class="tight-form-item">\n						<editor-checkbox text="Add current variable values" model="link.includeVars"></editor-checkbox>\n					</li>\n					<li class="tight-form-item last">\n						<editor-checkbox text="Open in new tab " model="link.targetBlank"></editor-checkbox>\n					</li>\n				</ul>\n				<div class="clearfix"></div>\n			</div>\n		</div>\n\n	</div>\n</div>\n\n<div class="editor-row">\n	<br>\n	<button class="btn btn-inverse" ng-click="addLink()"><i class="fa fa-plus"></i> Add link</button>\n</div>\n'),a.put("app/features/profile/partials/password.html",'<topnav title="{{contextSrv.user.name}}" section="Profile" icon="fa fa-user" subnav="true">\n	<ul class="nav">\n		<li><a href="profile">Overview</a></li>\n		<li class="active"><a href="profile/password">Change password</a></li>\n	</ul>\n</topnav>\n\n<div class="page-container">\n	<div class="page">\n\n		<h2>Change password</h2>\n\n		<form name="userForm">\n			<div>\n				<div class="tight-form">\n					<ul class="tight-form-list">\n						<li class="tight-form-item" style="width: 100px">\n							<strong>Old Password</strong>\n						</li>\n						<li>\n							<input type="password" required ng-model="command.oldPassword" class="input-xxlarge tight-form-input last" >\n						</li>\n					</ul>\n					<div class="clearfix"></div>\n				</div>\n				<div class="tight-form" style="margin-top: 5px">\n					<ul class="tight-form-list">\n						<li class="tight-form-item" style="width: 100px">\n							<strong>New Password</strong>\n						</li>\n						<li>\n							<input type="password" required ng-model="command.newPassword" ng-minlength="4" class="input-xxlarge tight-form-input last" >\n						</li>\n					</ul>\n					<div class="clearfix"></div>\n				</div>\n				<div class="tight-form" style="margin-top: 5px">\n					<ul class="tight-form-list">\n						<li class="tight-form-item" style="width: 100px">\n							<strong>Confirm New</strong>\n						</li>\n						<li>\n							<input type="password" required ng-model="command.confirmNew" ng-minlength="4" class="input-xxlarge tight-form-input last" >\n						</li>\n					</ul>\n					<div class="clearfix"></div>\n				</div>\n			</div>\n\n			<br>\n			<button type="submit" class="pull-right btn btn-success" ng-click="changePassword()">Change Password</button>\n		</form>\n\n	</div>\n</div>\n\n'),a.put("app/features/profile/partials/profile.html",'<topnav title="{{contextSrv.user.name}}" section="Profile" icon="fa fa-fw fa-user" subnav="true">\n	<ul class="nav">\n		<li class="active"><a href="profile">Overview</a></li>\n		<li><a href="profile/password">Change password</a></li>\n	</ul>\n</topnav>\n\n<div class="page-container">\n	<div class="page">\n\n		<h2>Profile</h2>\n\n		<form name="userForm">\n			<div class="tight-form">\n				<ul class="tight-form-list">\n					<li class="tight-form-item" style="width: 100px">\n						Name\n					</li>\n					<li>\n						<input type="text" required ng-model="user.name" class="input-xxlarge tight-form-input last" >\n					</li>\n				</ul>\n				<div class="clearfix"></div>\n			</div>\n			<div class="tight-form">\n				<ul class="tight-form-list">\n					<li class="tight-form-item" style="width: 100px">\n						Email\n					</li>\n					<li>\n						<input type="email" required ng-model="user.email" class="input-xxlarge tight-form-input last" >\n					</li>\n				</ul>\n				<div class="clearfix"></div>\n			</div>\n			<div class="tight-form">\n				<ul class="tight-form-list">\n					<li class="tight-form-item" style="width: 100px">\n						Username\n					</li>\n					<li>\n						<input type="text" required ng-model="user.login" class="input-xxlarge tight-form-input last" >\n					</li>\n				</ul>\n				<div class="clearfix"></div>\n			</div>\n\n			<div class="tight-form last">\n				<ul class="tight-form-list">\n					<li class="tight-form-item" style="width: 100px">\n						UI Theme\n					</li>\n					<li>\n						<select class="input-small tight-form-input" ng-model="user.theme" ng-options="f for f in [\'dark\', \'light\']"></select>\n					</li>\n				</ul>\n				<div class="clearfix"></div>\n			</div>\n			<br>\n			<button type="submit" class="pull-right btn btn-success" ng-click="update()">Update</button>\n		</form>\n\n		<h3>Organizations</h3>\n\n		<table class="grafana-options-table">\n			<tr ng-repeat="org in orgs">\n				<td style="width: 98%"><strong>Name: </strong> {{org.name}}</td>\n				<td><strong>Role: </strong> {{org.role}}</td>\n				<td class="nobg max-width-btns">\n					<span class="btn btn-primary btn-mini" ng-show="org.orgId === contextSrv.user.orgId">\n						Current\n					</span>\n					<a ng-click="setUsingOrg(org)" class="btn btn-inverse btn-mini" ng-show="org.orgId !== contextSrv.user.orgId">\n						Select\n					</a>\n				</td>\n			</tr>\n		</table>\n\n	</div>\n</div>\n\n'),a.put("app/features/profile/partials/select_org.html",'<div class="container">\n\n	<div class="signup-page-background">\n	</div>\n\n	<div class="login-box">\n\n		<div class="login-box-logo">\n			<img src="img/logo_transparent_200x75.png">\n		</div>\n\n    <div class="invite-box">\n			<h3>\n				<i class="fa fa-users"></i>&nbsp;\n				Change active organization\n			</h3>\n\n			<div class="modal-tagline">\n				You have been added to another Organization <br>\n				due to an open invitation!\n				<br><br>\n\n				Please select which organization you want to <br>\n				use right now (you can change this later at any time).\n			</div>\n\n			<div style="display: inline-block; width: 400px; margin: 30px 0">\n				<table class="grafana-options-table">\n					<tr ng-repeat="org in orgs">\n						<td class="nobg max-width-btns">\n							<a ng-click="setUsingOrg(org)" class="btn btn-inverse">\n								{{org.name}} ({{org.role}})\n							</a>\n						</td>\n					</tr>\n				</table>\n			</div>\n\n		</div>\n\n\n		<div class="row" style="margin-top: 50px">\n			<div class="version-footer text-center small">\n				Grafana version: {{buildInfo.version}}, commit: {{buildInfo.commit}},\n				build date: {{buildInfo.buildstamp | date: \'yyyy-MM-dd HH:mm:ss\' }}\n			</div>\n		</div>\n\n	</div>\n\n</div>\n\n\n'),a.put("app/features/templating/partials/editor.html",'<div ng-controller="TemplateEditorCtrl" ng-init="init()">\n	<div class="gf-box-header">\n		<div class="gf-box-title">\n			<i class="fa fa-code"></i>\n			Templating\n		</div>\n\n		<div class="tabs">\n			<ul class="nav nav-tabs">\n				<li ng-class="{active: mode === \'list\'}">\n					<a ng-click="mode = \'list\';">\n						Variables\n					</a>\n				</li>\n\n				<li ng-class="{active: mode === \'edit\'}" ng-show="mode === \'edit\'">\n					<a>\n						{{current.name}}\n					</a>\n				</li>\n\n				<li ng-class="{active: mode === \'new\'}">\n					<a ng-click="mode = \'new\';">\n						<i class="fa fa-plus"></i>\n						New\n					</a>\n				</li>\n			</ul>\n		</div>\n\n		<button class="gf-box-header-close-btn" ng-click="dismiss();dashboard.refresh();">\n			<i class="fa fa-remove"></i>\n		</button>\n\n	</div>\n\n	<div class="gf-box-body">\n\n		<div ng-if="mode === \'list\'">\n\n			<div class="editor-row row">\n				<div class="span8">\n					<div ng-if="variables.length === 0">\n						<em>No template variables defined</em>\n					</div>\n					<table class="grafana-options-table">\n						<tr ng-repeat="variable in variables">\n							<td style="width: 1%">\n								<span class="template-variable">\n									${{variable.name}}\n								</span>\n							</td>\n							<td class="max-width" style="max-width: 200px;">\n								{{variable.query}}\n							</td>\n							<td style="width: 1%">\n								<a ng-click="edit(variable)" class="btn btn-inverse btn-small">\n									<i class="fa fa-edit"></i>\n									Edit\n								</a>\n							</td>\n							<td style="width: 1%"><i ng-click="_.move(variables,$index,$index-1)" ng-hide="$first" class="pointer fa fa-arrow-up"></i></td>\n							<td style="width: 1%"><i ng-click="_.move(variables,$index,$index+1)" ng-hide="$last" class="pointer fa fa-arrow-down"></i></td>\n							<td style="width: 1%">\n								<a ng-click="removeVariable(variable)" class="btn btn-danger btn-small">\n									<i class="fa fa-remove"></i>\n								</a>\n							</td>\n						</tr>\n					</table>\n				</div>\n			</div>\n		</div>\n\n		<div ng-if="mode === \'edit\' || mode === \'new\'">\n			<div class="editor-row">\n				<div class="tight-form-section">\n					<h5>Variable</h5>\n					<div class="tight-form last">\n						<ul class="tight-form-list">\n							<li class="tight-form-item" style="width: 100px">\n								Name\n							</li>\n							<li>\n								<input type="text" class="input-large tight-form-input" placeholder="name" ng-model=\'current.name\'></input>\n							</li>\n							<li class="tight-form-item">\n								Type\n							</li>\n							<li>\n								<select class="input-small tight-form-input" ng-model="current.type" ng-options="f for f in [\'query\', \'interval\', \'custom\']" ng-change="typeChanged()"></select>\n							</li>\n							<li class="tight-form-item" ng-show="current.type === \'query\'">\n								Data source\n							</li>\n							<li ng-show="current.type === \'query\'">\n								<select class="input input-medium tight-form-input last" ng-model="current.datasource" ng-options="f.value as f.name for f in datasources"></select>\n							</li>\n						</ul>\n						<div class="clearfix"></div>\n					</div>\n				</div>\n			</div>\n\n			<div class="editor-row">\n				<div class="tight-form-section">\n					<h5>Value Options</h5>\n\n					<div ng-show="current.type === \'interval\'">\n						<div class="tight-form">\n							<ul class="tight-form-list">\n								<li class="tight-form-item" style="width: 160px">\n									Values\n								</li>\n								<li>\n									<input type="text" style="width: 345px" class="input-xxlarge tight-form-input last" placeholder="name" ng-model=\'current.query\' placeholder="1m,10m,1h,6h,1d,7d" ng-model-onblur ng-change="runQuery()"></input>\n								</li>\n							</ul>\n							<div class="clearfix"></div>\n						</div>\n						<div class="tight-form last">\n							<ul class="tight-form-list">\n								<li class="tight-form-item" style="width: 160px">\n									<editor-checkbox text="Include auto interval" model="current.auto" change="runQuery()"></editor-checkbox>\n								</li>\n								<li class="tight-form-item" ng-show="current.auto">\n									Auto interval steps <tip>How many steps, roughly, the interval is rounded and will not always match this count<tip>\n								</li>\n								<li>\n									<select class="input-mini tight-form-input last" ng-model="current.auto_count" ng-options="f for f in [3,5,10,30,50,100,200]" ng-change="runQuery()"></select>\n								</li>\n							</ul>\n							<div class="clearfix"></div>\n						</div>\n					</div>\n\n					<div ng-show="current.type === \'custom\'">\n						<div class="tight-form last">\n							<ul class="tight-form-list">\n								<li class="tight-form-item" style="width: 180px">\n									Values seperated by comma\n								</li>\n								<li>\n									<input type="text" class="input tight-form-input last" style="width: 325px;" ng-model=\'current.query\' ng-blur="runQuery()" placeholder="1, 10, 20, myvalue"></input>\n								</li>\n							</ul>\n							<div class="clearfix"></div>\n						</div>\n					</div>\n\n					<div ng-show="current.type === \'query\'">\n\n						<div class="tight-form">\n							<ul class="tight-form-list">\n								<li class="tight-form-item" style="width: 100px">\n									Query\n								</li>\n								<li>\n									<input type="text" style="width: 588px" class="input-xxlarge tight-form-input last" ng-model=\'current.query\' placeholder="metric name or tags query" ng-model-onblur ng-change="runQuery()"></input>\n								</li>\n							</ul>\n							<div class="clearfix"></div>\n						</div>\n						<div class="tight-form">\n							<ul class="tight-form-list">\n								<li class="tight-form-item" style="width: 100px;">\n									Regex\n									<tip>Optional, if you want to extract part of a series name or metric node segment</tip>\n								</li>\n								<li>\n									<input type="text" style="width: 588px" class="input tight-form-input last" ng-model=\'current.regex\' placeholder="/.*-(.*)-.*/" ng-model-onblur ng-change="runQuery()"></input>\n								</li>\n							</ul>\n							<div class="clearfix"></div>\n						</div>\n\n						<div class="tight-form">\n							<ul class="tight-form-list">\n								<li class="tight-form-item" style="width: 100px;">\n									<editor-checkbox text="All value" model="current.includeAll" change="runQuery()"></editor-checkbox>\n								</li>\n								<li ng-show="current.includeAll">\n									<input type="text" class="input-xlarge tight-form-input" style="width:364px" ng-model=\'current.options[0].value\'></input>\n								</li>\n								<li class="tight-form-item" ng-show="current.includeAll">\n									All format\n								</li>\n								<li ng-show="current.includeAll">\n									<select class="input-medium tight-form-input last" ng-model="current.allFormat" ng-change="runQuery()" ng-options="f for f in [\'glob\', \'wildcard\', \'regex wildcard\', \'regex values\', \'lucene\', \'pipe\']"></select>\n								</li>\n							</ul>\n							<div class="clearfix"></div>\n						</div>\n\n						<div class="tight-form last">\n							<ul class="tight-form-list">\n								<li class="tight-form-item last">\n									<editor-checkbox text="Refresh on load" model="current.refresh"></editor-checkbox>\n									<tip>Check if you want values to be updated on dashboard load, will slow down dashboard load time</tip>\n								</li>\n							</ul>\n							<div class="clearfix"></div>\n						</div>\n					</div>\n				</div>\n			</div>\n\n			<div class="editor-row">\n				<div class="tight-form-section" ng-hide="current.type === \'interval\'">\n					<h5>Multi-value selection <tip>Enables multiple values to be selected at the same time</tip></h5>\n					<div class="tight-form last">\n						<ul class="tight-form-list">\n							<li class="tight-form-item last" style="width: 100px;">\n								<editor-checkbox text="Enable" model="current.multi" change="runQuery()"></editor-checkbox>\n							</li>\n							<li class="tight-form-item" ng-show="current.multi">\n								Multi format\n							</li>\n							<li ng-show="current.multi">\n								<select class="input-medium tight-form-input last" ng-model="current.multiFormat" ng-change="runQuery()" ng-options="f for f in [\'glob\', \'regex values\', \'lucene\', \'pipe\']"></select>\n							</li>\n						</ul>\n						<div class="clearfix"></div>\n					</div>\n				</div>\n\n				<div class="tight-form-section">\n					<h5>Display options</h5>\n					<div class="tight-form last">\n						<ul class="tight-form-list">\n							<li class="tight-form-item" style="width: 100px">\n								Variable Label\n							</li>\n							<li>\n								<input type="text" class="input-medium tight-form-input" ng-model=\'current.label\' placeholder=""></input>\n							</li>\n							<li class="tight-form-item last">\n								<editor-checkbox text="Hide label" model="current.hideLabel" change="runQuery()"></editor-checkbox>\n							</li>\n						</ul>\n						<div class="clearfix"></div>\n					</div>\n				</div>\n			</div>\n\n			<div class="editor-row" ng-if="current.type === \'query\'">\n				<div class="tight-form-section">\n					<h5>Value groups/tags (Experimental feature)</h5>\n					<div class="tight-form last" ng-if="current.useTags">\n						<ul class="tight-form-list">\n							<li class="tight-form-item" style="width: 135px">\n								Tags query\n							</li>\n							<li>\n								<input type="text" style="width: 588px" class="input-xxlarge tight-form-input last" ng-model=\'current.tagsQuery\' placeholder="metric name or tags query" ng-model-onblur></input>\n							</li>\n						</ul>\n						<div class="clearfix"></div>\n					</div>\n					<div class="tight-form" ng-if="current.useTags">\n						<ul class="tight-form-list">\n							<li class="tight-form-item" style="width: 135px;">\n								Tag values query\n							</li>\n							<li>\n								<input type="text" style="width: 588px" class="input tight-form-input last" ng-model=\'current.tagValuesQuery\' placeholder="apps.$tag.*" ng-model-onblur></input>\n							</li>\n						</ul>\n						<div class="clearfix"></div>\n					</div>\n					<div class="tight-form">\n						<ul class="tight-form-list">\n							<li class="tight-form-item last">\n								<editor-checkbox text="Enable" model="current.useTags" change="runQuery()"></editor-checkbox>\n							</li>\n						</ul>\n						<div class="clearfix"></div>\n					</div>\n				</div>\n			</div>\n\n			<div class="editor-row">\n				<div class="tight-form-section">\n					<h5>Preview of values (shows max 20)</h5>\n					<div class="tight-form last">\n						<ul class="tight-form-list">\n							<li class="tight-form-item" ng-repeat="option in current.options | limitTo: 20">\n								{{option.text}}\n							</li>\n						</ul>\n						<div class="clearfix"></div>\n					</div>\n				</div>\n			</div>\n		</div>\n\n		<div class="editor-row" style="margin-top: 20px">\n			<button type="button" class="btn btn-success" ng-show="mode === \'edit\'" ng-click="update();">Update</button>\n			<button type="button" class="btn btn-success" ng-show="mode === \'new\'" ng-click="add();">Add</button>\n		</div>\n\n	</div>\n</div>\n\n'),a.put("app/panels/dashlist/editor.html",'<div class="editor-row"><div class="section" style="margin-bottom: 20px"><div class="tight-form last"><ul class="tight-form-list"><li class="tight-form-item" style="width: 110px"><strong>Mode</strong></li><li><select class="input-small tight-form-input last" ng-model="panel.mode" ng-options="f for f in modes" ng-change="get_data()"></select></li></ul><div class="clearfix"></div></div></div><div class="section" style="margin-bottom: 20px" ng-if="panel.mode === \'search\'"><div class="tight-form last"><ul class="tight-form-list"><li class="tight-form-item" style="width: 110px"><strong>Search options</strong></li><li class="tight-form-item">Query</li><li><input type="text" class="input-medium tight-form-input" placeholder="title query" ng-model="panel.query" ng-change="get_data()" ng-model-onblur=""></li><li class="tight-form-item">Tags</li><li><bootstrap-tagsinput ng-model="panel.tags" tagclass="label label-tag" placeholder="add tags" on-tags-updated="get_data()"></bootstrap-tagsinput></li></ul><div class="clearfix"></div></div></div></div><div class="editor-row"><div class="section" style="margin-bottom: 20px"><div class="tight-form last"><ul class="tight-form-list"><li class="tight-form-item" style="width: 110px"><strong>Limit number to</strong></li><li><input class="input-small tight-form-input last" type="number" ng-model="panel.limit" ng-model-onblur="" ng-change="get_data()"></li></ul><div class="clearfix"></div></div></div></div>'),a.put("app/panels/dashlist/module.html",'<grafana-panel><div class="dashlist"><div class="dashlist-item" ng-repeat="dash in dashList"><a class="dashlist-link dashlist-link-{{dash.type}}" href="dashboard/{{dash.uri}}"><span class="dashlist-title">{{dash.title}}</span> <span class="dashlist-star"><i class="fa" ng-class="{\'fa-star\': dash.isStarred, \'fa-star-o\': !dash.isStarred}"></i></span></a></div></div></grafana-panel>'),a.put("app/panels/graph/axisEditor.html",'<div class="editor-row"><div class="section" style="margin-bottom: 20px"><div class="tight-form"><ul class="tight-form-list"><li class="tight-form-item" style="width: 80px">Left Y</li><li class="tight-form-item">Unit</li><li class="dropdown" style="width: 140px" ng-model="panel.y_formats[0]" dropdown-typeahead="unitFormats" dropdown-typeahead-on-select="setUnitFormat(0, $subItem)"></li><li class="tight-form-item">&nbsp;&nbsp; Grid Max</li><li><input type="number" class="input-small tight-form-input" placeholder="auto" empty-to-null="" ng-model="panel.grid.leftMax" ng-change="render()" ng-model-onblur=""></li><li class="tight-form-item">Min</li><li><input type="number" class="input-small tight-form-input" placeholder="auto" empty-to-null="" ng-model="panel.grid.leftMin" ng-change="render()" ng-model-onblur=""></li><li class="tight-form-item">Scale type</li><li><select class="input-small tight-form-input" style="width: 113px" ng-model="panel.grid.leftLogBase" ng-options="v as k for (k, v) in logScales" ng-change="render()"></select></li><li class="tight-form-item">Label</li><li><input type="text" class="input-small tight-form-input last" ng-model="panel.leftYAxisLabel" ng-change="render()" ng-model-onblur=""></li></ul><div class="clearfix"></div></div><div class="tight-form last"><ul class="tight-form-list"><li class="tight-form-item" style="width: 80px">Right Y</li><li class="tight-form-item">Unit</li><li class="dropdown" style="width: 140px" ng-model="panel.y_formats[1]" dropdown-typeahead="unitFormats" dropdown-typeahead-on-select="setUnitFormat(1, $subItem)"></li><li class="tight-form-item">&nbsp;&nbsp; Grid Max</li><li><input type="number" class="input-small tight-form-input" placeholder="auto" empty-to-null="" ng-model="panel.grid.rightMax" ng-change="render()" ng-model-onblur=""></li><li class="tight-form-item">Min</li><li><input type="number" class="input-small tight-form-input" placeholder="auto" empty-to-null="" ng-model="panel.grid.rightMin" ng-change="render()" ng-model-onblur=""></li><li class="tight-form-item">Scale type</li><li><select class="input-small tight-form-input" style="width: 113px" ng-model="panel.grid.rightLogBase" ng-options="v as k for (k, v) in logScales" ng-change="render()"></select></li><li class="tight-form-item">Label</li><li><input type="text" class="input-small tight-form-input last" ng-model="panel.rightYAxisLabel" ng-change="render()" ng-model-onblur=""></li></ul><div class="clearfix"></div></div></div><div class="section" style="margin-bottom: 20px"><div class="tight-form"><ul class="tight-form-list"><li class="tight-form-item" style="width: 80px">Show Axis</li><li class="tight-form-item">X-Axis&nbsp;<input class="cr1" id="hideXAxis" type="checkbox" ng-model="panel[\'x-axis\']" ng-checked="panel[\'x-axis\']" ng-change="render()"><label for="hideXAxis" class="cr1"></label></li><li class="tight-form-item last">Y-Axis&nbsp;<input class="cr1" id="hideYAxis" type="checkbox" ng-model="panel[\'y-axis\']" ng-checked="panel[\'y-axis\']" ng-change="render()"><label for="hideYAxis" class="cr1"></label></li></ul><div class="clearfix"></div></div><div class="tight-form last"><ul class="tight-form-list"><li class="tight-form-item" style="width: 80px">Thresholds</li><li class="tight-form-item">Level 1</li><li><input type="number" class="input-small tight-form-input" ng-model="panel.grid.threshold1" ng-change="render()" ng-model-onblur=""></li><li class="tight-form-item"><spectrum-picker ng-model="panel.grid.threshold1Color" ng-change="render()"></spectrum-picker></li><li class="tight-form-item">Level 2</li><li><input type="number" class="input-small tight-form-input" ng-model="panel.grid.threshold2" ng-change="render()" ng-model-onblur=""></li><li class="tight-form-item"><spectrum-picker ng-model="panel.grid.threshold2Color" ng-change="render()"></spectrum-picker></li><li class="tight-form-item last"><editor-checkbox text="Line mode" model="panel.grid.thresholdLine" change="render()"></editor-checkbox></li></ul><div class="clearfix"></div></div></div></div><div class="editor-row"><div class="section"><div class="tight-form last"><ul class="tight-form-list"><li class="tight-form-item" style="width: 110px">Legend</li><li class="tight-form-item"><editor-checkbox text="Show" model="panel.legend.show" change="get_data()"></editor-checkbox></li><li class="tight-form-item"><editor-checkbox text="Table" model="panel.legend.alignAsTable" change="render()"></editor-checkbox></li><li class="tight-form-item"><editor-checkbox text="Right side" model="panel.legend.rightSide" change="render()"></editor-checkbox></li><li class="tight-form-item last"><editor-checkbox text="Hide empty" model="panel.legend.hideEmpty" change="render()"></editor-checkbox></li></ul><div class="clearfix"></div></div></div><div class="section"><div class="tight-form"><ul class="tight-form-list"><li class="tight-form-item" style="width: 105px">Legend values</li><li class="tight-form-item"><editor-checkbox text="Min" model="panel.legend.min" change="legendValuesOptionChanged()"></editor-checkbox></li><li class="tight-form-item"><editor-checkbox text="Max" model="panel.legend.max" change="legendValuesOptionChanged()"></editor-checkbox></li><li class="tight-form-item"><editor-checkbox text="Avg" model="panel.legend.avg" change="legendValuesOptionChanged()"></editor-checkbox></li><li class="tight-form-item"><editor-checkbox text="Current" model="panel.legend.current" change="legendValuesOptionChanged()"></editor-checkbox></li><li class="tight-form-item last"><editor-checkbox text="Total" model="panel.legend.total" change="legendValuesOptionChanged()"></editor-checkbox></li></ul><div class="clearfix"></div></div><div class="tight-form last"><ul class="tight-form-list"><li class="tight-form-item" style="width: 105px"><strong>Decimals</strong></li><li style="width: 105px"><input type="number" class="input-small tight-form-input" placeholder="auto" bs-tooltip="\'Override automatic decimal precision for legend and tooltips\'" data-placement="right" ng-model="panel.decimals" ng-change="render()" ng-model-onblur=""></li></ul><div class="clearfix"></div></div></div></div>'),a.put("app/panels/graph/legend.popover.html",'<div class="graph-legend-popover"><a class="close" ng-click="dismiss();" href="">×</a><div class="editor-row small" style="padding-bottom: 0"><label>Axis:</label><button ng-click="toggleYAxis(series);dismiss();" class="btn btn-mini" ng-class="{\'btn-success\': series.yaxis === 1 }">Left</button> <button ng-click="toggleYAxis(series);dismiss();" class="btn btn-mini" ng-class="{\'btn-success\': series.yaxis === 2 }">Right</button></div><div class="editor-row"><i ng-repeat="color in colors" class="pointer" ng-class="{\'fa fa-circle-o\': color === series.color,\'fa fa-circle\': color !== series.color}" ng-style="{color:color}" ng-click="changeSeriesColor(series, color);dismiss();">&nbsp;</i></div></div>'),a.put("app/panels/graph/module.html",'<grafana-panel><div class="graph-wrapper" ng-class="{\'graph-legend-rightside\': panel.legend.rightSide}"><div class="graph-canvas-wrapper"><div ng-if="datapointsWarning" class="datapoints-warning"><span class="small" ng-show="!datapointsCount">No datapoints<tip>No datapoints returned from metric query</tip></span> <span class="small" ng-show="datapointsOutside">Datapoints outside time range<tip>Can be caused by timezone mismatch between browser and graphite server</tip></span></div><div grafana-graph="" class="histogram-chart"></div></div><div class="graph-legend-wrapper" ng-if="panel.legend.show" graph-legend=""></div></div><div class="clearfix"></div></grafana-panel>'),a.put("app/panels/graph/styleEditor.html",'<div class="editor-row"><div class="section"><h5>Chart Options</h5><editor-opt-bool text="Bars" model="panel.bars" change="render()"></editor-opt-bool><editor-opt-bool text="Lines" model="panel.lines" change="render()"></editor-opt-bool><editor-opt-bool text="Points" model="panel.points" change="render()"></editor-opt-bool></div><div class="section"><h5>Line options</h5><div class="editor-option" ng-show="panel.lines"><label class="small">Line Fill</label><select class="input-mini" ng-model="panel.fill" ng-options="f for f in [0,1,2,3,4,5,6,7,8,9,10]" ng-change="render()"></select></div><div class="editor-option" ng-show="panel.lines"><label class="small">Line Width</label><select class="input-mini" ng-model="panel.linewidth" ng-options="f for f in [0,1,2,3,4,5,6,7,8,9,10]" ng-change="render()"></select></div><div class="editor-option" ng-show="panel.points"><label class="small">Point Radius</label><select class="input-mini" ng-model="panel.pointradius" ng-options="f for f in [1,2,3,4,5,6,7,8,9,10]" ng-change="render()"></select></div><div class="editor-option"><label class="small">Null point mode<tip>Define how null values should be drawn</tip></label><select class="input-medium" ng-model="panel.nullPointMode" ng-options="f for f in [\'connected\', \'null\', \'null as zero\']" ng-change="render()"></select></div><editor-opt-bool text="Staircase line" model="panel.steppedLine" change="render()"></editor-opt-bool></div><div class="section"><h5>Multiple Series</h5><editor-opt-bool text="Stack" model="panel.stack" change="render()"></editor-opt-bool><editor-opt-bool text="Percent" model="panel.percentage" change="render()" tip="Stack as a percentage of total"></editor-opt-bool></div><div class="section"><h5>Rendering</h5><div class="editor-option"><label class="small">Flot<tip>client side</tip></label><input type="radio" class="input-small" ng-model="panel.renderer" value="flot" ng-change="get_data()"></div><div class="editor-option"><label class="small">Graphite PNG<tip>server side</tip></label><input type="radio" class="input-small" ng-model="panel.renderer" value="png" ng-change="get_data()"></div></div><div class="section"><h5>Tooltip</h5><editor-opt-bool text="All series" model="panel.tooltip.shared" change="render()" tip="Show all series on same tooltip and a x croshair to help follow all series"></editor-opt-bool><div class="editor-option" ng-show="panel.stack"><label class="small">Stacked Values<tip>How should the values in stacked charts to be calculated?</tip></label><select class="input-small" ng-model="panel.tooltip.value_type" ng-options="f for f in [\'cumulative\',\'individual\']" ng-change="render()"></select></div></div></div><div class="editor-row"><div class="section"><h5>Series specific overrides<tip>Regex match example: /server[0-3]/i</tip></h5><div><div class="tight-form" ng-repeat="override in panel.seriesOverrides" ng-controller="SeriesOverridesCtrl"><ul class="tight-form-list"><li class="tight-form-item"><i class="fa fa-remove pointer" ng-click="removeSeriesOverride(override)"></i></li><li class="tight-form-item">alias or regex</li><li><input type="text" ng-model="override.alias" bs-typeahead="getSeriesNames" ng-blur="render()" data-min-length="0" data-items="100" class="input-medium tight-form-input"></li><li class="tight-form-item" ng-repeat="option in currentOverrides"><i class="pointer fa fa-remove" ng-click="removeOverride(option)"></i> <span ng-show="option.propertyName === \'color\'">Color: <i class="fa fa-circle" ng-style="{color:option.value}"></i></span> <span ng-show="option.propertyName !== \'color\'">{{option.name}}: {{option.value}}</span></li><li class="dropdown" dropdown-typeahead="overrideMenu" dropdown-typeahead-on-select="setOverride($item, $subItem)"></li></ul><div class="clearfix"></div></div></div><button class="btn btn-inverse" style="margin-top: 20px" ng-click="addSeriesOverride()">Add series specific option</button></div></div>'),
a.put("app/panels/singlestat/editor.html",'<div class="editor-row"><div class="section tight-form-container" style="margin-bottom: 20px"><div class="tight-form"><ul class="tight-form-list"><li class="tight-form-item" style="width: 80px"><strong>Big value</strong></li><li class="tight-form-item">Prefix</li><li><input type="text" class="input-small tight-form-input" ng-model="panel.prefix" ng-change="render()" ng-model-onblur=""></li><li class="tight-form-item">Value</li><li><select class="input-small tight-form-input" ng-model="panel.valueName" ng-options="f for f in [\'min\',\'max\',\'avg\', \'current\', \'total\']" ng-change="render()"></select></li><li class="tight-form-item">Postfix</li><li><input type="text" class="input-small tight-form-input last" ng-model="panel.postfix" ng-change="render()" ng-model-onblur=""></li></ul><div class="clearfix"></div></div><div class="tight-form"><ul class="tight-form-list"><li class="tight-form-item" style="width: 80px"><strong>Font size</strong></li><li class="tight-form-item">Prefix</li><li><select class="input-small tight-form-input" ng-model="panel.prefixFontSize" ng-options="f for f in fontSizes" ng-change="render()"></select></li><li class="tight-form-item">Value</li><li><select class="input-small tight-form-input" ng-model="panel.valueFontSize" ng-options="f for f in fontSizes" ng-change="render()"></select></li><li class="tight-form-item">Postfix</li><li><select class="input-small tight-form-input last" ng-model="panel.postfixFontSize" ng-options="f for f in fontSizes" ng-change="render()"></select></li></ul><div class="clearfix"></div></div><div class="tight-form"><ul class="tight-form-list"><li class="tight-form-item" style="width: 80px"><strong>Unit</strong></li><li class="dropdown" style="width: 266px" ng-model="panel.format" dropdown-typeahead="unitFormats" dropdown-typeahead-on-select="setUnitFormat($subItem)"></li><li class="tight-form-item">Decimals</li><li><input type="number" class="input-small tight-form-input last" placeholder="auto" bs-tooltip="\'Override automatic decimal precision for legend and tooltips\'" data-placement="right" ng-model="panel.decimals" ng-change="render()" ng-model-onblur=""></li></ul><div class="clearfix"></div></div></div></div><div class="editor-row"><div class="section" style="margin-bottom: 20px"><div class="tight-form last"><ul class="tight-form-list"><li class="tight-form-item" style="width: 80px"><strong>Coloring</strong></li><li class="tight-form-item">Background&nbsp;<input class="cr1" id="panel.colorBackground" type="checkbox" ng-model="panel.colorBackground" ng-checked="panel.colorBackground" ng-change="render()"><label for="panel.colorBackground" class="cr1"></label></li><li class="tight-form-item">Value&nbsp;<input class="cr1" id="panel.colorValue" type="checkbox" ng-model="panel.colorValue" ng-checked="panel.colorValue" ng-change="render()"><label for="panel.colorValue" class="cr1"></label></li><li class="tight-form-item">Thresholds<tip>Comma seperated values</tip></li><li><input type="text" class="input-large tight-form-input" ng-model="panel.thresholds" ng-blur="render()" placeholder="0,50,80"></li><li class="tight-form-item">Colors</li><li class="tight-form-item"><spectrum-picker ng-model="panel.colors[0]" ng-change="render()"></spectrum-picker><spectrum-picker ng-model="panel.colors[1]" ng-change="render()"></spectrum-picker><spectrum-picker ng-model="panel.colors[2]" ng-change="render()"></spectrum-picker></li><li class="tight-form-item last"><a class="pointer" ng-click="invertColorOrder()">invert order</a></li></ul><div class="clearfix"></div></div></div></div><div class="editor-row"><div class="section" style="margin-bottom: 20px"><div class="tight-form last"><ul class="tight-form-list"><li class="tight-form-item" style="width: 80px"><strong>Spark lines</strong></li><li class="tight-form-item">Show&nbsp;<input class="cr1" id="panel.sparkline.show" type="checkbox" ng-model="panel.sparkline.show" ng-checked="panel.sparkline.show" ng-change="render()"><label for="panel.sparkline.show" class="cr1"></label></li><li class="tight-form-item">Background mode&nbsp;<input class="cr1" id="panel.sparkline.full" type="checkbox" ng-model="panel.sparkline.full" ng-checked="panel.sparkline.full" ng-change="render()"><label for="panel.sparkline.full" class="cr1"></label></li><li class="tight-form-item">Line Color</li><li class="tight-form-item"><spectrum-picker ng-model="panel.sparkline.lineColor" ng-change="render()"></spectrum-picker></li><li class="tight-form-item">Fill Color</li><li class="tight-form-item last"><spectrum-picker ng-model="panel.sparkline.fillColor" ng-change="render()"></spectrum-picker></li></ul><div class="clearfix"></div></div></div></div><div class="editor-row"><div class="section" style="margin-bottom: 20px"><div class="tight-form last"><ul class="tight-form-list"><li class="tight-form-item"><strong>Value to text mapping</strong></li><li class="tight-form-item" ng-repeat-start="map in panel.valueMaps"><i class="fa fa-remove pointer" ng-click="removeValueMap(map)"></i></li><li><input type="text" ng-model="map.value" placeholder="value" class="input-mini tight-form-input" ng-blur="render()"></li><li class="tight-form-item"><i class="fa fa-arrow-right"></i></li><li ng-repeat-end=""><input type="text" placeholder="text" ng-model="map.text" class="input-mini tight-form-input" ng-blur="render()"></li><li><a class="pointer tight-form-item last" ng-click="addValueMap();"><i class="fa fa-plus"></i></a></li></ul><div class="clearfix"></div></div></div></div>'),a.put("app/panels/singlestat/module.html",'<grafana-panel><div class="singlestat-panel" singlestat-panel=""></div><div class="clearfix"></div></grafana-panel>'),a.put("app/panels/text/editor.html","<div><div class=\"row-fluid\"><div class=\"span4\"><label class=\"small\">Mode</label><select class=\"input-medium\" ng-model=\"panel.mode\" ng-options=\"f for f in ['html','markdown','text']\"></select></div><div class=\"span2\" ng-show=\"panel.mode == 'text'\"><label class=\"small\">Font Size</label><select class=\"input-mini\" ng-model=\"panel.style['font-size']\" ng-options=\"f for f in ['6pt','7pt','8pt','10pt','12pt','14pt','16pt','18pt','20pt','24pt','28pt','32pt','36pt','42pt','48pt','52pt','60pt','72pt']\"></select></div></div><label class=\"small\">Content <span ng-show=\"panel.mode == 'markdown'\">(This area uses <a target=\"_blank\" href=\"http://en.wikipedia.org/wiki/Markdown\">Markdown</a>. HTML is not supported)</span></label><textarea ng-model=\"panel.content\" rows=\"20\" style=\"width:95%\" ng-change=\"render()\" ng-model-onblur=\"\">\n  </textarea></div>"),a.put("app/panels/text/module.html",'<grafana-panel><p ng-bind-html="content" ng-show="content"></p></grafana-panel>'),a.put("app/partials/bootstrap/tab.html",'<li ng-class="{active: active, disabled: disabled}"><a href="" ng-click="select()" tab-heading-transclude="">{{heading}}</a></li>'),a.put("app/partials/bootstrap/tabset.html",'<div><ul class="nav nav-{{type || \'tabs\'}} nav-tabs-alt" ng-class="{\'nav-stacked\': vertical, \'nav-justified\': justified}" ng-transclude=""></ul><div class="tab-content"><div class="tab-pane" ng-repeat="tab in tabs" ng-class="{active: tab.active}" tab-content-transclude="tab"></div></div></div>'),a.put("app/partials/colorpicker.html",'<div class="graph-legend-popover"><a class="close" ng-click="dismiss();" href="">×</a><div class="editor-row"><i ng-repeat="color in colors" class="pointer fa fa-circle" ng-style="{color:color}" ng-click="colorSelected(color);dismiss();">&nbsp;</i></div></div>'),a.put("app/partials/confirm_modal.html",'<div class="modal-body"><a class="modal-close" ng-click="dismiss();"><i class="fa fa-remove"></i></a><div class="confirm-modal-icon"><i class="fa {{icon}}"></i></div><div class="confirm-modal-title">{{title}}</div><div class="modal-tagline">{{text}}</div><div class="confirm-modal-buttons"><button type="button" class="btn btn-inverse" ng-click="dismiss()">{{noText}}</button> <button type="button" class="btn btn-danger" ng-click="onConfirm();dismiss();">{{yesText}}</button></div></div>'),a.put("app/partials/dashboard.html",'<div body-class="" class="dashboard"><div ng-include="" src="topNavPartial"></div><div dash-editor-view=""></div><div dash-search-view=""></div><div class="clearfix"></div><div ng-if="submenuEnabled" ng-include="\'app/partials/submenu.html\'"></div><div class="clearfix"></div><div class="main-view-container"><div class="grafana-row" ng-controller="RowCtrl" ng-repeat="(row_name, row) in dashboard.rows" row-height=""><div class="row-control"><div class="row-control-inner"><div class="row-close" ng-show="row.collapse" data-placement="bottom"><div class="row-close-buttons"><span class="row-button bgPrimary" ng-click="toggleRow(row)"><i bs-tooltip="\'Expand row\'" data-placement="right" class="fa fa-caret-left pointer"></i></span></div><div class="row-text pointer" ng-click="toggleRow(row)" ng-bind="row.title | interpolateTemplateVars:this"></div></div><div class="row-open" ng-show="!row.collapse"><div class="row-tab bgSuccess dropdown" ng-show="dashboardMeta.canEdit" ng-hide="dashboardViewState.fullscreen"><span class="row-tab-button dropdown-toggle" data-toggle="dropdown"><i class="fa fa-bars"></i></span><ul class="dropdown-menu dropdown-menu-right" role="menu" aria-labelledby="drop1"><li><a ng-click="toggleRow(row)">Collapse row</a></li><li class="dropdown-submenu"><a href="javascript:void(0);">Add Panel</a><ul class="dropdown-menu"><li bindonce="" ng-repeat="(key, value) in panels"><a ng-click="addPanelDefault(key)" bo-text="value.name"></a></li></ul></li><li class="dropdown-submenu"><a href="javascript:void(0);">Set height</a><ul class="dropdown-menu"><li><a ng-click="setHeight(\'25px\')">25 px</a></li><li><a ng-click="setHeight(\'100px\')">100 px</a></li><li><a ng-click="setHeight(\'150px\')">150 px</a></li><li><a ng-click="setHeight(\'200px\')">200 px</a></li><li><a ng-click="setHeight(\'250px\')">250 px</a></li><li><a ng-click="setHeight(\'300px\')">300 px</a></li><li><a ng-click="setHeight(\'350px\')">350 px</a></li><li><a ng-click="setHeight(\'450px\')">450 px</a></li><li><a ng-click="setHeight(\'500px\')">500 px</a></li><li><a ng-click="setHeight(\'600px\')">600 px</a></li><li><a ng-click="setHeight(\'700px\')">700 px</a></li></ul></li><li class="dropdown-submenu"><a href="javascript:void(0);">Move</a><ul class="dropdown-menu"><li><a ng-click="moveRow(\'up\')">Up</a></li><li><a ng-click="moveRow(\'down\')">Down</a></li><li><a ng-click="moveRow(\'top\')">To top</a></li><li><a ng-click="moveRow(\'bottom\')">To Bottom</a></li></ul></li><li><a dash-editor-link="app/partials/roweditor.html">Row editor</a></li><li><a ng-click="deleteRow()">Delete row</a></li></ul></div></div></div><div class="panels-wrapper" ng-if="!row.collapse"><div class="row-text pointer" ng-click="toggle_row(row)" ng-if="row.showTitle" ng-bind="row.title | interpolateTemplateVars:this"></div><div ng-repeat="(name, panel) in row.panels track by panel.id" class="panel" ui-draggable="!dashboardViewState.fullscreen" drag="panel.id" ui-on-drop="onDrop($data, row, panel)" drag-handle-class="drag-handle" panel-width=""><panel-loader type="panel.type" class="panel-margin"></panel-loader></div><div panel-drop-zone="" class="panel panel-drop-zone" ui-on-drop="onDrop($data, row)" data-drop="true"><div class="panel-container" style="background: transparent"><div style="text-align: center"><em>Drop here</em></div></div></div><div class="clearfix"></div></div></div></div><div ng-show="dashboardMeta.canEdit" class="row-fluid add-row-panel-hint" ng-hide="dashboardViewState.fullscreen"><div class="span12" style="text-align:right"><span style="margin-right: 10px" ng-click="addRowDefault()" class="pointer btn btn-info btn-small"><span><i class="fa fa-plus"></i> ADD ROW</span></span></div></div></div><div ng-include="\'app/partials/console.html\'" ng-if="consoleEnabled"></div></div>'),a.put("app/partials/edit_json.html",'<div ng-controller="JsonEditorCtrl"><div class="gf-box-header"><div class="gf-box-title"><i class="fa fa-edit"></i> JSON</div><button class="gf-box-header-close-btn" ng-click="dismiss();"><i class="fa fa-remove"></i></button></div><div class="gf-box-body" style="height: 500px"><textarea ng-model="json" rows="20" spellcheck="false" style="width: 100%"></textarea><br><br><button type="button" class="btn btn-success" ng-show="canUpdate" ng-click="update(); dismiss();">Update</button></div></div>'),a.put("app/partials/error.html",'<div class="row-fluid" style="margin-top: 100px"><div class="span2"></div><div class="grafana-info-box span8 text-center"><h3>Page not found (404)</h3></div><div class="span2"></div></div>'),a.put("app/partials/help_modal.html",'<div class="modal-body gf-box-no-margin"><div class="gf-box-header"><div class="gf-box-title"><i class="fa fa-keyboard-o"></i> Keyboard shortcuts</div><button class="gf-box-header-close-btn" ng-click="dismiss();"><i class="fa fa-remove"></i></button></div><div class="gf-box-body"><table class="shortcut-table"><tr><th></th><th style="text-align: left">Dashboard wide shortcuts</th></tr><tr><td style="text-align: right"><span class="label label-info">ESC</span></td><td>Exit fullscreen edit/view mode, close search or any editor view</td></tr><tr><td><span class="label label-info">CTRL+F</span></td><td>Open dashboard search view (also contains import/playlist controls)</td></tr><tr><td><span class="label label-info">CTRL+S</span></td><td>Save dashboard</td></tr><tr><td><span class="label label-info">CTRL+H</span></td><td>Hide row controls</td></tr><tr><td><span class="label label-info">CTRL+Z</span></td><td>Zoom out</td></tr><tr><td><span class="label label-info">CTRL+R</span></td><td>Refresh (Fetches new data and rerenders panels)</td></tr><tr><td><span class="label label-info">CTRL+O</span></td><td>Enable/Disable shared graph crosshair</td></tr></table></div></div>'),a.put("app/partials/inspector.html",'<div class="modal-body gf-box gf-box-no-margin" ng-controller="InspectCtrl" ng-init="init()"><div class="gf-box-header"><div class="gf-box-title"><i class="fa fa-eye"></i> Inspector</div><div ng-model="editor.index" bs-tabs=""><div ng-repeat="tab in [\'Request\', \'Response\', \'JS Error\']" data-title="{{tab}}"></div></div></div><div class="gf-box-body"><div ng-if="editor.index == 0"><h5>Request details</h5><table class="table table-striped small inspector-request-table"><tr><td>Url</td><td>{{inspector.error.config.url}}</td></tr><tr><td>Method</td><td>{{inspector.error.config.method}}</td></tr><tr ng-repeat="(key, value) in inspector.error.config.headers"><td>{{key}}</td><td>{{value}}</td></tr></table><h5>Request parameters</h5><table class="table table-striped small inspector-request-table"><tr ng-repeat="param in request_parameters"><td>{{param.key}}</td><td>{{param.value}}</td></tr></table></div><div ng-if="editor.index == 1"><h5 ng-show="message">{{message}}</h5><pre class="small">\n{{response}}\n			</pre></div><div ng-if="editor.index == 2"><label>Message:</label><pre>\n			{{message}}\n		</pre><label>Stack trace:</label><pre>\n			{{stack_trace}}\n		</pre></div></div></div>'),a.put("app/partials/login.html",'<div class="container"><div class="login-box"><div class="login-box-logo"><img src="img/logo_transparent_200x75.png"></div><div class="login-inner-box"><div class="login-tab-header"><button class="btn-login-tab" ng-click="loginMode = true;" ng-class="{active: loginMode}">Log in</button> <button class="btn-login-tab" ng-click="loginMode = false;" ng-class="{active: !loginMode}" ng-show="!disableUserSignUp">Sign up</button></div><form name="loginForm" class="login-form" style="margin-top: 25px"><div class="tight-form-container"><div class="tight-form" ng-if="loginMode"><ul class="tight-form-list"><li class="tight-form-item" style="width: 78px"><strong>User</strong></li><li><input type="text" name="username" class="tight-form-input last" required="" ng-model="formModel.user" placeholder="email or username" style="width: 253px"></li></ul><div class="clearfix"></div></div><div class="tight-form" ng-if="loginMode"><ul class="tight-form-list"><li class="tight-form-item" style="width: 78px"><strong>Password</strong></li><li><input type="password" name="password" class="tight-form-input last" required="" ng-model="formModel.password" id="inputPassword" style="width: 253px" placeholder="password"></li></ul><div class="clearfix"></div></div><div class="tight-form" ng-if="!loginMode"><ul class="tight-form-list"><li class="tight-form-item" style="width: 79px"><strong>Email</strong></li><li><input type="email" class="tight-form-input last" required="" ng-model="formModel.email" placeholder="email" style="width: 253px"></li></ul><div class="clearfix"></div></div></div><div class="login-submit-button-row"><button type="submit" class="btn" ng-click="submit();" ng-class="{\'btn-inverse\': !loginForm.$valid, \'btn-primary\': loginForm.$valid}">{{submitBtnText}}</button></div></form><div class="clearfix"></div><div class="login-oauth text-center"><a class="btn btn-google" href="login/google" target="_self" ng-if="googleAuthEnabled"><i class="fa fa-google"></i> with Google</a> <a class="btn btn-github" href="login/github" target="_self" ng-if="githubAuthEnabled"><i class="fa fa-github"></i> with Github</a></div></div><div class="row" style="margin-top: 40px"><div class="text-center"><a href="user/password/send-reset-email">Forgot your password?</a></div></div><div class="row" style="margin-top: 50px"><div class="version-footer text-center small">Grafana version: {{buildInfo.version}}, commit: {{buildInfo.commit}}, build date: {{buildInfo.buildstamp | date: \'yyyy-MM-dd HH:mm:ss\' }}</div></div></div></div>'),a.put("app/partials/metrics.html",'<div class="editor-row"><div class="tight-form-container"><query-editor-loader ng-repeat="target in panel.targets" ng-class="{\'tight-form-disabled\': target.hide}"></query-editor-loader></div><div style="margin: 20px 0 0 0"><button class="btn btn-inverse" ng-click="addDataQuery()" ng-hide="datasource.meta.mixed"><i class="fa fa-plus"></i>&nbsp; Query</button><div class="dropdown" ng-if="datasource.meta.mixed"><button class="btn btn-inverse dropdown-toggle" data-toggle="dropdown"><i class="fa fa-plus"></i>&nbsp; Query &nbsp; <span class="caret"></span></button><ul class="dropdown-menu" role="menu"><li ng-repeat="datasource in datasources" role="menuitem" ng-hide="datasource.meta.builtIn"><a ng-click="addDataQuery(datasource);">{{datasource.name}}</a></li></ul></div></div><datasource-editor-view datasource="panel.datasource" name="metric-query-options"></datasource-editor-view></div><div class="editor-row" style="margin-top: 30px"><div class="pull-right dropdown" style="margin-right: 10px"><button class="btn btn-inverse dropdown-toggle" data-toggle="dropdown" bs-tooltip="\'Datasource\'"><i class="fa fa-database"></i>&nbsp; {{datasource.name}} &nbsp; <span class="caret"></span></button><ul class="dropdown-menu" role="menu"><li ng-repeat="datasource in datasources" role="menuitem"><a ng-click="setDatasource(datasource);">{{datasource.name}}</a></li></ul></div><div class="clearfix"></div></div>'),a.put("app/partials/modal.html",'<div class="modal-header"><button type="button" class="close" data-dismiss="modal" aria-hidden="true">×</button><h3>{{modal.title}}</h3></div><div class="modal-body"><div ng-bind-html="modal.body"></div></div><div class="modal-footer"><button type="button" class="btn btn-danger" ng-click="dismiss()">Close</button></div>'),a.put("app/partials/panelgeneral.html",'<div class="editor-row"><div class="section"><h5>General options</h5><div class="tight-form last"><ul class="tight-form-list"><li class="tight-form-item">Title</li><li><input type="text" class="input-xlarge tight-form-input" ng-model="panel.title"></li><li class="tight-form-item">Span</li><li><select class="input-mini tight-form-input" ng-model="panel.span" ng-options="f for f in [0,1,2,3,4,5,6,7,8,9,10,11,12]"></select></li><li class="tight-form-item">Height</li><li><input type="text" class="input-small tight-form-input" ng-model="panel.height"></li><li class="tight-form-item"><label class="checkbox-label" for="panel.transparent">Transparent</label><input class="cr1" id="panel.transparent" type="checkbox" ng-model="panel.transparent" ng-checked="panel.transparent"><label for="panel.transparent" class="cr1"></label></li></ul><div class="clearfix"></div></div></div><div class="section"><h5>Templating options</h5><div class="tight-form last"><ul class="tight-form-list"><li class="tight-form-item">Repeat Panel</li><li><select class="input-small tight-form-input last" ng-model="panel.repeat" ng-options="f.name as f.name for f in dashboard.templating.list"><option value=""></option></select></li><li class="tight-form-item">Min span</li><li><select class="input-small tight-form-input last" ng-model="panel.minSpan" ng-options="f for f in [1,2,3,4,5,6,7,8,9,10,11,12]"><option value=""></option></select></li></ul><div class="clearfix"></div></div></div></div><panel-links-editor panel="panel"></panel-links-editor>'),a.put("app/partials/playlist.html",'<div ng-controller="PlaylistCtrl" ng-init="init()"><div class="gf-box-header"><div class="gf-box-title"><i class="fa fa-play"></i> Start dashboard playlist</div><button class="gf-box-header-close-btn" ng-click="dismiss();"><i class="fa fa-remove"></i></button></div><div class="gf-box-body"><div class="row-fluid" style="margin-bottom: 10px"><div class="span12"><div style="display: inline-block"><div class="tight-form last"><ul class="tight-form-list"><li class="tight-form-item">Search</li><li><input type="text" class="tight-form-input input-xlarge last" ng-model="searchQuery" placeholder="query or empty for starred" ng-change="search()"></li></ul><div class="clearfix"></div></div></div></div></div><div class="row-fluid"><div class="span6"><h5>Search result</h5><table class="grafana-options-table"><tr ng-repeat="dashboard in filteredHits"><td style="white-space: nowrap">{{dashboard.title}}</td><td style="text-align: center"><button class="btn btn-inverse btn-mini pull-right" ng-click="addDashboard(dashboard)"><i class="fa fa-plus"></i> Add to playlist</button></td></tr><tr ng-hide="searchHits.length"><td colspan="2"><i class="fa fa-warning"></i> No dashboards found</td></tr></table></div><div class="span6"><h5>Playlist dashboards</h5><table class="grafana-options-table"><tr ng-repeat="dashboard in playlist"><td style="white-space: nowrap">{{dashboard.title}}</td><td style="text-align: center"><button class="btn btn-inverse btn-mini pull-right" ng-click="removeDashboard(dashboard)"><i class="fa fa-remove"></i></button></td></tr><tr ng-hide="playlist.length"><td colspan="2">Playlist empty</td></tr></table></div></div><br><br><div class="pull-left"><div class="tight-form last"><ul class="tight-form-list"><li class="tight-form-item">Timespan between dashboard change</li><li><input type="text" class="tight-form-input input-small" ng-model="timespan"></li><li><button class="btn btn-success tight-form-btn" ng-click="start();dismiss();"><i class="fa fa-play"></i> Start</button></li></ul><div class="clearfix"></div></div></div><div class="clearfix"></div></div></div>'),a.put("app/partials/reset_password.html",'<div class="container"><div class="login-box"><div class="login-box-logo"><a href="login"><img src="img/logo_transparent_200x75.png"></a></div><div class="login-inner-box"><div class="login-tab-header"><button class="btn-login-tab" class="active">Reset password</button></div><form name="sendResetForm" class="login-form" ng-show="mode === \'send\'"><div class="tight-form last"><ul class="tight-form-list"><li class="tight-form-item" style="width: 78px"><strong>User</strong></li><li><input type="text" name="username" class="tight-form-input last" required="" ng-model="formModel.userOrEmail" placeholder="email or username" style="width: 253px"></li></ul><div class="clearfix"></div></div><div class="login-submit-button-row"><button type="submit" class="btn" ng-click="sendResetEmail();" ng-class="{\'btn-inverse\': !sendResetForm.$valid, \'btn-primary\': sendResetForm.$valid}">Send reset instructions</button></div></form><h5 ng-if="mode === \'email-sent\'" style="text-align: center; padding: 20px">An email with a reset link as been sent to the email address, you should receive it shortly.</h5><form name="resetForm" class="login-form" ng-show="mode === \'reset\'"><div class="tight-form"><ul class="tight-form-list"><li class="tight-form-item" style="width: 125px"><strong>New Password</strong></li><li><input type="password" name="NewPassword" class="tight-form-input last" required="" ng-minlength="4" ng-model="formModel.newPassword" placeholder="password" style="width: 207px" watch-change="formModel.newPassword = inputValue;"></li></ul><div class="clearfix"></div></div><div class="tight-form last"><ul class="tight-form-list"><li class="tight-form-item" style="width: 125px"><strong>Confirm Password</strong></li><li><input type="password" name="ConfirmPassword" class="tight-form-input last" required="" ng-minlength="4" ng-model="formModel.confirmPassword" placeholder="confirm password" style="width: 207px"></li></ul><div class="clearfix"></div></div><div style="margin-left: 141px; width: 207px"><password-strength password="formModel.newPassword"></password-strength></div><div class="login-submit-button-row"><button type="submit" class="btn" ng-click="submitReset();" ng-class="{\'btn-inverse\': !resetForm.$valid, \'btn-primary\': resetForm.$valid}">Reset Password</button></div></form><div class="clearfix"></div></div><div class="row" style="margin-top: 40px"><div class="text-center"><a href="login">Back to login</a></div></div></div></div>'),a.put("app/partials/roweditor.html",'<div class="gf-box-header"><div class="gf-box-title"><i class="fa fa-th-list"></i> Row settings</div><div ng-model="editor.index" bs-tabs="" style="text-transform:capitalize"><div ng-repeat="tab in [\'General\']" data-title="{{tab}}"></div></div><button class="gf-box-header-close-btn" ng-click="dismiss();"><i class="fa fa-remove"></i></button></div><div class="gf-box-body"><div class="editor-row"><div class="section"><h5>Row details</h5><div class="tight-form"><ul class="tight-form-list"><li class="tight-form-item">Title</li><li><input type="text" class="input-xlarge tight-form-input" ng-model="row.title"></li><li class="tight-form-item">Height</li><li><input type="text" class="input-small tight-form-input" ng-model="row.height"></li><li class="tight-form-item last"><label class="checkbox-label" for="row.showTitle">Show Title</label><input class="cr1" id="row.showTitle" type="checkbox" ng-model="row.showTitle" ng-checked="row.showTitle"><label for="row.showTitle" class="cr1"></label></li></ul><div class="clearfix"></div></div></div><div class="section"><h5>Templating options</h5><div class="tight-form"><ul class="tight-form-list"><li class="tight-form-item">Repeat Row</li><li><select class="input-small tight-form-input last" ng-model="row.repeat" ng-options="f.name as f.name for f in dashboard.templating.list"><option value=""></option></select></li></ul><div class="clearfix"></div></div></div></div></div>'),a.put("app/partials/search.html",'<div ng-controller="SearchCtrl" ng-init="init()" class="search-box"><div class="search-field-wrapper"><span style="position: relative"><input type="text" placeholder="Find dashboards by name" give-focus="giveSearchFocus" tabindex="1" ng-keydown="keyDown($event)" ng-model="query.query" ng-model-options="{ debounce: 500 }" spellcheck="false" ng-change="search()"></span><div class="search-switches"><i class="fa fa-filter"></i> <a class="pointer" href="javascript:void 0;" ng-click="showStarred()" tabindex="2"><i class="fa fa-remove" ng-show="query.starred"></i> starred</a> | <a class="pointer" href="javascript:void 0;" ng-click="getTags()" tabindex="3"><i class="fa fa-remove" ng-show="tagsMode"></i> tags</a> <span ng-if="query.tag.length">| <span ng-repeat="tagName in query.tag"><a ng-click="removeTag(tagName, $event)" tag-color-from-name="tagName" class="label label-tag"><i class="fa fa-remove"></i> {{tagName}}</a></span></span></div></div><div class="search-results-container" ng-if="tagsMode"><div class="row"><div class="span6 offset1"><div ng-repeat="tag in results" class="pointer" style="width: 180px; float: left" ng-class="{\'selected\': $index === selectedIndex }" ng-click="filterByTag(tag.term, $event)"><a class="search-result-tag label label-tag" tag-color-from-name="tag.term"><i class="fa fa-tag"></i> <span>{{tag.term}} &nbsp;({{tag.count}})</span></a></div></div></div></div><div class="search-results-container" ng-if="!tagsMode"><h6 ng-hide="results.length">No dashboards matching your query were found.</h6><a class="search-item pointer search-item-{{row.type}}" bindonce="" ng-repeat="row in results" ng-class="{\'selected\': $index == selectedIndex}" ng-href="{{row.url}}"><span class="search-result-tags"><span ng-click="filterByTag(tag, $event)" ng-repeat="tag in row.tags" tag-color-from-name="tag" class="label label-tag">{{tag}}</span> <i class="fa" ng-class="{\'fa-star\': row.isStarred, \'fa-star-o\': !row.isStarred}"></i></span> <span class="search-result-link"><i class="fa search-result-icon"></i> <span bo-text="row.title"></span></span></a></div><div class="search-button-row"><button class="btn btn-inverse pull-left" ng-click="newDashboard()" ng-show="contextSrv.isEditor"><i class="fa fa-plus"></i> New</button> <a class="btn btn-inverse pull-left" href="import/dashboard" ng-show="contextSrv.isEditor"><i class="fa fa-download"></i> Import</a> <button class="btn btn-inverse pull-left" dash-editor-link="app/partials/playlist.html" editor-scope="isolated" ng-click="dismiss();"><i class="fa fa-play"></i> Playlist</button><div class="clearfix"></div></div></div>'),a.put("app/partials/sidemenu.html",'<div ng-controller="SideMenuCtrl" ng-init="init()"><ul class="sidemenu sidemenu-main"><li style="margin-bottom: 15px"><a class="pointer sidemenu-top-btn" ng-click="contextSrv.toggleSideMenu()"><img class="logo-icon" src="img/fav32.png"><i class="pull-right fa fa-angle-left"></i></a></li><li class="sidemenu-system-section" ng-if="systemSection"><div class="sidemenu-system-section-inner"><i class="fa fa-fw fa-cubes"></i><div class="sidemenu-section-text-wrapper"><div class="sidemenu-section-heading">Grafana Admin</div><div class="sidemenu-section-tagline">v {{grafanaVersion}}</div></div></div></li><li ng-repeat="item in mainLinks"><a href="{{item.href}}" class="sidemenu-item" target="{{item.target}}"><span class="icon-circle sidemenu-icon"><i class="{{item.icon}}"></i></span> <span class="sidemenu-item-text">{{item.text}}</span></a></li></ul><ul class="sidemenu sidemenu-small" style="margin-top:50px" ng-if="!systemSection"><li ng-if="contextSrv.user.isSignedIn"><a href="profile" class="sidemenu-item"><img ng-src="{{contextSrv.user.gravatarUrl}}"> <span class="sidemenu-item-text">{{contextSrv.user.name}}</span></a></li><li class="dropdown"><a class="sidemenu-item pointer" data-toggle="dropdown" ng-click="loadOrgs()" tabindex="0"><span class="icon-circle sidemenu-icon"><i class="fa fa-fw fa-users"></i></span> <span class="sidemenu-item-text">{{contextSrv.user.orgName}}</span><i class="fa fa-caret-down small"></i></a><ul class="dropdown-menu" role="menu" style="left: 65px"><li ng-repeat="menuItem in orgMenu" ng-class="menuItem.cssClass"><a href="{{menuItem.href}}" ng-if="menuItem.href"><i class="{{menuItem.icon}}" ng-if="menuItem.icon"></i> {{menuItem.text}}</a> <a ng-click="menuItem.click()" ng-if="menuItem.click"><i class="{{menuItem.icon}}"></i> {{menuItem.text}}</a></li></ul></li><li ng-if="contextSrv.isGrafanaAdmin"><a href="admin/settings" class="sidemenu-item"><span class="icon-circle sidemenu-icon"><i class="fa fa-fw fa-cog"></i></span> <span class="sidemenu-item-text">Grafana admin</span></a></li><li ng-if="contextSrv.isSignedIn"><a href="logout" class="sidemenu-item" target="_self"><span class="icon-circle sidemenu-icon"><i class="fa fa-fw fa-sign-out"></i></span> <span class="sidemenu-item-text">Sign out</span></a></li><li ng-if="!contextSrv.isSignedIn"><a href="login" class="sidemenu-item" target="_self"><span class="icon-circle sidemenu-icon"><i class="fa fa-fw fa-sign-in"></i></span> <span class="sidemenu-item-text">Sign in</span></a></li></ul><ul class="sidemenu sidemenu-small" style="margin-top:50px" ng-if="systemSection"><li><a href="{{appSubUrl}}/" class="sidemenu-item"><span class="icon-circle sidemenu-icon"><i class="fa fa-fw fa-backward"></i></span> <span class="sidemenu-item-text">Exit admin</span></a></li><li><a href="logout" class="sidemenu-item" target="_self"><span class="icon-circle sidemenu-icon"><i class="fa fa-fw fa-sign-out"></i></span> <span class="sidemenu-item-text">Sign out</span></a></li></ul></div>'),
a.put("app/partials/signup_invited.html",'<div class="container"><div class="signup-page-background"></div><div class="login-box"><div class="login-box-logo"><img src="img/logo_transparent_200x75.png"></div><div class="invite-box"><h3>Hello {{greeting}}.</h3><div class="modal-tagline"><em>{{invitedBy}}</em> has invited you to join Grafana and the organization <span class="highlight-word">{{contextSrv.user.orgName}}</span>Please complete the following to accept your invitation and continue:</div><form name="inviteForm" class="login-form"><div class="tight-form-container"><div class="tight-form"><ul class="tight-form-list"><li class="tight-form-item" style="width: 128px">Email</li><li><input type="email" name="email" class="tight-form-input last" required="" ng-model="formModel.email" placeholder="Email" style="width: 253px"></li></ul><div class="clearfix"></div></div><div class="tight-form"><ul class="tight-form-list"><li class="tight-form-item" style="width: 128px">Name</li><li><input type="text" name="name" class="tight-form-input last" ng-model="formModel.name" placeholder="Name (optional)" style="width: 253px"></li></ul><div class="clearfix"></div></div><div class="tight-form"><ul class="tight-form-list"><li class="tight-form-item" style="width: 128px">Username</li><li><input type="text" name="username" class="tight-form-input last" required="" ng-model="formModel.username" placeholder="Username" style="width: 253px"></li></ul><div class="clearfix"></div></div><div class="tight-form"><ul class="tight-form-list"><li class="tight-form-item" style="width: 128px">Password</li><li><input type="password" name="password" class="tight-form-input last" required="" ng-model="formModel.password" id="inputPassword" style="width: 253px" placeholder="password"></li></ul><div class="clearfix"></div></div></div><div style="margin-left: 147px; width: 254px"><password-strength password="formModel.password"></password-strength></div><div class="login-submit-button-row"><button type="submit" class="btn" ng-click="submit();" ng-class="{\'btn-inverse\': !inviteForm.$valid, \'btn-primary\': inviteForm.$valid}">Continue</button></div></form><div class="clearfix"></div></div><div class="row" style="margin-top: 50px"><div class="version-footer text-center small">Grafana version: {{buildInfo.version}}, commit: {{buildInfo.commit}}, build date: {{buildInfo.buildstamp | date: \'yyyy-MM-dd HH:mm:ss\' }}</div></div></div></div>'),a.put("app/partials/signup_step2.html",'<div class="container"><div class="signup-page-background"></div><div class="login-box"><div class="login-box-logo"><img src="img/logo_transparent_200x75.png"></div><div class="invite-box"><h3>You\'re almost there.</h3><div class="modal-tagline">We just need a couple of more bits of<br>information to finish creating your account.</div><div style="display: inline-block; margin-top: 25px; width: 300px"><div class="editor-option"><label class="small">Your email:</label><span class="large">{{formModel.email}}</span></div></div><br><form name="signUpForm" class="login-form"><div style="display: inline-block; margin-bottom: 25px; width: 300px" ng-if="verifyEmailEnabled"><div class="editor-option"><label class="small">Email verification code: (sent to your email)</label><input type="text" class="input input-xlarge text-center" ng-model="formModel.code" required=""></div></div><div class="tight-form-container"><div class="tight-form" ng-if="!autoAssignOrg"><ul class="tight-form-list"><li class="tight-form-item" style="width: 128px">Organization name</li><li><input type="text" name="orgName" class="tight-form-input last" ng-model="formModel.orgName" placeholder="Name your organization" style="width: 253px"></li></ul><div class="clearfix"></div></div><div class="tight-form"><ul class="tight-form-list"><li class="tight-form-item" style="width: 128px">Your name</li><li><input type="text" name="name" class="tight-form-input last" ng-model="formModel.name" placeholder="(optional)" style="width: 253px"></li></ul><div class="clearfix"></div></div><div class="tight-form"><ul class="tight-form-list"><li class="tight-form-item" style="width: 128px">Username</li><li><input type="text" class="tight-form-input last" required="" ng-model="formModel.username" placeholder="Username" style="width: 253px" autocomplete="off"></li></ul><div class="clearfix"></div></div><div class="tight-form"><ul class="tight-form-list"><li class="tight-form-item" style="width: 128px">Password</li><li><input type="password" class="tight-form-input last" required="" ng-model="formModel.password" id="inputPassword" style="width: 253px" placeholder="password" autocomplete="off"></li></ul><div class="clearfix"></div></div></div><div style="margin-left: 147px; width: 254px"><password-strength password="formModel.password"></password-strength></div><div class="login-submit-button-row"><button type="submit" class="btn" ng-click="ctrl.submit();" ng-class="{\'btn-inverse\': !signUpForm.$valid, \'btn-primary\': signUpForm.$valid}">Continue</button></div></form><div class="clearfix"></div></div><div class="row" style="margin-top: 50px"><div class="version-footer text-center small">Grafana version: {{buildInfo.version}}, commit: {{buildInfo.commit}}, build date: {{buildInfo.buildstamp | date: \'yyyy-MM-dd HH:mm:ss\' }}</div></div></div></div>'),a.put("app/partials/submenu.html",'<div class="submenu-controls" ng-controller="SubmenuCtrl"><div class="tight-form borderless"><ul class="tight-form-list" ng-if="dashboard.templating.list.length > 0"><li ng-repeat="variable in variables" class="submenu-item"><span class="template-variable tight-form-item" ng-show="!variable.hideLabel" style="padding-right: 5px">{{variable.label || variable.name}}:</span><value-select-dropdown variable="variable" on-updated="variableUpdated(variable)" get-values-for-tag="getValuesForTag(variable, tagKey)"></value-select-dropdown></li></ul><ul class="tight-form-list" ng-if="dashboard.annotations.list.length > 0"><li ng-repeat="annotation in dashboard.annotations.list" class="submenu-item annotation-segment" ng-class="{\'annotation-disabled\': !annotation.enable}"><a ng-click="disableAnnotation(annotation)"><i class="fa fa-bolt"></i> {{annotation.name}}<input class="cr1" id="hideYAxis" type="checkbox" ng-model="annotation.enable" ng-checked="annotation.enable"><label for="hideYAxis" class="cr1"></label></a></li></ul><ul class="tight-form-list pull-right" ng-if="dashboard.links.length > 0"><dash-links-container links="dashboard.links"></dash-links-container></ul><div class="clearfix"></div></div></div>'),a.put("app/partials/unsaved-changes.html",'<div class="modal-body"><a class="modal-close" ng-click="dismiss();"><i class="fa fa-remove"></i></a><div class="confirm-modal-icon"><i class="fa fa-exclamation"></i></div><div class="confirm-modal-title">Unsaved changes</div><div class="confirm-modal-buttons"><button type="button" class="btn btn-inverse" ng-click="dismiss()">Cancel</button> <button type="button" class="btn btn-danger" ng-click="ignore();dismiss()">Ignore</button> <button type="button" class="btn btn-success" ng-click="save();dismiss();">Save</button></div></div>'),a.put("app/partials/valueSelectDropdown.html",'<div class="variable-link-wrapper"><a ng-click="vm.show()" class="variable-value-link tight-form-item">{{vm.linkText}} <span ng-repeat="tag in vm.selectedTags" bs-tooltip="tag.valuesText" data-placement="bottom"><span class="label-tag" tag-color-from-name="tag.text">&nbsp;&nbsp;<i class="fa fa-tag"></i>&nbsp; {{tag.text}}</span></span> <i class="fa fa-caret-down"></i></a><input type="text" class="tight-form-clear-input input-small" style="display: none" ng-keydown="vm.keyDown($event)" ng-model="vm.search.query" ng-change="vm.queryChanged()"><div class="variable-value-dropdown" ng-if="vm.dropdownVisible" ng-class="{\'multi\': vm.variable.multi, \'single\': !vm.variable.multi}"><div class="variable-options-wrapper"><div class="variable-options-column"><a class="variable-options-column-header" ng-if="vm.variable.multi" ng-class="{\'many-selected\': vm.selectedValues.length > 1}" bs-tooltip="\'Clear selections\'" data-placement="top" ng-click="vm.clearSelections()"><span class="variable-option-icon"></span> Selected ({{vm.selectedValues.length}})</a> <a class="variable-option pointer" ng-repeat="option in vm.search.options" ng-class="{\'selected\': option.selected, \'highlighted\': $index === vm.highlightIndex}" ng-click="vm.selectValue(option, $event)"><span class="variable-option-icon"></span> <span>{{option.text}}</span></a></div><div class="variable-options-column" ng-if="vm.tags.length"><div class="variable-options-column-header text-center">Tags</div><a class="variable-option-tag pointer" ng-repeat="tag in vm.tags" ng-click="vm.selectTag(tag, $event)" ng-class="{\'selected\': tag.selected}"><span class="fa fa-fw variable-option-icon"></span> <span class="label-tag" tag-color-from-name="tag.text">{{tag.text}}&nbsp;&nbsp;<i class="fa fa-tag"></i>&nbsp;</span></a></div></div></div></div>'),a.put("app/plugins/datasource/cloudwatch/partials/config.html",'<br>\n<h5>CloudWatch details</h5>\n\n<div class="tight-form last">\n  <ul class="tight-form-list">\n    <li class="tight-form-item" style="width: 160px">\n      Default Region\n    </li>\n    <li>\n      <input type="text" class="tight-form-input input-xlarge" ng-model=\'current.jsonData.defaultRegion\' placeholder="" required></input>\n    </li>\n  </ul>\n  <div class="clearfix"></div>\n</div>\n\n<!-- <div class="tight&#45;form" ng&#45;show="current.jsonData.access === \'direct\'"> -->\n<!--   <ul class="tight&#45;form&#45;list"> -->\n<!--     <li class="tight&#45;form&#45;item" style="width: 160px"> -->\n<!--     </li> -->\n<!--     <li> -->\n<!--       <input type="text" class="tight&#45;form&#45;input input&#45;xlarge" ng&#45;model=\'current.jsonData.accessKeyId\' placeholder=""></input> -->\n<!--     </li> -->\n<!--   </ul> -->\n<!--   <div class="clearfix"></div> -->\n<!-- </div> -->\n<!-- <div class="tight&#45;form" ng&#45;show="current.jsonData.access === \'direct\'"> -->\n<!--   <ul class="tight&#45;form&#45;list"> -->\n<!--     <li class="tight&#45;form&#45;item" style="width: 160px"> -->\n<!--       Access Key Id -->\n<!--     </li> -->\n<!--     <li> -->\n<!--       <input type="text" class="tight&#45;form&#45;input input&#45;xlarge" ng&#45;model=\'current.jsonData.accessKeyId\' placeholder=""></input> -->\n<!--     </li> -->\n<!--   </ul> -->\n<!--   <div class="clearfix"></div> -->\n<!-- </div> -->\n<!-- <div class="tight&#45;form" ng&#45;show="current.jsonData.access === \'direct\'"> -->\n<!--   <ul class="tight&#45;form&#45;list"> -->\n<!--     <li class="tight&#45;form&#45;item" style="width: 160px"> -->\n<!-- 			Secret Access Key -->\n<!--     </li> -->\n<!--     <li> -->\n<!-- 			<input type="password" class="tight&#45;form&#45;input input&#45;xlarge" ng&#45;model=\'current.jsonData.secretAccessKey\' placeholder=""></input> -->\n<!--     </li> -->\n<!--   </ul> -->\n<!--   <div class="clearfix"></div> -->\n<!-- </div> -->\n\n<!-- <div class="tight&#45;form last"> -->\n<!--   <ul class="tight&#45;form&#45;list"> -->\n<!--     <li class="tight&#45;form&#45;item" style="width: 160px"> -->\n<!--       Custom Metric Attributes -->\n<!--     </li> -->\n<!--     <li> -->\n<!-- 			<input type="text" class="tight&#45;form&#45;input input&#45;xlarge" -->\n<!-- 				ng&#45;model=\'current.jsonData.customMetricsAttributes[0]\' -->\n<!-- 			ng&#45;init="current.jsonData.customMetricsAttributes = current.jsonData.customMetricsAttributes || []" placeholder="JSON url" bs&#45;tooltip="\'Set JSON url of the result, \\\'aws cloudwatch list&#45;metrics &#45;&#45;output json\\\'\'"> -->\n<!-- 			</input> -->\n<!--     </li> -->\n<!--   </ul> -->\n<!--   <div class="clearfix"></div> -->\n<!-- </div> -->\n'),a.put("app/plugins/datasource/cloudwatch/partials/query.editor.html",'<div class="tight-form">\n	<ul class="tight-form-list pull-right">\n		<li class="tight-form-item">\n			<div class="dropdown">\n				<a class="pointer dropdown-toggle" data-toggle="dropdown" tabindex="1">\n					<i class="fa fa-bars"></i>\n				</a>\n				<ul class="dropdown-menu pull-right" role="menu">\n					<li role="menuitem"><a tabindex="1" ng-click="duplicateDataQuery(target)">Duplicate</a></li>\n					<li role="menuitem"><a tabindex="1" ng-click="moveDataQuery($index, $index-1)">Move up</a></li>\n					<li role="menuitem"><a tabindex="1" ng-click="moveDataQuery($index, $index+1)">Move down</a></li>\n				</ul>\n			</div>\n		</li>\n		<li class="tight-form-item last">\n			<a class="pointer" tabindex="1" ng-click="removeDataQuery(target)">\n				<i class="fa fa-remove"></i>\n			</a>\n		</li>\n	</ul>\n\n	<ul class="tight-form-list">\n		<li class="tight-form-item" style="min-width: 15px; text-align: center">\n			{{target.refId}}\n		</li>\n		<li>\n			<a  class="tight-form-item"\n				ng-click="target.hide = !target.hide; get_data();"\n				role="menuitem">\n				<i class="fa fa-eye"></i>\n			</a>\n		</li>\n	</ul>\n\n	<ul class="tight-form-list" role="menu">\n		<li class="tight-form-item query-keyword" style="width: 100px">\n			Metric\n		</li>\n		<li>\n			<metric-segment segment="regionSegment" get-options="getRegions()" on-change="regionChanged()"></metric-segment>\n		</li>\n		<li>\n			<metric-segment segment="namespaceSegment" get-options="getNamespaces()" on-change="namespaceChanged()"></metric-segment>\n		</li>\n		<li>\n			<metric-segment segment="metricSegment" get-options="getMetrics()" on-change="metricChanged()"></metric-segment>\n		</li>\n		<li class="tight-form-item query-keyword">\n			Stats\n		</li>\n		<li ng-repeat="segment in statSegments">\n			<metric-segment segment="segment" get-options="getStatSegments(segment, $index)" on-change="statSegmentChanged(segment, $index)"></metric-segment>\n		</li>\n	</ul>\n\n	<div class="clearfix"></div>\n</div>\n\n<div class="tight-form">\n	<ul class="tight-form-list" role="menu">\n		<li class="tight-form-item query-keyword tight-form-align" style="width: 100px">\n			Dimensions\n		</li>\n		<li ng-repeat="segment in dimSegments">\n			<metric-segment segment="segment" get-options="getDimSegments(segment, $index)" on-change="dimSegmentChanged(segment, $index)"></metric-segment>\n		</li>\n	</ul>\n\n	<div class="clearfix"></div>\n</div>\n\n<div class="tight-form">\n	<ul class="tight-form-list" role="menu">\n		<li class="tight-form-item query-keyword tight-form-align" style="width: 100px">\n			Alias\n			<tip>{{metric}} {{stat}} {{namespace}} {{region}} {{<dimension name>}}</tip>\n		</li>\n		<li>\n			<input type="text" class="input-xlarge tight-form-input"  ng-model="target.alias" spellcheck=\'false\' ng-model-onblur ng-change="refreshMetricData()">\n		</li>\n		<li class="tight-form-item query-keyword">\n			Period\n		</li>\n		<li>\n			<input type="text" class="input-mini tight-form-input" ng-model="target.period" spellcheck=\'false\' placeholder="period" ng-model-onblur ng-change="refreshMetricData()" />\n		</li>\n\n	</ul>\n\n	<div class="clearfix"></div>\n</div>\n\n'),a.put("app/plugins/datasource/elasticsearch/partials/annotations.editor.html",'<div class="editor-row">\n	<div class="section">\n		<h5>Index name</h5>\n		<div class="editor-option">\n			<input type="text" class="span4" ng-model=\'currentAnnotation.index\' placeholder="events-*"></input>\n		</div>\n	</div>\n	<div class="section">\n		<h5>Search query (lucene) <tip>Use [[filterName]] in query to replace part of the query with a filter value</h5>\n		<div class="editor-option">\n			<input type="text" class="span6" ng-model=\'currentAnnotation.query\' placeholder="tags:deploy"></input>\n		</div>\n	</div>\n</div>\n\n<div class="editor-row">\n  <div class="section">\n		<h5>Field mappings</h5>\n		<div class="editor-option">\n			<label class="small">Time</label>\n			<input type="text" class="input-small" ng-model=\'currentAnnotation.timeField\' placeholder="@timestamp"></input>\n		</div>\n\n		<div class="editor-option">\n			<label class="small">Title</label>\n			<input type="text" class="input-small" ng-model=\'currentAnnotation.titleField\' placeholder="desc"></input>\n		</div>\n\n		<div class="editor-option">\n			<label class="small">Tags</label>\n			<input type="text" class="input-small" ng-model=\'currentAnnotation.tagsField\' placeholder="tags"></input>\n		</div>\n\n		<div class="editor-option">\n			<label class="small">Text</label>\n			<input type="text" class="input-small" ng-model=\'currentAnnotation.textField\' placeholder=""></input>\n		</div>\n	</div>\n</div>\n'),a.put("app/plugins/datasource/elasticsearch/partials/bucketAgg.html",'<div class="tight-form">\n	<ul class="tight-form-list">\n		<li class="tight-form-item query-keyword tight-form-align" style="width: 75px;">\n			<span ng-show="isFirst">Group by</span>\n			<span ng-hide="isFirst">Then by</span>\n		</li>\n		<li>\n			<metric-segment-model property="agg.type" options="bucketAggTypes" on-change="onTypeChanged()" custom="false" css-class="tight-form-item-large"></metric-segment-model>\n		</li>\n		<li ng-if="agg.field">\n			<metric-segment-model property="agg.field" get-options="getFieldsInternal()" on-change="onChange()" css-class="tight-form-item-xxlarge"></metric-segment>\n		</li>\n		<li ng-if="!agg.field">\n			<span class="tight-form-item tight-form-item-xxlarge">&nbsp;</span>\n		</li>\n		<li class="tight-form-item last" ng-if="settingsLinkText">\n			<a ng-click="toggleOptions()">{{settingsLinkText}}</a>\n		</li>\n	</ul>\n\n	<ul class="tight-form-list pull-right">\n		<li class="tight-form-item last" ng-if="isFirst">\n			<a class="pointer" ng-click="addBucketAgg()"><i class="fa fa-plus"></i></a>\n		</li>\n		<li class="tight-form-item last" ng-if="!isLast">\n			<a class="pointer" ng-click="removeBucketAgg()"><i class="fa fa-minus"></i></a>\n		</li>\n	</ul>\n	<div class="clearfix"></div>\n</div>\n\n<div class="tight-form" ng-if="showOptions">\n	<div class="tight-form-inner-box" ng-if="agg.type === \'date_histogram\'">\n		<div class="tight-form last">\n			<ul class="tight-form-list">\n				<li class="tight-form-item" style="width: 60px">\n					Interval\n				</li>\n				<li>\n					<metric-segment-model property="agg.settings.interval" options="intervalOptions" on-change="onChangeInternal()" css-class="last" custom="true"></metric-segment-model>\n				</li>\n			</ul>\n			<div class="clearfix"></div>\n		</div>\n	</div>\n	<div class="tight-form-inner-box" ng-if="agg.type === \'terms\'">\n		<div class="tight-form">\n			<ul class="tight-form-list">\n				<li class="tight-form-item" style="width: 60px">\n					Order\n				</li>\n				<li>\n					<metric-segment-model property="agg.settings.order" options="orderOptions" on-change="onChangeInternal()" css-class="last"></metric-segment-model>\n				</li>\n			</ul>\n			<div class="clearfix"></div>\n		</div>\n		<div class="tight-form">\n			<ul class="tight-form-list">\n				<li class="tight-form-item" style="width: 60px">\n					Size\n				</li>\n				<li>\n					<metric-segment-model property="agg.settings.size" options="sizeOptions" on-change="onChangeInternal()" css-class="last"></metric-segment-model>\n				</li>\n			</ul>\n			<div class="clearfix"></div>\n		</div>\n		<div class="tight-form last">\n			<ul class="tight-form-list">\n				<li class="tight-form-item" style="width: 60px">\n					Order By\n				</li>\n				<li>\n					<metric-segment-model property="agg.settings.orderBy" options="orderByOptions" on-change="onChangeInternal()" css-class="last"></metric-segment-model>\n				</li>\n			</ul>\n			<div class="clearfix"></div>\n		</div>\n	</div>\n	<div class="tight-form-inner-box" ng-if="agg.type === \'filters\'">\n		<div class="tight-form" ng-repeat="filter in agg.settings.filters" ng-class="{last: $last}">\n			<ul class="tight-form-list">\n				<li class="tight-form-item" style="width: 100px">\n					Query {{$index + 1}}\n				</li>\n				<li>\n					<input type="text" class="tight-form-input input-large" ng-model="filter.query" spellcheck=\'false\' placeholder="Lucence query" ng-blur="onChangeInternal()">\n				</li>\n				<li class="tight-form-item last" ng-if="$first">\n					<a class="pointer" ng-click="addFiltersQuery()"><i class="fa fa-plus"></i></a>\n				</li>\n				<li class="tight-form-item last" ng-if="!$first">\n					<a class="pointer" ng-click="removeFiltersQuery(filter)"><i class="fa fa-minus"></i></a>\n				</li>\n			</ul>\n			<div class="clearfix"></div>\n		</div>\n\n	</div>\n\n</div>\n\n\n'),a.put("app/plugins/datasource/elasticsearch/partials/config.html",'<div ng-include="httpConfigPartialSrc"></div>\n<br>\n\n<h5>Elastic search details</h5>\n\n<div class="tight-form">\n	<ul class="tight-form-list">\n		<li class="tight-form-item" style="width: 144px">\n			Index name\n		</li>\n		<li>\n			<input type="text" class="tight-form-input input-xlarge" ng-model=\'current.database\' placeholder="" required></input>\n		</li>\n		<li class="tight-form-item">\n			Pattern\n		</li>\n		<li>\n			<select class="input-medium tight-form-input" ng-model="current.jsonData.interval" ng-options="f.value as f.name for f in indexPatternTypes" ng-change="indexPatternTypeChanged()" ></select>\n		</li>\n	</ul>\n	<div class="clearfix"></div>\n</div>\n<div class="tight-form last">\n	<ul class="tight-form-list">\n		<li class="tight-form-item" style="width: 144px">\n			Time field name\n		</li>\n		<li>\n			<input type="text" class="tight-form-input input-xlarge" ng-model=\'current.jsonData.timeField\' placeholder="" required ng-init="current.jsonData.timeField = current.jsonData.timeField || \'@timestamp\'"></input>\n		</li>\n	</ul>\n	<div class="clearfix"></div>\n</div>\n'),a.put("app/plugins/datasource/elasticsearch/partials/metricAgg.html",'<div class="tight-form">\n	<ul class="tight-form-list">\n		<li class="tight-form-item query-keyword tight-form-align" style="width: 75px;">\n			Metric\n		</li>\n		<li>\n			<metric-segment-model property="agg.type" options="metricAggTypes" on-change="onTypeChange()" custom="false" css-class="tight-form-item-large"></metric-segment-model>\n		</li>\n		<li ng-if="agg.type !== \'count\'">\n			<metric-segment-model property="agg.field" get-options="getFieldsInternal()" on-change="onChange()" css-class="tight-form-item-xxlarge"></metric-segment>\n		</li>\n		<li class="tight-form-item last" ng-if="settingsLinkText">\n			<a ng-click="toggleOptions()">{{settingsLinkText}}</a>\n		</li>\n	</ul>\n\n	<ul class="tight-form-list pull-right">\n		<li class="tight-form-item last" ng-if="isFirst">\n			<a class="pointer" ng-click="addMetricAgg()"><i class="fa fa-plus"></i></a>\n		</li>\n		<li class="tight-form-item last" ng-if="!isSingle">\n			<a class="pointer" ng-click="removeMetricAgg()"><i class="fa fa-minus"></i></a>\n		</li>\n	</ul>\n	<div class="clearfix"></div>\n</div>\n\n<div class="tight-form" ng-if="showOptions">\n	<div class="tight-form-inner-box">\n		<div class="tight-form last" ng-if="agg.type === \'percentiles\'">\n			<ul class="tight-form-list">\n				<li class="tight-form-item">\n					Percentiles\n				</li>\n				<li>\n					<input type="text" class="input-xlarge tight-form-input last" ng-model="agg.settings.percents" array-join ng-blur="onChange()"></input>\n				</li>\n			</ul>\n			<div class="clearfix"></div>\n		</div>\n		<div ng-if="agg.type === \'extended_stats\'">\n			<div class="tight-form" ng-repeat="stat in extendedStats">\n				<ul class="tight-form-list">\n					<li class="tight-form-item" style="width: 100px">\n						{{stat.text}}\n					</li>\n					<li class="tight-form-item last">\n						<editor-checkbox text="" model="agg.meta.{{stat.value}}" change="onChange()"></editor-checkbox>\n					</li>\n				</ul>\n				<div class="clearfix"></div>\n			</div>\n		</div>\n		<div class="tight-form last" ng-if="agg.type === \'extended_stats\'">\n			<ul class="tight-form-list">\n				<li class="tight-form-item" style="width: 100px">\n					Sigma\n				</li>\n				<li>\n					<input type="number" class="input-mini tight-form-input last" placeholder="3" ng-model="agg.settings.sigma" ng-blur="onChange()"></input>\n				</li>\n			</ul>\n			<div class="clearfix"></div>\n		</div>\n	</div>\n</div>\n'),a.put("app/plugins/datasource/elasticsearch/partials/query.editor.html",'<div  class="tight-form">\n	<ul class="tight-form-list pull-right">\n		<li ng-show="parserError" class="tight-form-item">\n			<a bs-tooltip="parserError" style="color: rgb(229, 189, 28)" role="menuitem">\n				<i class="fa fa-warning"></i>\n			</a>\n		</li>\n		<li class="tight-form-item small" ng-show="target.datasource">\n			<em>{{target.datasource}}</em>\n		</li>\n		<li class="tight-form-item">\n			<div class="dropdown">\n				<a  class="pointer dropdown-toggle" data-toggle="dropdown" tabindex="1">\n					<i class="fa fa-bars"></i>\n				</a>\n				<ul class="dropdown-menu pull-right" role="menu">\n					<li role="menuitem"><a tabindex="1" ng-click="toggleQueryMode()">Switch editor mode</a></li>\n					<li role="menuitem"><a tabindex="1" ng-click="duplicateDataQuery(target)">Duplicate</a></li>\n					<li role="menuitem"><a tabindex="1" ng-click="moveDataQuery($index, $index-1)">Move up</a></li>\n					<li role="menuitem"><a tabindex="1" ng-click="moveDataQuery($index, $index+1)">Move down</a></li>\n				</ul>\n			</div>\n		</li>\n\n		<li class="tight-form-item last">\n			<a class="pointer" tabindex="1" ng-click="removeDataQuery(target)">\n				<i class="fa fa-remove"></i>\n			</a>\n		</li>\n	</ul>\n\n	<ul class="tight-form-list">\n		<li class="tight-form-item" style="min-width: 15px; text-align: center">\n			{{target.refId}}\n		</li>\n		<li>\n			<a class="tight-form-item" ng-click="target.hide = !target.hide; get_data();" role="menuitem">\n				<i class="fa fa-eye"></i>\n			</a>\n		</li>\n	</ul>\n\n	<ul class="tight-form-list">\n		<li class="tight-form-item query-keyword" style="width: 75px">\n			Query\n		</li>\n		<li>\n			<input type="text" class="tight-form-input" style="width: 345px;" ng-model="target.query" spellcheck=\'false\' placeholder="Lucence query" ng-blur="get_data()">\n		</li>\n		<li class="tight-form-item query-keyword">\n			Alias\n		</li>\n		<li>\n			<input type="text" class="tight-form-input" style="width: 260px;" ng-model="target.alias" spellcheck=\'false\' placeholder="alias patterns (empty = auto)" ng-blur="get_data()">\n		</li>\n	</ul>\n	<div class="clearfix"></div>\n\n	<div style="padding: 10px" ng-if="target.rawQuery">\n		<textarea ng-model="target.rawQuery" rows="8" spellcheck="false" style="width: 100%; box-sizing: border-box;" ng-blur="queryUpdated()"></textarea>\n	</div>\n</div>\n\n<div ng-hide="target.rawQuery">\n	<div ng-repeat="agg in target.metrics">\n		<elastic-metric-agg\n			target="target" index="$index"\n			get-fields="getFields($fieldType)"\n			on-change="queryUpdated()">\n		</elastic-metric-agg>\n	</div>\n\n	<div ng-repeat="agg in target.bucketAggs">\n		<elastic-bucket-agg\n			target="target" index="$index"\n			get-fields="getFields($fieldType)"\n			on-change="queryUpdated()">\n		</elastic-bucket-agg>\n	</div>\n\n</div>\n'),a.put("app/plugins/datasource/elasticsearch/partials/query.options.html",'<section class="grafana-metric-options">\n	<div class="tight-form">\n		<ul class="tight-form-list">\n			<li class="tight-form-item tight-form-item-icon">\n				<i class="fa fa-wrench"></i>\n			</li>\n			<li class="tight-form-item">\n				Group by time interval\n			</li>\n			<li>\n				<input type="text" class="input-medium tight-form-input" ng-model="panel.interval" ng-blur="get_data();"\n							 spellcheck=\'false\' placeholder="example: >10s">\n			</li>\n			<li class="tight-form-item">\n				<i class="fa fa-question-circle" bs-tooltip="\'Set a low limit by having a greater sign: example: >60s\'" data-placement="right"></i>\n			</li>\n		</ul>\n		<div class="clearfix"></div>\n	</div>\n	<div class="tight-form last">\n		<ul class="tight-form-list">\n			<li class="tight-form-item tight-form-item-icon">\n				<i class="fa fa-info-circle"></i>\n			</li>\n			<li class="tight-form-item">\n				<a ng-click="toggleEditorHelp(1);" bs-tooltip="\'click to show helpful info\'" data-placement="bottom">\n					alias patterns\n				</a>\n			</li>\n		</ul>\n		<div class="clearfix"></div>\n	</div>\n</section>\n\n<div class="editor-row">\n	<div class="pull-left" style="margin-top: 30px;">\n		<div class="grafana-info-box span6" ng-if="editorHelpIndex === 1">\n			<h5>Alias patterns</h5>\n			<ul ng-non-bindable>\n				<li>{{term fieldname}} = replaced with value of term group by</li>\n				<li>{{metric}} = replaced with metric name (ex. Average, Min, Max)</li>\n				<li>{{field}} = replaced with the metric field name</li>\n			</ul>\n		</div>\n	</div>\n</div>\n\n\n'),a.put("app/plugins/datasource/grafana/partials/query.editor.html",'<div class="tight-form">\n	<ul class="tight-form-list pull-right">\n		<li ng-show="parserError" class="tight-form-item">\n			<a bs-tooltip="parserError" style="color: rgb(229, 189, 28)" role="menuitem">\n				<i class="fa fa-warning"></i>\n			</a>\n		</li>\n		<li class="tight-form-item">\n			<div class="dropdown">\n				<a class="pointer dropdown-toggle" data-toggle="dropdown" tabindex="1">\n					<i class="fa fa-bars"></i>\n				</a>\n				<ul class="dropdown-menu pull-right" role="menu">\n					<li role="menuitem">\n						<a  tabindex="1"\n							ng-click="duplicate()">\n							Duplicate\n						</a>\n					</li>\n					<li role="menuitem">\n						<a  tabindex="1"\n							ng-click="moveMetricQuery($index, $index-1)">\n							Move up\n						</a>\n					</li>\n					<li role="menuitem">\n						<a  tabindex="1"\n							ng-click="moveMetricQuery($index, $index+1)">\n							Move down\n						</a>\n					</li>\n				</ul>\n			</div>\n		</li>\n		<li class="tight-form-item last">\n			<a class="pointer" tabindex="1" ng-click="removeDataQuery(target)">\n				<i class="fa fa-remove"></i>\n			</a>\n		</li>\n	</ul>\n\n	<ul class="tight-form-list">\n		<li class="tight-form-item" style="min-width: 15px; text-align: center">\n			{{target.refId}}\n		</li>\n		<li>\n			<a class="tight-form-item" ng-click="target.hide = !target.hide; get_data();" role="menuitem">\n				<i class="fa fa-eye"></i>\n			</a>\n		</li>\n		<li class="tight-form-item">\n			Test metric (fake data source)\n		</li>\n	</ul>\n	<div class="clearfix"></div>\n</div>\n'),a.put("app/plugins/datasource/graphite/partials/annotations.editor.html",'<div class="editor-row">\n	<div class="editor-option">\n		<label class="small">Graphite target expression</label>\n		<input type="text" class="span10" ng-model=\'currentAnnotation.target\' placeholder=""></input>\n	</div>\n</div>\n\n<div class="editor-row">\n	<div class="editor-option">\n		<label class="small">Graphite event tags</label>\n		<input type="text" ng-model=\'currentAnnotation.tags\' placeholder=""></input>\n	</div>\n</div>\n\n\n'),a.put("app/plugins/datasource/graphite/partials/config.html",'<div ng-include="httpConfigPartialSrc"></div>\n\n\n'),a.put("app/plugins/datasource/graphite/partials/query.editor.html",'<div class="tight-form">\n	<ul class="tight-form-list pull-right">\n		<li ng-show="parserError" class="tight-form-item">\n			<a bs-tooltip="parserError" style="color: rgb(229, 189, 28)" role="menuitem">\n				<i class="fa fa-warning"></i>\n			</a>\n		</li>\n		<li class="tight-form-item small" ng-show="target.datasource">\n			<em>{{target.datasource}}</em>\n		</li>\n		<li class="tight-form-item">\n			<div class="dropdown">\n				<a class="pointer dropdown-toggle" data-toggle="dropdown" tabindex="1">\n					<i class="fa fa-bars"></i>\n				</a>\n				<ul class="dropdown-menu pull-right" role="menu">\n					<li role="menuitem">\n						<a tabindex="1" ng-click="toggleEditorMode()">\n							Switch editor mode\n						</a>\n					</li>\n					<li role="menuitem">\n						<a tabindex="1" ng-click="duplicateDataQuery(target)">Duplicate</a>\n					</li>\n					<li role="menuitem">\n						<a tabindex="1" ng-click="moveDataQuery($index, $index-1)">Move up</a>\n					</li>\n					<li role="menuitem">\n						<a tabindex="1" ng-click="moveDataQuery($index, $index+1)">Move down</a>\n					</li>\n				</ul>\n			</div>\n		</li>\n		<li class="tight-form-item last">\n			<a class="pointer" tabindex="1" ng-click="removeDataQuery(target)">\n				<i class="fa fa-remove"></i>\n			</a>\n		</li>\n	</ul>\n\n	<ul class="tight-form-list">\n		<li class="tight-form-item" style="min-width: 15px; text-align: center">\n			{{target.refId}}\n		</li>\n		<li>\n			<a class="tight-form-item" ng-click="target.hide = !target.hide; get_data();" role="menuitem">\n				<i class="fa fa-eye"></i>\n			</a>\n		</li>\n	</ul>\n\n	<input type="text" class="tight-form-clear-input span10" ng-model="target.target" give-focus="target.textEditor" spellcheck=\'false\' ng-model-onblur ng-change="get_data()" ng-show="target.textEditor"></input>\n\n	<ul class="tight-form-list" role="menu" ng-hide="target.textEditor">\n		<li ng-repeat="segment in segments" role="menuitem">\n			<metric-segment segment="segment" get-options="getAltSegments($index)" on-change="segmentValueChanged(segment, $index)"></metric-segment>\n		</li>\n		<li ng-repeat="func in functions">\n			<span graphite-func-editor class="tight-form-item tight-form-func">\n			</span>\n		</li>\n		<li class="dropdown" graphite-add-func>\n		</li>\n	</ul>\n	<div class="clearfix"></div>\n</div>\n'),
a.put("app/plugins/datasource/graphite/partials/query.options.html",'<section class="grafana-metric-options">\n\n	<div class="tight-form">\n		<ul class="tight-form-list">\n			<li class="tight-form-item tight-form-item-icon">\n				<i class="fa fa-wrench"></i>\n			</li>\n			<li class="tight-form-item">\n				Cache timeout\n			</li>\n			<li>\n				<input type="text"\n					class="input-mini tight-form-input"\n					ng-model="panel.cacheTimeout"\n					bs-tooltip="\'Graphite parameter to override memcache default timeout (unit is seconds)\'"\n					data-placement="right"\n					spellcheck=\'false\'\n					placeholder="60"></input>\n			</li>\n			<li class="tight-form-item">\n				Max data points\n			</li>\n			<li>\n				<input type="text"\n					class="input-mini tight-form-input"\n					ng-model="panel.maxDataPoints"\n					bs-tooltip="\'Override max data points, automatically set to graph width in pixels.\'"\n					data-placement="right"\n					ng-model-onblur ng-change="get_data()"\n					spellcheck=\'false\'\n					placeholder="auto"></input>\n			</li>\n		</ul>\n		<div class="clearfix"></div>\n	</div>\n	<div class="tight-form last">\n		<ul class="tight-form-list">\n			<li class="tight-form-item tight-form-item-icon">\n				<i class="fa fa-info-circle"></i>\n			</li>\n			<li class="tight-form-item">\n				<a ng-click="toggleEditorHelp(1);" bs-tooltip="\'click to show helpful info\'" data-placement="bottom">\n					shorter legend names\n				</a>\n			</li>\n			<li class="tight-form-item">\n				<a ng-click="toggleEditorHelp(2);" bs-tooltip="\'click to show helpful info\'" data-placement="bottom">\n					series as parameters\n				</a>\n			</li>\n			<li class="tight-form-item">\n				<a ng-click="toggleEditorHelp(3)" bs-tooltip="\'click to show helpful info\'" data-placement="bottom">\n					stacking\n				</a>\n			</li>\n			<li class="tight-form-item">\n				<a ng-click="toggleEditorHelp(4)" bs-tooltip="\'click to show helpful info\'" data-placement="bottom">\n					templating\n				</a>\n			</li>\n			<li class="tight-form-item">\n				<a ng-click="toggleEditorHelp(5)" bs-tooltip="\'click to show helpful info\'" data-placement="bottom">\n					max data points\n				</a>\n			</li>\n		</ul>\n		<div class="clearfix"></div>\n	</div>\n</section>\n\n<div class="editor-row">\n	<div class="pull-left" style="margin-top: 30px;">\n\n		<div class="grafana-info-box span8" ng-if="editorHelpIndex === 1">\n			<h5>Shorter legend names</h5>\n			<ul>\n				<li>alias() function to specify a custom series name</li>\n				<li>aliasByNode(2) to alias by a specific part of your metric path</li>\n				<li>aliasByNode(2, -1) you can add multiple segment paths, and use negative index</li>\n				<li>groupByNode(2, \'sum\') is useful if you have 2 wildcards in your metric path and want to sumSeries and group by</li>\n			</ul>\n		</div>\n\n		<div class="grafana-info-box span8" ng-if="editorHelpIndex === 2">\n			<h5>Series as parameter</h5>\n			<ul>\n				<li>Some graphite functions allow you to have many series arguments</li>\n				<li>Use #[A-Z] to use a graphite query as parameter to a function</li>\n				<li>\n					Examples:\n					<ul>\n						<li>asPercent(#A, #B)</li>\n						<li>prod.srv-01.counters.count - asPercent(#A) : percentage of count in comparison with A query</li>\n						<li>prod.srv-01.counters.count - sumSeries(#A) : sum count and series A </li>\n						<li>divideSeries(#A, #B)</li>\n					</ul>\n				</li>\n				<li>If a query is added only to be used as a parameter, hide it from the graph with the eye icon</li>\n			</ul>\n		</div>\n\n		<div class="grafana-info-box span6" ng-if="editorHelpIndex === 3">\n			<h5>Stacking</h5>\n			<ul>\n				<li>You find the stacking option under Display Styles tab</li>\n				<li>When stacking is enabled make sure null point mode is set to \'null as zero\'</li>\n			</ul>\n		</div>\n\n		<div class="grafana-info-box span6" ng-if="editorHelpIndex === 4">\n			<h5>Templating</h5>\n			<ul>\n				<li>You can use a template variable in place of metric names</li>\n				<li>You can use a template variable in place of function parameters</li>\n				<li>You enable the templating feature in Dashboard settings / Feature toggles </li>\n			</ul>\n		</div>\n\n		<div class="grafana-info-box span6" ng-if="editorHelpIndex === 5">\n			<h5>Max data points</h5>\n			<ul>\n				<li>Every graphite request is issued with a maxDataPoints parameter</li>\n				<li>Graphite uses this parameter to consolidate the real number of values down to this number</li>\n				<li>If there are more real values, then by default they will be consolidated using averages</li>\n				<li>This could hide real peaks and max values in your series</li>\n				<li>You can change how point consolidation is made using the consolidateBy graphite function</li>\n				<li>Point consolidation will effect series legend values (min,max,total,current)</li>\n				<li>If you override maxDataPoint and set a high value performance can be severely effected</li>\n			</ul>\n		</div>\n	</div>\n</div>\n'),a.put("app/plugins/datasource/influxdb/partials/annotations.editor.html",'<div class="editor-row">\n	<div class="section">\n		<h5>InfluxDB Query <tip>Example: select text from events where $timeFilter</tip></h5>\n		<div class="editor-option">\n			<input type="text" class="span10" ng-model=\'currentAnnotation.query\' placeholder="select text from events where $timeFilter"></input>\n		</div>\n	</div>\n</div>\n\n<div class="editor-row">\n  <div class="section">\n		<h5>Column mappings <tip>If your influxdb query returns more than one column you need to specify the column names below. An annotation event is composed of a title, tags, and an additional text field.</tip></h5>\n		<div class="editor-option">\n			<label class="small">Title</label>\n			<input type="text" class="input-small" ng-model=\'currentAnnotation.titleColumn\' placeholder=""></input>\n		</div>\n\n		<div class="editor-option">\n			<label class="small">Tags</label>\n			<input type="text" class="input-small" ng-model=\'currentAnnotation.tagsColumn\' placeholder=""></input>\n		</div>\n\n		<div class="editor-option">\n			<label class="small">Text</label>\n			<input type="text" class="input-small" ng-model=\'currentAnnotation.textColumn\' placeholder=""></input>\n		</div>\n	</div>\n</div>\n\n'),a.put("app/plugins/datasource/influxdb/partials/config.html",'\n<div ng-include="httpConfigPartialSrc"></div>\n<br>\n\n<h5>InfluxDB Details</h5>\n\n<div class="tight-form">\n	<ul class="tight-form-list">\n		<li class="tight-form-item" style="width: 80px">\n			Database\n		</li>\n		<li>\n			<input type="text" class="tight-form-input input-large" ng-model=\'current.database\' placeholder="" required></input>\n		</li>\n	</ul>\n	<div class="clearfix"></div>\n</div>\n<div class="tight-form last">\n	<ul class="tight-form-list">\n		<li class="tight-form-item" style="width: 80px">\n			User\n		</li>\n		<li>\n			<input type="text" class="tight-form-input input-large" ng-model=\'current.user\' placeholder="" required></input>\n		</li>\n		<li class="tight-form-item">\n			Password\n		</li>\n		<li>\n			<input type="password" class="tight-form-input input-large" ng-model=\'current.password\' placeholder="" required></input>\n		</li>\n	</ul>\n	<div class="clearfix"></div>\n</div>\n\n\n'),a.put("app/plugins/datasource/influxdb/partials/query.editor.html",'<div class="tight-form-container-no-item-borders">\n	<div  class="tight-form">\n		<ul class="tight-form-list pull-right">\n			<li ng-show="parserError" class="tight-form-item">\n				<a bs-tooltip="parserError" style="color: rgb(229, 189, 28)" role="menuitem">\n					<i class="fa fa-warning"></i>\n				</a>\n			</li>\n			<li class="tight-form-item small" ng-show="target.datasource">\n				<em>{{target.datasource}}</em>\n			</li>\n			<li class="tight-form-item">\n				<div class="dropdown">\n					<a  class="pointer dropdown-toggle" data-toggle="dropdown" tabindex="1">\n						<i class="fa fa-bars"></i>\n					</a>\n					<ul class="dropdown-menu pull-right" role="menu">\n						<li role="menuitem"><a tabindex="1" ng-click="toggleQueryMode()">Switch editor mode</a></li>\n						<li role="menuitem"><a tabindex="1" ng-click="duplicateDataQuery(target)">Duplicate</a></li>\n						<li role="menuitem"><a tabindex="1" ng-click="moveDataQuery($index, $index-1)">Move up</a></li>\n						<li role="menuitem"><a tabindex="1" ng-click="moveDataQuery($index, $index+1)">Move down</a></li>\n					</ul>\n				</div>\n			</li>\n\n			<li class="tight-form-item last">\n				<a class="pointer" tabindex="1" ng-click="removeDataQuery(target)">\n					<i class="fa fa-remove"></i>\n				</a>\n			</li>\n		</ul>\n\n		<ul class="tight-form-list">\n			<li class="tight-form-item" style="min-width: 15px; text-align: center">\n				{{target.refId}}\n			</li>\n			<li>\n				<a class="tight-form-item" ng-click="target.hide = !target.hide; get_data();" role="menuitem">\n					<i class="fa fa-eye"></i>\n				</a>\n			</li>\n		</ul>\n\n		<ul class="tight-form-list" ng-hide="target.rawQuery">\n			<li class="tight-form-item query-keyword" style="width: 75px">\n				FROM\n			</li>\n			<li>\n				<metric-segment segment="measurementSegment" get-options="getMeasurements()" on-change="measurementChanged()"></metric-segment>\n			</li>\n		</ul>\n		<div class="clearfix"></div>\n\n		<div style="padding: 10px" ng-if="target.rawQuery">\n			<textarea ng-model="target.query" rows="8" spellcheck="false" style="width: 100%; box-sizing: border-box;" ng-blur="get_data()"></textarea>\n		</div>\n	</div>\n\n	<div ng-hide="target.rawQuery">\n		<div class="tight-form">\n			<ul class="tight-form-list">\n				<li class="tight-form-item query-keyword tight-form-align" style="width: 75px;">\n					WHERE\n				</li>\n				<li ng-repeat="segment in tagSegments">\n					<metric-segment segment="segment" get-options="getTagsOrValues(segment, $index)" on-change="tagSegmentUpdated(segment, $index)"></metric-segment>\n				</li>\n			</ul>\n			<div class="clearfix"></div>\n		</div>\n\n		<div class="tight-form" ng-repeat="field in target.fields">\n			<ul class="tight-form-list">\n				<li class="tight-form-item query-keyword tight-form-align" style="width: 75px;">\n					<span ng-show="$index === 0">SELECT</span>\n				</li>\n				<li>\n					<metric-segment-model property="field.func" get-options="getFunctions()" on-change="get_data()" css-class="tight-form-item-xlarge"></metric-segment>\n				</li>\n				<li>\n					<metric-segment-model property="field.name" get-options="getFields()" on-change="get_data()" css-class="tight-form-item-large"></metric-segment>\n				</li>\n				<li>\n					<input type="text" class="tight-form-clear-input text-center" style="width: 70px;" ng-model="field.mathExpr" spellcheck=\'false\' placeholder="math expr" ng-blur="get_data()">\n				</li>\n				<li class="tight-form-item query-keyword">\n					AS\n				</li>\n				<li>\n					<input type="text" class="tight-form-clear-input" style="width: 180px;" ng-model="field.asExpr" spellcheck=\'false\' placeholder="as expr" ng-blur="get_data()">\n				</li>\n			</ul>\n\n			<ul class="tight-form-list pull-right">\n				<li class="tight-form-item last" ng-show="$index === 0">\n					<a class="pointer" ng-click="addSelect()"><i class="fa fa-plus"></i></a>\n				</li>\n				<li class="tight-form-item last" ng-show="target.fields.length > 1">\n					<a class="pointer" ng-click="removeSelect($index)"><i class="fa fa-minus"></i></a>\n				</li>\n			</ul>\n			<div class="clearfix"></div>\n		</div>\n\n		<div class="tight-form" ng-repeat="groupBy in target.groupBy">\n			<ul class="tight-form-list">\n				<li class="tight-form-item query-keyword tight-form-align" style="width: 75px;">\n					<span ng-show="$index === 0">GROUP BY</span>\n				</li>\n				<li ng-if="groupBy.type === \'time\'">\n					<span class="tight-form-item">time</span>\n					<metric-segment-model property="groupBy.interval" get-options="getGroupByTimeIntervals()" on-change="get_data()">\n					</metric-segment>\n				</li>\n				<li class="dropdown" ng-if="groupBy.type === \'time\'">\n					<a class="tight-form-item pointer" data-toggle="dropdown" bs-tooltip="\'Insert missing values, important when stacking\'" data-placement="right">\n						<span ng-show="target.fill">\n							fill ({{target.fill}})\n						</span>\n						<span ng-show="!target.fill">\n							no fill\n						</span>\n					</a>\n					<ul class="dropdown-menu">\n						<li><a ng-click="setFill(\'\')">no fill</a></li>\n						<li><a ng-click="setFill(\'0\')">fill (0)</a></li>\n						<li><a ng-click="setFill(\'null\')">fill (null)</a></li>\n						<li><a ng-click="setFill(\'none\')">fill (none)</a></li>\n						<li><a ng-click="setFill(\'previous\')">fill (previous)</a></li>\n					</ul>\n				</li>\n				<li ng-if="groupBy.type === \'tag\'">\n					<metric-segment-model property="groupBy.key" get-options="getTagOptions()" on-change="get_data()"></metric-segment>\n				</li>\n			</ul>\n\n			<ul class="tight-form-list pull-right">\n				<li class="tight-form-item last" ng-show="$index === 0">\n					<a class="pointer" ng-click="addGroupBy()"><i class="fa fa-plus"></i></a>\n				</li>\n				<li class="tight-form-item last" ng-show="$index > 0">\n					<a class="pointer" ng-click="removeGroupBy($index)"><i class="fa fa-minus"></i></a>\n				</li>\n			</ul>\n			<div class="clearfix"></div>\n		</div>\n	</div>\n\n	<div class="tight-form">\n		<ul class="tight-form-list">\n			<li class="tight-form-item query-keyword tight-form-align" style="width: 75px;">\n				ALIAS BY\n			</li>\n			<li>\n				<input type="text" class="tight-form-clear-input input-xlarge" ng-model="target.alias" spellcheck=\'false\' placeholder="Naming pattern" ng-blur="get_data()">\n			</li>\n		</ul>\n		<div class="clearfix"></div>\n	</div>\n\n</div>\n'),a.put("app/plugins/datasource/influxdb/partials/query.options.html",'<section class="grafana-metric-options">\n	<div class="tight-form">\n		<ul class="tight-form-list">\n			<li class="tight-form-item tight-form-item-icon">\n				<i class="fa fa-wrench"></i>\n			</li>\n			<li class="tight-form-item">\n				 Group by time interval\n			</li>\n			<li>\n				<input type="text" class="input-medium tight-form-input" ng-model="panel.interval" ng-blur="get_data();"\n				spellcheck=\'false\' placeholder="example: >10s">\n			</li>\n			<li class="tight-form-item">\n				<i class="fa fa-question-circle" bs-tooltip="\'Set a low limit by having a greater sign: example: >60s\'" data-placement="right"></i>\n			</li>\n		</ul>\n		<div class="clearfix"></div>\n	</div>\n\n	<div class="tight-form last">\n		<ul class="tight-form-list">\n			<li class="tight-form-item tight-form-item-icon">\n				<i class="fa fa-info-circle"></i>\n			</li>\n			<li class="tight-form-item">\n				<a ng-click="toggleEditorHelp(1);" bs-tooltip="\'click to show helpful info\'" data-placement="bottom">\n					alias patterns\n				</a>\n			</li>\n			<li class="tight-form-item">\n				<a ng-click="toggleEditorHelp(2)" bs-tooltip="\'click to show helpful info\'" data-placement="bottom">\n					stacking &amp; and fill\n				</a>\n			</li>\n			<li class="tight-form-item">\n				<a ng-click="toggleEditorHelp(3)" bs-tooltip="\'click to show helpful info\'" data-placement="bottom">\n					group by time\n				</a>\n			</li>\n		</ul>\n		<div class="clearfix"></div>\n	</div>\n</section>\n\n<div class="editor-row">\n	<div class="pull-left" style="margin-top: 30px;">\n\n		<div class="grafana-info-box span6" ng-if="editorHelpIndex === 1">\n			<h5>Alias patterns</h5>\n			<ul>\n				<li>$m = replaced with measurement name</li>\n				<li>$measurement = replaced with measurement name</li>\n				<li>$1 - $9 = replaced with part of measurement name (if you seperate your measurement name with dots)</li>\n				<li>$col = replaced with column name</li>\n				<li>$tag_hostname = replaced with the value of the hostname tag</li>\n				<li>You can also use [[tag_hostname]] pattern replacement syntax</li>\n			</ul>\n		</div>\n\n		<div class="grafana-info-box span6" ng-if="editorHelpIndex === 2">\n			<h5>Stacking and fill</h5>\n			<ul>\n				<li>When stacking is enabled it important that points align</li>\n				<li>If there are missing points for one series it can cause gaps or missing bars</li>\n				<li>You must use fill(0), and select a group by time low limit</li>\n				<li>Use the group by time option below your queries and specify for example &gt;10s if your metrics are written every 10 seconds</li>\n				<li>This will insert zeros for series that are missing measurements and will make stacking work properly</li>\n			</ul>\n		</div>\n\n		<div class="grafana-info-box span6" ng-if="editorHelpIndex === 3">\n			<h5>Group by time</h5>\n			<ul>\n				<li>Group by time is important, otherwise the query could return many thousands of datapoints that will slow down Grafana</li>\n				<li>Leave the group by time field empty for each query and it will be calculated based on time range and pixel width of the graph</li>\n				<li>If you use fill(0) or fill(null) set a low limit for the auto group by time interval</li>\n				<li>The low limit can only be set in the group by time option below your queries</li>\n				<li>You set a low limit by adding a greater sign before the interval</li>\n				<li>Example: &gt;60s if you write metrics to InfluxDB every 60 seconds</li>\n			</ul>\n		</div>\n\n\n	</div>\n</div>\n\n\n'),a.put("app/plugins/datasource/influxdb_08/partials/annotations.editor.html",'<div class="editor-row">\n	<div class="section">\n		<h5>InfluxDB Query <tip>Example: select text from events where $timeFilter</tip></h5>\n		<div class="editor-option">\n			<input type="text" class="span10" ng-model=\'currentAnnotation.query\' placeholder="select text from events where $timeFilter"></input>\n		</div>\n	</div>\n</div>\n\n<div class="editor-row">\n  <div class="section">\n		<h5>Column mappings <tip>If your influxdb query returns more than one column you need to specify the column names below. An annotation event is composed of a title, tags, and an additional text field.</tip></h5>\n		<div class="editor-option">\n			<label class="small">Title</label>\n			<input type="text" class="input-small" ng-model=\'currentAnnotation.titleColumn\' placeholder=""></input>\n		</div>\n\n		<div class="editor-option">\n			<label class="small">Tags</label>\n			<input type="text" class="input-small" ng-model=\'currentAnnotation.tagsColumn\' placeholder=""></input>\n		</div>\n\n		<div class="editor-option">\n			<label class="small">Text</label>\n			<input type="text" class="input-small" ng-model=\'currentAnnotation.textColumn\' placeholder=""></input>\n		</div>\n	</div>\n</div>\n\n'),a.put("app/plugins/datasource/influxdb_08/partials/config.html",'<div ng-include="httpConfigPartialSrc"></div>\n\n<br>\n\n<h5>InfluxDB Details</h5>\n\n<div class="tight-form">\n	<ul class="tight-form-list">\n		<li class="tight-form-item" style="width: 80px">\n			Database\n		</li>\n		<li>\n			<input type="text" class="tight-form-input input-large" ng-model=\'current.database\' placeholder="" required></input>\n		</li>\n	</ul>\n	<div class="clearfix"></div>\n</div>\n<div class="tight-form last">\n	<ul class="tight-form-list">\n		<li class="tight-form-item" style="width: 80px">\n			User\n		</li>\n		<li>\n			<input type="text" class="tight-form-input input-large" ng-model=\'current.user\' placeholder="" required></input>\n		</li>\n		<li class="tight-form-item">\n			Password\n		</li>\n		<li>\n			<input type="password" class="tight-form-input input-large" ng-model=\'current.password\' placeholder="" required></input>\n		</li>\n	</ul>\n	<div class="clearfix"></div>\n</div>\n\n\n'),a.put("app/plugins/datasource/influxdb_08/partials/query.editor.html",'<div class="tight-form">\n	<ul class="tight-form-list pull-right">\n		<li class="tight-form-item small" ng-show="target.datasource">\n			<em>{{target.datasource}}</em>\n		</li>\n		<li class="tight-form-item">\n			<div class="dropdown">\n				<a class="pointer dropdown-toggle" data-toggle="dropdown" tabindex="1">\n					<i class="fa fa-bars"></i>\n				</a>\n				<ul class="dropdown-menu pull-right" role="menu">\n					<li role="menuitem"><a tabindex="1" ng-click="toggleQueryMode()">Switch editor mode</a></li>\n					<li role="menuitem"><a tabindex="1" ng-click="duplicateDataQuery(target)">Duplicate</a></li>\n					<li role="menuitem"><a tabindex="1" ng-click="moveDataQuery($index, $index-1)">Move up </a></li>\n					<li role="menuitem"><a tabindex="1" ng-click="moveDataQuery($index, $index+1)">Move down</a></li>\n				</ul>\n			</div>\n		</li>\n		<li class="tight-form-item last">\n			<a class="pointer" tabindex="1" ng-click="removeDataQuery(target)">\n				<i class="fa fa-remove"></i>\n			</a>\n		</li>\n	</ul>\n\n	<ul class="tight-form-list">\n		<li class="tight-form-item" style="min-width: 15px; text-align: center">\n			{{target.refId}}\n		</li>\n		<li>\n			<a class="tight-form-item" ng-click="target.hide = !target.hide; get_data();" role="menuitem">\n				<i class="fa fa-eye"></i>\n			</a>\n		</li>\n	</ul>\n\n	<!-- Raw Query mode  -->\n	<input type="text" class="tight-form-clear-input" style="width: 80%" ng-model="target.query"\n	placeholder="select ..." ng-show="target.rawQuery"\n	give-focus="target.rawQuery"\n	spellcheck=\'false\'\n	data-min-length=0 data-items=100\n	ng-model-onblur\n	ng-blur="get_data()"></input>\n\n	<!-- Query editor mode -->\n	<ul class="tight-form-list" role="menu" ng-hide="target.rawQuery">\n		<li class="tight-form-item">\n			series\n		</li>\n		<li>\n			<input type="text"\n			class="tight-form-input span8"\n			ng-model="target.series"\n			spellcheck=\'false\'\n			bs-typeahead="listSeries"\n			match-all="true"\n			min-length="3"\n			placeholder="series name"\n			data-min-length=0 data-items=100\n			ng-blur="seriesBlur()">\n		</li>\n\n		<li class="tight-form-item">\n			alias\n		</li>\n\n		<li>\n			<input type="text" class="input-medium tight-form-input" ng-model="target.alias"\n			spellcheck=\'false\' placeholder="alias" ng-blur="get_data()">\n		</li>\n\n	</ul>\n\n	<div class="clearfix"></div>\n</div>\n\n<div class="tight-form">\n	<!-- Raw Query mode  -->\n	<ul class="tight-form-list" ng-show="target.rawQuery">\n		<li class="tight-form-item tight-form-align">\n			alias\n		</li>\n		<li>\n			<input type="text"\n			class="input-medium tight-form-input"\n			ng-model="target.alias"\n			spellcheck=\'false\'\n			placeholder="alias"\n			ng-blur="get_data()">\n		</li>\n		<li class="tight-form-item">\n			group by time\n		</li>\n		<li>\n			<input type="text" class="input-mini tight-form-input" ng-model="target.interval"\n			spellcheck=\'false\' placeholder="{{interval}}" data-placement="right"\n			bs-tooltip="\'Leave blank for auto handling based on time range and panel width\'"\n			ng-model-onblur ng-change="get_data()" >\n		</li>\n	</ul>\n\n	<!-- Query editor mode -->\n	<ul class="tight-form-list" role="menu" ng-hide="target.rawQuery">\n		<li class="tight-form-item tight-form-align">\n			select\n		</li>\n		<li class="dropdown">\n			<span influxdb-func-editor08 class="tight-form-item tight-form-func">\n			</span>\n		</li>\n\n		<li class="tight-form-item">\n			where\n		</li>\n		<li>\n			<input type="text" class="input-medium tight-form-input" ng-model="target.condition"\n			bs-tooltip="\'Add a where clause\'" data-placement="right" spellcheck=\'false\' placeholder="column ~= value" ng-blur="get_data()">\n		</li>\n\n		<li class="tight-form-item">\n			group by time\n		</li>\n		<li>\n			<input type="text" class="input-mini tight-form-input" ng-model="target.interval"\n			spellcheck=\'false\' placeholder="{{interval}}" data-placement="right"\n			bs-tooltip="\'Leave blank for auto handling based on time range and panel width\'"\n			ng-model-onblur ng-change="get_data()" >\n		</li>\n\n		<li class="tight-form-item">\n			and\n		</li>\n\n		<li>\n			<input type="text" class="input-small tight-form-input" ng-model="target.groupby_field" bs-tooltip="\'Add a group by column or leave blank\'"\n			placeholder="column" spellcheck="false" bs-typeahead="listColumns" data-min-length=0 ng-blur="get_data()">\n		</li>\n\n		<li class="dropdown">\n			<a class="tight-form-item pointer" data-toggle="dropdown" bs-tooltip="\'Insert missing values, important when stacking\'" data-placement="right">\n				<span ng-show="target.fill">\n					fill ({{target.fill}})\n				</span>\n				<span ng-show="!target.fill">\n					no fill\n				</span>\n			</a>\n			<ul class="dropdown-menu">\n				<li><a ng-click="target.fill = \'\'">no fill</a></li>\n				<li><a ng-click="target.fill = \'null\'">fill (null)</a></li>\n				<li><a ng-click="target.fill = \'0\'">fill (0)</a></li>\n			</ul>\n		</li>\n	</ul>\n	<div class="clearfix"></div>\n</div>\n\n\n'),a.put("app/plugins/datasource/influxdb_08/partials/query.options.html",'<section class="grafana-metric-options">\n	<div class="tight-form">\n		<ul class="tight-form-list">\n			<li class="tight-form-item tight-form-item-icon">\n				<i class="fa fa-wrench"></i>\n			</li>\n			<li class="tight-form-item">\n				group by time\n			</li>\n			<li>\n				<input type="text" class="input-medium tight-form-input" ng-model="panel.interval" ng-blur="get_data();"\n				spellcheck=\'false\' placeholder="example: >10s">\n			</li>\n			<li class="tight-form-item">\n				<i class="fa fa-question-circle" bs-tooltip="\'Set a low limit by having a greater sign: example: >60s\'" data-placement="right"></i>\n			</li>\n		</ul>\n		<div class="clearfix"></div>\n	</div>\n\n	<div class="tight-form">\n		<ul class="tight-form-list">\n			<li class="tight-form-item tight-form-item-icon">\n				<i class="fa fa-info-circle"></i>\n			</li>\n			<li class="tight-form-item">\n				<a ng-click="toggleEditorHelp(1);" bs-tooltip="\'click to show helpful info\'" data-placement="bottom">\n					alias patterns\n				</a>\n			</li>\n			<li class="tight-form-item">\n				<a ng-click="toggleEditorHelp(2)" bs-tooltip="\'click to show helpful info\'" data-placement="bottom">\n					stacking &amp; and fill\n				</a>\n			</li>\n			<li class="tight-form-item">\n				<a ng-click="toggleEditorHelp(3)" bs-tooltip="\'click to show helpful info\'" data-placement="bottom">\n					group by time\n				</a>\n			</li>\n		</ul>\n		<div class="clearfix"></div>\n	</div>\n</section>\n\n<div class="editor-row">\n	<div class="pull-left" style="margin-top: 30px;">\n\n		<div class="grafana-info-box span6" ng-if="editorHelpIndex === 1">\n			<h5>Alias patterns</h5>\n			<ul>\n				<li>$s = series name</li>\n				<li>$g = group by</li>\n				<li>$[0-9] part of series name for series names seperated by dots.</li>\n			</ul>\n		</div>\n\n		<div class="grafana-info-box span6" ng-if="editorHelpIndex === 2">\n			<h5>Stacking and fill</h5>\n			<ul>\n				<li>When stacking is enabled it important that points align</li>\n				<li>If there are missing points for one series it can cause gaps or missing bars</li>\n				<li>You must use fill(0), and select a group by time low limit</li>\n				<li>Use the group by time option below your queries and specify for example &gt;10s if your metrics are written every 10 seconds</li>\n				<li>This will insert zeros for series that are missing measurements and will make stacking work properly</li>\n			</ul>\n		</div>\n\n		<div class="grafana-info-box span6" ng-if="editorHelpIndex === 3">\n			<h5>Group by time</h5>\n			<ul>\n				<li>Group by time is important, otherwise the query could return many thousands of datapoints that will slow down Grafana</li>\n				<li>Leave the group by time field empty for each query and it will be calculated based on time range and pixel width of the graph</li>\n				<li>If you use fill(0) or fill(null) set a low limit for the auto group by time interval</li>\n				<li>The low limit can only be set in the group by time option below your queries</li>\n				<li>You set a low limit by adding a greater sign before the interval</li>\n				<li>Example: &gt;60s if you write metrics to InfluxDB every 60 seconds</li>\n			</ul>\n		</div>\n\n\n	</div>\n</div>\n\n\n'),a.put("app/plugins/datasource/kairosdb/partials/config.html",'<div ng-include="httpConfigPartialSrc"></div>\n'),a.put("app/plugins/datasource/kairosdb/partials/query.editor.html",'<div class="tight-form">\n	<ul class="tight-form-list pull-right">\n		<li class="tight-form-item small" ng-show="target.datasource">\n			<em>{{target.datasource}}</em>\n		</li>\n		<li class="tight-form-item">\n			<div class="dropdown">\n				<a  class="pointer dropdown-toggle" data-toggle="dropdown" tabindex="1">\n					<i class="fa fa-bars"></i>\n				</a>\n				<ul class="dropdown-menu pull-right" role="menu">\n					<li role="menuitem"><a tabindex="1" ng-click="duplicateDataQuery(target)">Duplicate</a></li>\n					<li role="menuitem"><a tabindex="1" ng-click="moveDataQuery($index, $index-1)">Move up</a></li>\n					<li role="menuitem"><a tabindex="1" ng-click="moveDataQuery($index, $index+1)">Move down</a></li>\n				</ul>\n			</div>\n		</li>\n		<li class="tight-form-item last">\n			<a class="pointer" tabindex="1" ng-click="removeDataQuery(target)">\n				<i class="fa fa-remove"></i>\n			</a>\n		</li>\n	</ul>\n\n	<ul class="tight-form-list">\n		<li class="tight-form-item" style="min-width: 15px; text-align: center">\n			{{target.refId}}\n		</li>\n		<li>\n			<a class="tight-form-item" ng-click="target.hide = !target.hide; targetBlur();" role="menuitem">\n				<i class="fa fa-eye"></i>\n			</a>\n		</li>\n		<li class="tight-form-item">\n			Metric\n		</li>\n		<li>\n			<input type="text" class="input-large tight-form-input"\n			ng-model="target.metric"\n			spellcheck="false"\n			bs-typeahead="suggestMetrics"\n			placeholder="metric name"\n			data-min-length=0 data-items=100\n			ng-blur="targetBlur()">\n			<a bs-tooltip="target.errors.metric"\n				style="color: rgb(229, 189, 28)"\n				ng-show="target.errors.metric">\n				<i class="fa fa-warning"></i>\n			</a>\n		</li>\n		<li class="tight-form-item">\n			Alias\n		</li>\n		<li>\n			<input type="text" class="input-medium tight-form-input" ng-model="target.alias"\n			spellcheck=\'false\' placeholder="alias" ng-blur="targetBlur()">\n		</li>\n		<li  class="tight-form-item">\n			&nbsp;Peak filter\n			<input class="input-medium" type="checkbox" ng-model="target.exOuter" ng-change="targetBlur()">\n		</li>\n	</ul>\n\n	<div class="clearfix"></div>\n</div>\n\n<!-- TAGS -->\n<div class="tight-form">\n	<ul class="tight-form-list" role="menu">\n		<li class="tight-form-item tight-form-align">\n			Tags\n		</li>\n		<li ng-repeat="(key, value) in target.tags track by $index" class="tight-form-item">\n			{{key}}&nbsp;=&nbsp;{{value}}\n			<a ng-click="removeFilterTag(key)">\n				<i class="fa fa-remove"></i>\n			</a>\n		</li>\n\n		<li class="tight-form-item" ng-hide="addFilterTagMode">\n			<a ng-click="addFilterTag()">\n				<i class="fa fa-plus"></i>\n			</a>\n		</li>\n\n		<li ng-show="addFilterTagMode">\n			<input type="text"\n			class="input-small tight-form-input"\n			spellcheck=\'false\'\n			bs-typeahead="suggestTagKeys"\n			ng-change="validateFilterTag()"\n			data-min-length=0 data-items=100\n			ng-model="target.currentTagKey"\n			placeholder="key">\n		</li>\n		<li ng-show="addFilterTagMode">\n			<input type="text"\n			class="input-small tight-form-input"\n			spellcheck=\'false\'\n			bs-typeahead="suggestTagValues"\n			ng-change="validateFilterTag()"\n			data-min-length=0 data-items=100\n			ng-model="target.currentTagValue"\n			placeholder="value">\n			<a bs-tooltip="target.errors.tags"\n				style="color: rgb(229, 189, 28)"\n				ng-show="target.errors.tags">\n				<i class="fa fa-warning"></i>\n			</a>\n			<li class="tight-form-item" ng-show="addFilterTagMode">\n				<a ng-click="addFilterTag()">\n					<i ng-show="target.errors.tags" class="fa fa-remove"></i>\n					<i ng-hide="target.errors.tags" class="fa fa-plus-circle"></i>\n				</a>\n			</li>\n		</li>\n	</ul>\n	<div class="clearfix"></div>\n</div>\n\n<!-- GROUP BY -->\n<div class="tight-form">\n	<ul class="tight-form-list" role="menu">\n		<li class="tight-form-item tight-form-align">\n			Group By\n		</li>\n\n		<li class="tight-form-item" ng-show="target.groupByTags">\n			tags:\n		</li>\n\n		<li ng-repeat="key in target.groupByTags track by $index" class="tight-form-item">\n			{{key}}\n			<a ng-click="removeGroupByTag($index)">\n				<i class="fa fa-remove"></i>\n			</a>\n		</li>\n\n		<li class="tight-form-item" ng-show="target.groupByTags && target.nonTagGroupBys">\n			and by:\n		</li>\n\n		<li ng-repeat="groupByObject in target.nonTagGroupBys track by $index" class="tight-form-item">\n			{{_.values(groupByObject)}}\n			<a ng-click="removeNonTagGroupBy($index)">\n				<i class="fa fa-remove"></i>\n			</a>\n		</li>\n\n		<li class="tight-form-item" ng-hide="addGroupByMode">\n			<a ng-click="addGroupBy()">\n				<i class="fa fa-plus"></i>\n			</a>\n		</li>\n		<li ng-show="addGroupByMode">\n			<select class="input-small tight-form-input"\n				ng-change="changeGroupByInput()"\n				ng-model="target.currentGroupByType"\n				ng-options="f for f in [\'tag\',\'value\',\'time\']"></select>\n		</li>\n		<li ng-show="isTagGroupBy">\n			<input type="text"\n			class="input-small tight-form-input"\n			spellcheck=\'false\'\n			bs-typeahead="suggestTagKeys"\n			ng-change = "validateGroupBy()"\n			data-min-length=0 data-items=100\n			ng-model="target.groupBy.tagKey"\n			placeholder="key">\n			<a bs-tooltip="target.errors.groupBy.tagKey"\n				style="color: rgb(229, 189, 28)"\n				ng-show="target.errors.groupBy.tagKey">\n				<i class="fa fa-warning"></i>\n			</a>\n		</li>\n		<li ng-show="isValueGroupBy">\n			<input type="text"\n			class="input-mini tight-form-input"\n			spellcheck=\'false\'\n			ng-model="target.groupBy.valueRange"\n			placeholder="range"\n			bs-tooltip="\'Range on which values are considered in the same group\'"\n			ng-change = "validateGroupBy()" >\n			<a bs-tooltip="target.errors.groupBy.valueRange"\n				style="color: rgb(229, 189, 28)"\n				ng-show="target.errors.groupBy.valueRange">\n				<i class="fa fa-warning"></i>\n			</a>\n		</li>\n		<li ng-show="isTimeGroupBy">\n			<input type="text"\n			class="input-mini tight-form-input"\n			ng-model="target.groupBy.timeInterval"\n			ng-init="target.groupBy.timeInterval=\'1s\'"\n			placeholder="interval"\n			bs-tooltip="\'Duration of time groups\'"\n			spellcheck=\'false\'\n			ng-change="validateGroupBy()">\n			<a bs-tooltip="target.errors.groupBy.timeInterval"\n				style="color: rgb(229, 189, 28)"\n				ng-show="target.errors.groupBy.timeInterval">\n				<i class="fa fa-warning"></i>\n			</a>\n		</li>\n		<li ng-show="isTimeGroupBy">\n			<input type="text"\n			class="input-mini tight-form-input"\n			ng-model="target.groupBy.groupCount"\n			placeholder="Count"\n			bs-tooltip="\'Number of time groups to be formed\'"\n			spellcheck=\'false\'\n			ng-change="validateGroupBy()">\n			<a bs-tooltip="target.errors.groupBy.groupCount"\n				style="color: rgb(229, 189, 28)"\n				ng-show="target.errors.groupBy.groupCount">\n				<i class="fa fa-warning"></i>\n			</a>\n		</li>\n		<li class="tight-form-item" ng-show="addGroupByMode">\n			<a ng-click="addGroupBy()">\n				<i ng-hide="isGroupByValid" class="fa fa-remove"></i>\n				<i ng-show="isGroupByValid" class="fa fa-plus-circle"></i>\n			</a>\n		</li>\n	</ul>\n	<div class="clearfix"></div>\n</div>\n\n<!-- HORIZONTAL AGGREGATION -->\n<div class="tight-form">\n	<ul class="tight-form-list" role="menu">\n		<li class="tight-form-item tight-form-align">\n			Aggregators\n		</li>\n		<li ng-repeat="aggregatorObject in target.horizontalAggregators track by $index" class="tight-form-item">\n			{{aggregatorObject.name}}&#40;\n			<span ng-repeat="aggKey in _.keys(_.omit(aggregatorObject,\'name\'))" bs-tooltip="aggKey">\n				{{$last?aggregatorObject[aggKey]:aggregatorObject[aggKey]+","}}\n			</span>\n			&#41;\n			<a ng-click="removeHorizontalAggregator($index)">\n				<i class="fa fa-remove"></i>\n			</a>\n		</li>\n\n		<li class="tight-form-item" ng-hide="addHorizontalAggregatorMode">\n			<a ng-click="addHorizontalAggregator()">\n				<i class="fa fa-plus"></i>\n			</a>\n		</li>\n\n		<li ng-show="addHorizontalAggregatorMode">\n			<select class="input-medium tight-form-input"\n				ng-change="changeHorAggregationInput()"\n				ng-model="target.currentHorizontalAggregatorName"\n				ng-options="f for f in [\'avg\',\'dev\',\'max\',\'min\',\'rate\',\'sampler\',\'count\',\'sum\',\'least_squares\',\'percentile\',\'scale\',\'div\']"></select>\n		</li>\n\n		<!-- Different parameters -->\n		<li ng-show="hasSamplingRate" class="tight-form-item">\n			every\n		</li>\n		<li ng-show="hasSamplingRate">\n			<input type="text"\n			class="input-mini tight-form-input"\n			ng-model="target.horAggregator.samplingRate"\n			ng-init="target.horAggregator.samplingRate=\'1s\'"\n			spellcheck=\'false\'\n			ng-change="validateHorizontalAggregator()" >\n			<a bs-tooltip="target.errors.horAggregator.samplingRate"\n				style="color: rgb(229, 189, 28)"\n				ng-show="target.errors.horAggregator.samplingRate">\n				<i class="fa fa-warning"></i>\n			</a>\n		</li>\n\n		<li ng-show="hasUnit" class="tight-form-item">\n			every\n		</li>\n		<li ng-show="hasUnit">\n			<select class="input-medium tight-form-input"\n				ng-model="target.horAggregator.unit"\n				ng-init="target.horAggregator.unit=\'millisecond\'"\n				ng-options="f for f in [\'millisecond\',\'second\',\'minute\',\'hour\',\'day\',\'week\',\'month\',\'year\']"></select>\n		</li>\n\n		<li ng-show="hasFactor" class="tight-form-item">\n			by\n		</li>\n		<li ng-show="hasFactor">\n			<input type="text"\n			class="input-mini tight-form-input"\n			ng-model="target.horAggregator.factor"\n			ng-init="target.horAggregator.factor=\'1\'"\n			spellcheck=\'false\'\n			ng-change="validateHorizontalAggregator()" >\n			<a bs-tooltip="target.errors.horAggregator.factor"\n				style="color: rgb(229, 189, 28)"\n				ng-show="target.errors.horAggregator.factor">\n				<i class="fa fa-warning"></i>\n			</a>\n		</li>\n\n		<li ng-show="hasPercentile" class="tight-form-item">\n			percentile\n		</li>\n		<li ng-show="hasPercentile">\n			<input type="text"\n			class="input-mini tight-form-input"\n			ng-model="target.horAggregator.percentile"\n			ng-init="target.horAggregator.percentile=\'0.75\'"\n			spellcheck=\'false\'\n			ng-change="validateHorizontalAggregator()" >\n			<a bs-tooltip="target.errors.horAggregator.percentile"\n				style="color: rgb(229, 189, 28)"\n				ng-show="target.errors.horAggregator.percentile">\n				<i class="fa fa-warning"></i>\n			</a>\n		</li>\n\n		<li class="tight-form-item" ng-show="addHorizontalAggregatorMode">\n			<a ng-click="addHorizontalAggregator()">\n				<i ng-hide="isAggregatorValid" class="fa fa-remove"></i>\n				<i ng-show="isAggregatorValid" class="fa fa-plus-circle"></i>\n			</a>\n		</li>\n	</ul>\n	<div class="clearfix"></div>\n</div>\n\n\n'),
a.put("app/plugins/datasource/kairosdb/partials/query.options.html",'<section class="grafana-metric-options" ng-controller="KairosDBQueryCtrl">\n	<div class="tight-form">\n		<ul class="tight-form-list">\n			<li class="tight-form-item tight-form-item-icon">\n				<i class="fa fa-wrench"></i>\n			</li>\n\n			<li class="tight-form-item">\n				Downsampling with\n			</li>\n			<li>\n				<select class="input-medium tight-form-input" ng-change="panelBlur()" ng-model="panel.downsampling" ng-options="f for f in [\'(NONE)\',\'avg\', \'sum\', \'min\', \'max\', \'dev\']" ></select>\n			</li>\n\n			<!-- SAMPLING RATE -->\n			<li ng-hide="panel.downsampling==\'(NONE)\'" class="tight-form-item">\n				every\n			</li>\n			<li>\n				<input type="text"\n				ng-hide="panel.downsampling==\'(NONE)\'"\n				class="input-mini tight-form-input"\n				ng-model="panel.sampling"\n				placeholder="{{interval}}"\n				bs-tooltip="\'Leave blank for auto handling based on time range and panel width\'"\n				spellcheck=\'false\'\n				ng-blur="panelBlur()" >\n				<a bs-tooltip="target.errors.sampling"\n					style="color: rgb(229, 189, 28)"\n					ng-show="target.errors.sampling">\n					<i class="fa fa-warning"></i>\n				</a>\n			</li>\n		</ul>\n		<div class="clearfix"></div>\n	</div>\n</section>\n'),a.put("app/plugins/datasource/opentsdb/partials/config.html",'<div ng-include="httpConfigPartialSrc"></div>\n\n<br>\n\n'),a.put("app/plugins/datasource/opentsdb/partials/query.editor.html",'<div class="tight-form">\n	<ul class="tight-form-list pull-right">\n		<li class="tight-form-item small" ng-show="target.datasource">\n			<em>{{target.datasource}}</em>\n		</li>\n		<li class="tight-form-item">\n			<div class="dropdown">\n				<a class="pointer dropdown-toggle" data-toggle="dropdown" tabindex="1">\n					<i class="fa fa-bars"></i>\n				</a>\n				<ul class="dropdown-menu pull-right" role="menu">\n					<li role="menuitem"><a tabindex="1" ng-click="toggleQueryMode()">Switch editor mode</a></li>\n					<li role="menuitem"><a tabindex="1" ng-click="duplicateDataQuery(target)">Duplicate</a></li>\n					<li role="menuitem"><a tabindex="1" ng-click="moveDataQuery($index, $index-1)">Move up</a></li>\n					<li role="menuitem"><a tabindex="1" ng-click="moveDataQuery($index, $index+1)">Move down</a></li>\n				</ul>\n			</div>\n		</li>\n		<li class="tight-form-item last">\n			<a class="pointer" tabindex="1" ng-click="removeDataQuery(target)">\n				<i class="fa fa-remove"></i>\n			</a>\n		</li>\n	</ul>\n\n	<ul class="tight-form-list">\n		<li class="tight-form-item" style="min-width: 15px; text-align: center">\n			{{target.refId}}\n		</li>\n		<li>\n			<a  class="tight-form-item"\n				ng-click="target.hide = !target.hide; get_data();"\n				role="menuitem">\n				<i class="fa fa-eye"></i>\n			</a>\n		</li>\n	</ul>\n\n	<ul class="tight-form-list" role="menu">\n		<li class="tight-form-item" style="width: 86px">\n			Metric\n		</li>\n		<li>\n			<input type="text" class="input-large tight-form-input" ng-model="target.metric"\n			spellcheck=\'false\' bs-typeahead="suggestMetrics" placeholder="metric name" data-min-length=0 data-items=100\n			ng-blur="targetBlur()">\n			</input>\n			<a bs-tooltip="target.errors.metric" style="color: rgb(229, 189, 28)" ng-show="target.errors.metric">\n				<i class="fa fa-warning"></i>\n			</a>\n		</li>\n		<li class="tight-form-item">\n			Aggregator\n		</li>\n		<li>\n			<select ng-model="target.aggregator" class="tight-form-input input-small"\n				ng-options="agg for agg in aggregators"\n				ng-change="targetBlur()">\n			</select>\n			<a bs-tooltip="target.errors.aggregator" style="color: rgb(229, 189, 28)" ng-show="target.errors.aggregator">\n				<i class="fa fa-warning"></i>\n			</a>\n		</li>\n\n		<li class="tight-form-item">\n			Alias:\n			<tip>Use patterns like $tag_tagname to replace part of the alias for a tag value</tip>\n		</li>\n		<li>\n			<input type="text" class="tight-form-input input-large"\n			ng-model="target.alias"\n			spellcheck=\'false\'\n			placeholder="series alias"\n			data-min-length=0 data-items=100\n			ng-blur="targetBlur()"></input>\n		</li>\n	</ul>\n\n	<div class="clearfix"></div>\n</div>\n\n<div class="tight-form">\n	<ul class="tight-form-list" role="menu">\n		<li class="tight-form-item tight-form-align" style="width: 86px">\n			Down sample\n		</li>\n\n		<li>\n			<input type="text" class="input-large tight-form-input"\n			ng-model="target.downsampleInterval"\n			ng-model-onblur\n			ng-change="targetBlur()"\n			placeholder="interval (empty = auto)"></input>\n		</li>\n\n		<li class="tight-form-item">\n			Aggregator\n		</li>\n\n		<li>\n			<select ng-model="target.downsampleAggregator" class="tight-form-input input-small"\n				ng-options="agg for agg in aggregators"\n				ng-change="targetBlur()">\n			</select>\n		</li>\n\n		<li class="tight-form-item">\n			<editor-checkbox text="Disable downsampling" model="target.disableDownsampling" change="targetBlur()"></editor-checkbox>\n		</li>\n\n	</ul>\n	<div class="clearfix"></div>\n</div>\n\n<div class="tight-form">\n	<ul class="tight-form-list" role="menu">\n		<li class="tight-form-item tight-form-align" style="width: 86px">\n			Tags\n		</li>\n		<li ng-repeat="(key, value) in target.tags track by $index" class="tight-form-item">\n			{{key}}&nbsp;=&nbsp;{{value}}\n			<a ng-click="removeTag(key)">\n				<i class="fa fa-remove"></i>\n			</a>\n		</li>\n\n		<li class="tight-form-item" ng-hide="addTagMode">\n			<a ng-click="addTag()">\n				<i class="fa fa-plus"></i>\n			</a>\n		</li>\n\n		<li ng-show="addTagMode">\n			<input type="text" class="input-small tight-form-input" spellcheck=\'false\'\n			bs-typeahead="suggestTagKeys" data-min-length=0 data-items=100\n			ng-model="target.currentTagKey" placeholder="key"></input>\n\n			<input type="text" class="input-small tight-form-input"\n			spellcheck=\'false\' bs-typeahead="suggestTagValues"\n			data-min-length=0 data-items=100 ng-model="target.currentTagValue" placeholder="value">\n			</input>\n			<a ng-click="addTag()">\n				add tag\n			</a>\n			<a bs-tooltip="target.errors.tags"\n				style="color: rgb(229, 189, 28)"\n				ng-show="target.errors.tags">\n				<i class="fa fa-warning"></i>\n			</a>\n		</li>\n	</ul>\n	<div class="clearfix"></div>\n</div>\n\n<div class="tight-form">\n	<ul class="tight-form-list" role="menu">\n		<li class="tight-form-item tight-form-align" style="width: 86px">\n			<editor-checkbox text="Rate" model="target.shouldComputeRate" change="targetBlur()"></editor-checkbox>\n		</li>\n\n		<li class="tight-form-item" ng-hide="!target.shouldComputeRate">\n			<editor-checkbox text="Counter" model="target.isCounter" change="targetBlur()"></editor-checkbox>\n		</li>\n\n		<li class="tight-form-item" ng-hide="!target.isCounter">\n			Counter Max:\n		</li>\n\n		<li ng-hide="!target.isCounter">\n			<input type="text" class="tight-form-input input-small" ng-disabled="!target.shouldComputeRate"\n			ng-model="target.counterMax" spellcheck=\'false\'\n			placeholder="max value" ng-model-onblur\n			ng-blur="targetBlur()"></input>\n		</li>\n		<li class="tight-form-item" ng-hide="!target.isCounter">\n			Reset Value:\n		</li>\n		<li ng-hide="!target.isCounter">\n			<input type="text" class="tight-form-input input-small" ng-disabled="!target.shouldComputeRate"\n			ng-model="target.counterResetValue" spellcheck=\'false\'\n			placeholder="reset value" ng-model-onblur\n			ng-blur="targetBlur()"></input>\n		</li>\n	</ul>\n\n	<div class="clearfix"></div>\n</div>\n'),a.put("app/plugins/datasource/prometheus/partials/config.html",'<div ng-include="httpConfigPartialSrc"></div>\n\n<br>\n\n'),a.put("app/plugins/datasource/prometheus/partials/query.editor.html",'<div class="tight-form">\n  <ul class="tight-form-list pull-right">\n    <li class="tight-form-item small" ng-show="target.datasource">\n      <em>{{target.datasource}}</em>\n    </li>\n    <li class="tight-form-item">\n      <div class="dropdown">\n        <a class="pointer dropdown-toggle" data-toggle="dropdown" tabindex="1">\n          <i class="fa fa-bars"></i>\n        </a>\n        <ul class="dropdown-menu pull-right" role="menu">\n          <li role="menuitem"><a tabindex="1" ng-click="toggleQueryMode()">Switch editor mode</a></li>\n          <li role="menuitem"><a tabindex="1" ng-click="duplicateDataQuery(target)">Duplicate</a></li>\n          <li role="menuitem"><a tabindex="1" ng-click="moveDataQuery($index, $index-1)">Move up</a></li>\n          <li role="menuitem"><a tabindex="1" ng-click="moveDataQuery($index, $index+1)">Move down</a></li>\n        </ul>\n      </div>\n    </li>\n    <li class="tight-form-item last">\n      <a class="pointer" tabindex="1" ng-click="removeDataQuery(target)">\n        <i class="fa fa-remove"></i>\n      </a>\n    </li>\n  </ul>\n\n  <ul class="tight-form-list">\n    <li class="tight-form-item" style="min-width: 15px; text-align: center">\n      {{target.refId}}\n    </li>\n    <li>\n      <a  class="tight-form-item"\n          ng-click="target.hide = !target.hide; get_data();"\n          role="menuitem">\n        <i class="fa fa-eye"></i>\n      </a>\n    </li>\n  </ul>\n\n  <ul class="tight-form-list" role="menu">\n    <li class="tight-form-item" style="width: 94px">\n      Query\n    </li>\n    <li>\n      <input type="text"\n             class="input-xxlarge tight-form-input"\n             ng-model="target.expr"\n             spellcheck=\'false\'\n             placeholder="query expression"\n             data-min-length=0 data-items=100\n             ng-model-onblur\n             ng-change="refreshMetricData()">\n    </li>\n    <li class="tight-form-item">\n      Metric\n    </li>\n    <li>\n      <input type="text"\n             class="input-medium tight-form-input"\n             ng-model="target.metric"\n             spellcheck=\'false\'\n             bs-typeahead="suggestMetrics"\n             placeholder="metric name"\n             data-min-length=0 data-items=100>\n    </li>\n  </ul>\n\n  <div class="clearfix"></div>\n</div>\n\n<div class="tight-form">\n  <ul class="tight-form-list" role="menu">\n    <li class="tight-form-item tight-form-align" style="width: 94px">\n      Legend format\n    </li>\n    <li>\n      <input type="text" class="tight-form-input input-xxlarge" ng-model="target.legendFormat"\n             spellcheck=\'false\' placeholder="legend format" data-min-length=0 data-items=1000\n             ng-model-onblur ng-change="refreshMetricData()">\n      </input>\n    </li>\n  </ul>\n\n  <div class="clearfix"></div>\n</div>\n\n<div class="tight-form">\n  <ul class="tight-form-list" role="menu">\n    <li class="tight-form-item tight-form-align" style="width: 94px">\n      Step\n    </li>\n    <li>\n      <input type="text" class="input-mini tight-form-input" ng-model="target.interval"\n             bs-tooltip="\'Leave blank for auto handling based on time range and panel width\'"\n             data-placement="right"\n             spellcheck=\'false\'\n             placeholder="{{interval}}"\n             data-min-length=0 data-items=100\n             ng-model-onblur\n             ng-change="refreshMetricData()"\n             />\n      </input>\n    </li>\n\n    <li class="tight-form-item">\n      Resolution\n    </li>\n    <li>\n      <select ng-model="target.intervalFactor" class="tight-form-input input-mini"\n             ng-options="r.factor as r.label for r in resolutions"\n             ng-change="refreshMetricData()">\n      </select>\n    </li>\n    <li class="tight-form-item">\n      <a href="{{linkToPrometheus()}}" target="_blank" bs-tooltip="\'Link to Graph in Prometheus\'">\n        <i class="fa fa-share-square-o"></i>\n      </a>\n    </li>\n  </ul>\n\n  <div class="clearfix"></div>\n</div>\n'),a.put("app/plugins/datasource/sql/partials/config.html",'<h2>SQL Options</h2>\n\n<div class="tight-form">\n	<ul class="tight-form-list">\n		<li class="tight-form-item" style="width: 80px">\n			DB Type\n		</li>\n		<li>\n			<select class="input-medium tight-form-input" ng-model="current.jsonData.dbType" ng-options="f for f in [\'sqlite3\',\'mysql\',\'postgres\']"></select>\n		</li>\n		<li class="tight-form-item" style="width: 80px">\n			Host\n		</li>\n		<li>\n			<input type="text" class="tight-form-input input-medium" ng-model=\'current.jsonData.host\' placeholder="localhost:3306">\n		</li>\n		<li class="tight-form-item" ng-if="current.jsonData.dbType === \'postgres\'">\n			SSL&nbsp;\n			<input class="cr1" id="jsonData.ssl" type="checkbox" ng-model="current.jsonData.ssl" ng-checked="current.jsonData.ssl">\n			<label for="jsonData.ssl" class="cr1"></label>\n		</li>\n	</ul>\n	<div class="clearfix"></div>\n</div>\n<div class="tight-form">\n	<ul class="tight-form-list">\n		<li class="tight-form-item" style="width: 80px">\n			Database\n		</li>\n		<li>\n			<input type="text" class="tight-form-input input-medium" ng-model=\'current.database\' placeholder="">\n		</li>\n	</ul>\n	<div class="clearfix"></div>\n</div>\n<div class="tight-form">\n	<ul class="tight-form-list">\n		<li class="tight-form-item" style="width: 80px">\n			User\n		</li>\n		<li>\n			<input type="text" class="tight-form-input input-medium" ng-model=\'current.user\' placeholder="">\n		</li>\n		<li class="tight-form-item" style="width: 80px">\n			Password\n		</li>\n		<li>\n			<input type="password" class="tight-form-input input-medium" ng-model=\'current.password\' placeholder="">\n		</li>\n	</ul>\n	<div class="clearfix"></div>\n</div>\n\n'),a.put("app/plugins/datasource/sql/partials/query.editor.html",'\n<div class="fluid-row" style="margin-top: 20px">\n	<div class="span2"></div>\n	<div class="grafana-info-box span8">\n		<h5>Test graph</h5>\n\n		<p>\n		This is just a test data source that generates random walk series. If this is your only data source\n		open the left side menu and navigate to the data sources admin screen and add your data sources. You can change\n		data source using the button to the left of the <strong>Add query</strong> button.\n		</p>\n	</div>\n	<div class="span2"></div>\n\n	<div class="clearfix"></div>\n</div>\n\n')}])});