/*! grafana - v2.5.0 - 2015-10-28
 * Copyright (c) 2015 Torkel Ödegaard; Licensed Apache-2.0 */

define(["angular","lodash","moment","./query_ctrl","./directives"],function(a,b){"use strict";var c=a.module("grafana.services");c.factory("CloudWatchDatasource",["$q","backendSrv","templateSrv",function(a,c,d){function e(a){this.type="cloudwatch",this.name=a.name,this.supportMetrics=!0,this.proxyUrl=a.url,this.defaultRegion=a.jsonData.defaultRegion}function f(a,c){var e=/\{\{(.+?)\}\}/g,f=c.alias||"{{metric}}_{{stat}}",g={region:d.replace(c.region),namespace:d.replace(c.namespace),metric:d.replace(c.metricName)};return b.extend(g,c.dimensions),b.map(c.statistics,function(c){var d=b.chain(a.Datapoints).map(function(a){return[a[c],new Date(a.Timestamp).getTime()]}).sortBy(function(a){return a[1]}).value();g.stat=c;var h=f.replace(e,function(a,b){return g[b]?g[b]:b});return{target:h,datapoints:d}})}function g(a){return Math.round(a.valueOf()/1e3)}function h(a){return b.map(a,function(a,b){return{Name:d.replace(b),Value:d.replace(a)}})}return e.prototype.query=function(c){var e=g(c.range.from),i=g(c.range.to),j=[];if(b.each(c.targets,b.bind(function(a){if(!a.hide&&a.namespace&&a.metricName&&!b.isEmpty(a.statistics)){var f={};f.region=d.replace(a.region,c.scopedVars),f.namespace=d.replace(a.namespace,c.scopedVars),f.metricName=d.replace(a.metricName,c.scopedVars),f.dimensions=h(a.dimensions),f.statistics=a.statistics,f.period=parseInt(a.period,10);var g=i-e;g/f.period>=1440&&(f.period=60*Math.floor(g/1440/60)),j.push(f)}},this)),b.isEmpty(j)){var k=a.defer();return k.resolve({data:[]}),k.promise}var l=b.map(j,function(a){return this.performTimeSeriesQuery(a,e,i)},this);return a.all(l).then(function(a){var d=[];return b.each(a,function(a,b){var e=f(a,c.targets[b]);d=d.concat(e)}),{data:d}})},e.prototype.performTimeSeriesQuery=function(a,b,c){return this.awsRequest({region:a.region,action:"GetMetricStatistics",parameters:{namespace:a.namespace,metricName:a.metricName,dimensions:a.dimensions,statistics:a.statistics,startTime:b,endTime:c,period:a.period}})},e.prototype.getRegions=function(){return this.awsRequest({action:"__GetRegions"})},e.prototype.getNamespaces=function(){return this.awsRequest({action:"__GetNamespaces"})},e.prototype.getMetrics=function(a){return this.awsRequest({action:"__GetMetrics",parameters:{namespace:d.replace(a)}})},e.prototype.getDimensionKeys=function(a){return this.awsRequest({action:"__GetDimensions",parameters:{namespace:d.replace(a)}})},e.prototype.getDimensionValues=function(a,c,e,f){var g={region:d.replace(a),action:"ListMetrics",parameters:{namespace:d.replace(c),metricName:d.replace(e),dimensions:h(f)}};return this.awsRequest(g).then(function(a){return b.chain(a.Metrics).map(function(a){return b.pluck(a.Dimensions,"Value")}).flatten().uniq().sortBy(function(a){return a}).map(function(a){return{value:a,text:a}}).value()})},e.prototype.performEC2DescribeInstances=function(a,b,c){return this.awsRequest({region:a,action:"DescribeInstances",parameters:{filter:b,instanceIds:c}})},e.prototype.metricFindQuery=function(c){var e,f,g,h=function(a){return b.map(a,function(a){return{text:a}})},i=c.match(/^regions\(\)/);if(i)return this.getRegions();var j=c.match(/^namespaces\(\)/);if(j)return this.getNamespaces();var k=c.match(/^metrics\(([^\)]+?)\)/);if(k)return this.getMetrics(k[1]);var l=c.match(/^dimension_keys\(([^\)]+?)\)/);if(l)return this.getDimensionKeys(l[1]);var m=c.match(/^dimension_values\(([^,]+?),\s?([^,]+?),\s?([^,]+?)(,\s?([^)]*))?\)/);if(m){e=d.replace(m[1]),f=d.replace(m[2]),g=d.replace(m[3]);var n=d.replace(m[5]),o={};return b.isEmpty(n)||b.each(n.split(","),function(a){var b=a.split("=");if(2!==b.length)throw new Error("Invalid query format");o[b[0]]=b[1]}),this.getDimensionValues(e,f,g,o)}var p=c.match(/^ebs_volume_ids\(([^,]+?),\s?([^,]+?)\)/);if(p){e=d.replace(p[1]);var q=d.replace(p[2]),r=[q];return this.performEC2DescribeInstances(e,[],r).then(function(a){var c=b.map(a.Reservations[0].Instances[0].BlockDeviceMappings,function(a){return a.EBS.VolumeID});return h(c)})}return a.when([])},e.prototype.testDatasource=function(){var a="us-east-1",b="AWS/Billing",c="EstimatedCharges",d={};return this.getDimensionValues(a,b,c,d).then(function(){return{status:"success",message:"Data source is working",title:"Success"}})},e.prototype.awsRequest=function(a){var b={method:"POST",url:this.proxyUrl,data:a};return c.datasourceRequest(b).then(function(a){return a.data})},e.prototype.getDefaultRegion=function(){return this.defaultRegion},e}])});