/*! grafana - v2.5.0 - 2015-10-28
 * Copyright (c) 2015 Torkel Ödegaard; Licensed Apache-2.0 */

define(["angular","lodash","moment","kbn","./query_builder","./index_pattern","./elastic_response","./query_ctrl","./directives"],function(a,b,c,d,e,f,g){"use strict";var h=a.module("grafana.services");h.factory("ElasticDatasource",["$q","backendSrv","templateSrv","timeSrv",function(d,h,i,j){function k(a){this.type="elasticsearch",this.basicAuth=a.basicAuth,this.url=a.url,this.name=a.name,this.index=a.index,this.timeField=a.jsonData.timeField,this.indexPattern=new f(a.index,a.jsonData.interval),this.queryBuilder=new e({timeField:this.timeField})}return k.prototype._request=function(a,b,c){var d={url:this.url+"/"+b,method:a,data:c};return this.basicAuth&&(d.withCredentials=!0,d.headers={Authorization:this.basicAuth}),h.datasourceRequest(d)},k.prototype._get=function(a){return this._request("GET",this.indexPattern.getIndexForToday()+a).then(function(a){return a.data})},k.prototype._post=function(a,b){return this._request("POST",a,b).then(function(a){return a.data})},k.prototype.annotationQuery=function(a,d){var e={},f=a.timeField||"@timestamp",g=a.query||"*",h=a.tagsField||"tags",j=a.titleField||"desc",k=a.textField||null;e[f]={from:d.from,to:d.to};var l=i.replace(g),m={bool:{must:[{range:e}]}},n={bool:{should:[{query_string:{query:l}}]}},o={fields:[f,"_source"],query:{filtered:{query:n,filter:m}},size:1e4};return this._request("POST",a.index+"/_search",o).then(function(d){for(var e=[],g=d.data.hits.hits,i=function(a,c){if(c){for(var d=c.split("."),e=a,f=0;f<d.length;f++)if(e=e[d[f]],!e)return console.log("could not find field in annotatation: ",c),"";return b.isArray(e)&&(e=e.join(", ")),e}},l=0;l<g.length;l++){var m=g[l]._source,n=g[l].fields,o=m[f];(b.isString(n[f])||b.isNumber(n[f]))&&(o=n[f]);var p={annotation:a,time:c.utc(o).valueOf(),title:i(m,j),tags:i(m,h),text:i(m,k)};e.push(p)}return e})},k.prototype.testDatasource=function(){return this._get("/_stats").then(function(){return{status:"success",message:"Data source is working",title:"Success"}},function(a){return a.data&&a.data.error?{status:"error",message:a.data.error,title:"Error"}:{status:"error",message:a.status,title:"Error"}})},k.prototype.getQueryHeader=function(b,c){var d={search_type:"count",ignore_unavailable:!0};return d.index=this.indexPattern.getIndexList(b,c),a.toJson(d)},k.prototype.query=function(b){for(var c,d="",e=[],f=this.getQueryHeader(b.range.from,b.range.to),h=0;h<b.targets.length;h++){if(c=b.targets[h],c.hide)return;var j=a.toJson(this.queryBuilder.build(c)),k=a.toJson(c.query||"*");k=k.substr(1,k.length-2),j=j.replace("$lucene_query",k),d+=f+"\n"+j+"\n",e.push(c)}return d=d.replace(/\$interval/g,b.interval),d=d.replace(/\$timeFrom/g,b.range.from.valueOf()),d=d.replace(/\$timeTo/g,b.range.to.valueOf()),d=i.replace(d,b.scopedVars),this._post("/_msearch?search_type=count",d).then(function(a){return new g(e,a).getTimeSeries()})},k.prototype.getFields=function(a){return this._get("/_mapping").then(function(c){var d={},e={"float":"number","double":"number",integer:"number","long":"number",date:"date",string:"string"};for(var f in c){var g=c[f],h=g.mappings;if(h)for(var i in h){var j=h[i].properties;for(var k in j){var l=j[k];a.type&&e[l.type]!==a.type||l.type&&"_"!==k[0]&&(d[k]={text:k,type:l.type})}}}return b.map(d,function(a){return a})})},k.prototype.getTerms=function(c){var d=j.timeRange(),e=this.getQueryHeader(d.from,d.to),f=a.toJson(this.queryBuilder.getTermsQuery(c));return f=f.replace("$lucene_query",c.query||"*"),f=f.replace(/\$timeFrom/g,d.from.valueOf()),f=f.replace(/\$timeTo/g,d.to.valueOf()),f=e+"\n"+f+"\n",this._post("/_msearch?search_type=count",f).then(function(a){var c=a.responses[0].aggregations[1].buckets;return b.map(c,function(a){return{text:a.key,value:a.key}})})},k.prototype.metricFindQuery=function(b){return b=i.replace(b),b=a.fromJson(b),b?"fields"===b.find?this.getFields(b):"terms"===b.find?this.getTerms(b):void 0:d.when([])},k.prototype.getDashboard=function(b){return this._get("/dashboard/"+b).then(function(b){return a.fromJson(b._source.dashboard)})},k.prototype.searchDashboards=function(){var a={query:{query_string:{query:"*"}},size:1e4,sort:["_uid"]};return this._post(this.index+"/dashboard/_search",a).then(function(a){if(b.isUndefined(a.hits))return{dashboards:[],tags:[]};for(var c=a.hits.hits,d={dashboards:[]},e=0,f=c.length;f>e;e++){var g=c[e];d.dashboards.push({id:g._id,title:g._source.title,tags:g._source.tags})}return d})},k}])});